/* A Bison parser, made by GNU Bison 2.5.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 268 of yacc.c  */
#line 1 "parser.y"


/* Copyright 2009-2023
 * Kaz Kylheku <kaz@kylheku.com>
 * Vancouver, Canada
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#include <stddef.h>
#include <stdio.h>
#include <assert.h>
#include <limits.h>
#include <stdlib.h>
#include <wchar.h>
#include <signal.h>
#include "config.h"
#include "alloca.h"
#include "lib.h"
#include "signal.h"
#include "unwind.h"
#include "regex.h"
#include "match.h"
#include "filter.h"
#include "hash.h"
#include "struct.h"
#include "eval.h"
#include "tree.h"
#include "y.tab.h"
#include "debug.h"
#include "txr.h"
#include "itypes.h"
#include "buf.h"
#include "parser.h"

static void set_syntax_tree(parser_t *parser, val tree);
static val sym_helper(parser_t *parser, wchar_t *lexeme, val meta_allowed);
static val repeat_rep_helper(val sym, val args, val main, val parts);
static void process_catch_exprs(val exprs);
static val define_transform(parser_t *parser, val define_form);
static val optimize_text(val text_form);
static val rlrec(parser_t *, val form, val line);
static val rlcp_parser(parser_t *parser, val to, val from);
static wchar_t char_from_name(const wchar_t *name);
static val make_expr(parser_t *, val sym, val rest, val lineno);
static val check_parse_time_action(val spec_rev);
static val uref_helper(parser_t *, val expr);
static val uoref_helper(parser_t *, val expr);
static val qref_helper(parser_t *, val lexpr, val rexpr);
static val fname_helper(parser_t *, val name);
static val output_helper(parser_t *, val sym, val exprs, val clauses);

#if YYBISON
union YYSTYPE;
int yylex(union YYSTYPE *, yyscan_t scanner);
int yyparse(scanner_t *, parser_t *);
#endif

#define rl(form, line) rlrec(parser, form, line)
#define rlc(to, from) rlcp_parser(parser, to, from)
#define mkexp(sym, rest, lineno) make_expr(parser, sym, rest, lineno)
#define symhlpr(lexeme, meta_allowed) sym_helper(parser, lexeme, meta_allowed)
#define yyerr(msg) yyerror(scnr, parser, msg)
#define yybadtok(tok, context) yybadtoken(parser, tok, context)
#define ifnign(expr) (parser->ignore ? nil : (expr))

INLINE val expand_forms_ver(val forms, int ver)
{
  if (!opt_compat || opt_compat >= ver)
    return expand_forms(forms, nil);
  return forms;
}

INLINE val expand_form_ver(val form, int ver)
{
  if (!opt_compat || opt_compat >= ver)
    return expand(form, nil);
  return form;
}



/* Line 268 of yacc.c  */
#line 175 "y.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     SPACE = 258,
     TEXT = 259,
     SYMTOK = 260,
     ALL = 261,
     SOME = 262,
     NONE = 263,
     MAYBE = 264,
     CASES = 265,
     BLOCK = 266,
     CHOOSE = 267,
     GATHER = 268,
     AND = 269,
     OR = 270,
     END = 271,
     COLLECT = 272,
     UNTIL = 273,
     COLL = 274,
     OUTPUT = 275,
     REPEAT = 276,
     PUSH = 277,
     REP = 278,
     SINGLE = 279,
     FIRST = 280,
     LAST = 281,
     EMPTY = 282,
     MOD = 283,
     MODLAST = 284,
     DEFINE = 285,
     TRY = 286,
     CATCH = 287,
     FINALLY = 288,
     IF = 289,
     ERRTOK = 290,
     HASH_BACKSLASH = 291,
     HASH_SLASH = 292,
     DOTDOT = 293,
     HASH_H = 294,
     HASH_S = 295,
     HASH_R = 296,
     HASH_J = 297,
     HASH_SEMI = 298,
     HASH_B_QUOTE = 299,
     HASH_N = 300,
     HASH_T = 301,
     WORDS = 302,
     WSPLICE = 303,
     QWORDS = 304,
     QWSPLICE = 305,
     SECRET_ESCAPE_R = 306,
     SECRET_ESCAPE_E = 307,
     SECRET_ESCAPE_I = 308,
     SECRET_ESCAPE_J = 309,
     OLD_DOTDOT = 310,
     NUMBER = 311,
     METANUM = 312,
     JSKW = 313,
     HASH_N_EQUALS = 314,
     HASH_N_HASH = 315,
     REGCHAR = 316,
     REGTOKEN = 317,
     LITCHAR = 318,
     SPLICE = 319,
     JSPLICE = 320,
     OLD_AT = 321,
     CONSDOT = 322,
     LAMBDOT = 323,
     UREFDOT = 324,
     OREFDOT = 325,
     UOREFDOT = 326,
     LOW = 327,
     ELSE = 328,
     ELIF = 329
   };
#endif
/* Tokens.  */
#define SPACE 258
#define TEXT 259
#define SYMTOK 260
#define ALL 261
#define SOME 262
#define NONE 263
#define MAYBE 264
#define CASES 265
#define BLOCK 266
#define CHOOSE 267
#define GATHER 268
#define AND 269
#define OR 270
#define END 271
#define COLLECT 272
#define UNTIL 273
#define COLL 274
#define OUTPUT 275
#define REPEAT 276
#define PUSH 277
#define REP 278
#define SINGLE 279
#define FIRST 280
#define LAST 281
#define EMPTY 282
#define MOD 283
#define MODLAST 284
#define DEFINE 285
#define TRY 286
#define CATCH 287
#define FINALLY 288
#define IF 289
#define ERRTOK 290
#define HASH_BACKSLASH 291
#define HASH_SLASH 292
#define DOTDOT 293
#define HASH_H 294
#define HASH_S 295
#define HASH_R 296
#define HASH_J 297
#define HASH_SEMI 298
#define HASH_B_QUOTE 299
#define HASH_N 300
#define HASH_T 301
#define WORDS 302
#define WSPLICE 303
#define QWORDS 304
#define QWSPLICE 305
#define SECRET_ESCAPE_R 306
#define SECRET_ESCAPE_E 307
#define SECRET_ESCAPE_I 308
#define SECRET_ESCAPE_J 309
#define OLD_DOTDOT 310
#define NUMBER 311
#define METANUM 312
#define JSKW 313
#define HASH_N_EQUALS 314
#define HASH_N_HASH 315
#define REGCHAR 316
#define REGTOKEN 317
#define LITCHAR 318
#define SPLICE 319
#define JSPLICE 320
#define OLD_AT 321
#define CONSDOT 322
#define LAMBDOT 323
#define UREFDOT 324
#define OREFDOT 325
#define UOREFDOT 326
#define LOW 327
#define ELSE 328
#define ELIF 329




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 293 of yacc.c  */
#line 109 "parser.y"

  wchar_t *lexeme;
  union obj *val;
  wchar_t chr;
  cnum lineno;



/* Line 293 of yacc.c  */
#line 368 "y.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 343 of yacc.c  */
#line 380 "y.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  213
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   4920

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  101
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  132
/* YYNRULES -- Number of rules.  */
#define YYNRULES  473
/* YYNRULES -- Number of states.  */
#define YYNSTATES  840

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   329

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      95,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,   100,     2,    97,    96,     2,    93,    88,    84,
      72,    81,    90,    92,    83,    82,    94,    87,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    98,     2,
       2,     2,     2,    91,    74,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    73,     2,    80,    85,     2,    99,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    76,    86,    77,    89,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    75,    78,    79
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     8,     9,    14,    15,    20,    22,
      24,    25,    30,    32,    35,    36,    40,    41,    46,    47,
      52,    54,    57,    60,    61,    65,    66,    71,    72,    77,
      79,    82,    85,    87,    89,    90,    92,    95,    97,    98,
     100,   102,   104,   106,   108,   110,   112,   114,   116,   118,
     120,   122,   124,   126,   130,   134,   140,   146,   150,   154,
     158,   162,   166,   170,   178,   184,   190,   196,   204,   217,
     223,   226,   230,   234,   235,   243,   256,   262,   264,   266,
     268,   270,   273,   276,   280,   284,   294,   300,   307,   308,
     312,   313,   316,   318,   319,   321,   324,   326,   328,   330,
     332,   334,   337,   339,   341,   343,   349,   359,   365,   375,
     381,   384,   387,   390,   393,   398,   401,   404,   407,   412,
     418,   421,   423,   426,   429,   437,   444,   447,   453,   458,
     465,   469,   475,   482,   486,   487,   492,   498,   502,   510,
     516,   523,   531,   540,   543,   549,   554,   561,   567,   569,
     571,   573,   576,   578,   580,   582,   591,   595,   600,   605,
     612,   617,   624,   631,   632,   642,   645,   651,   658,   659,
     663,   664,   666,   667,   670,   672,   673,   675,   678,   680,
     683,   685,   687,   689,   691,   693,   700,   703,   707,   711,
     717,   721,   727,   733,   734,   736,   740,   745,   748,   753,
     759,   765,   768,   771,   773,   775,   777,   779,   781,   783,
     788,   791,   797,   801,   804,   807,   810,   813,   816,   819,
     822,   825,   828,   831,   834,   837,   840,   841,   846,   848,
     850,   853,   857,   860,   865,   868,   873,   874,   878,   879,
     883,   884,   888,   890,   893,   896,   899,   901,   902,   904,
     908,   911,   914,   918,   924,   927,   931,   934,   936,   938,
     942,   947,   950,   955,   960,   963,   966,   969,   972,   975,
     980,   984,   987,   992,   997,  1000,  1002,  1004,  1006,  1008,
    1010,  1011,  1013,  1017,  1019,  1020,  1024,  1025,  1030,  1031,
    1036,  1037,  1043,  1046,  1049,  1053,  1056,  1060,  1062,  1064,
    1066,  1068,  1070,  1072,  1074,  1076,  1078,  1080,  1082,  1084,
    1086,  1088,  1090,  1093,  1096,  1098,  1101,  1102,  1106,  1107,
    1111,  1112,  1116,  1117,  1121,  1123,  1126,  1128,  1130,  1132,
    1134,  1136,  1138,  1140,  1142,  1144,  1146,  1148,  1150,  1152,
    1154,  1156,  1158,  1161,  1164,  1166,  1169,  1170,  1174,  1175,
    1179,  1180,  1184,  1188,  1193,  1197,  1202,  1206,  1210,  1213,
    1216,  1217,  1221,  1223,  1225,  1226,  1229,  1232,  1234,  1238,
    1241,  1245,  1248,  1250,  1254,  1258,  1261,  1262,  1264,  1267,
    1271,  1274,  1277,  1280,  1284,  1288,  1291,  1294,  1296,  1298,
    1300,  1302,  1304,  1306,  1310,  1313,  1315,  1318,  1320,  1322,
    1324,  1328,  1330,  1332,  1334,  1336,  1338,  1340,  1342,  1344,
    1346,  1348,  1350,  1352,  1354,  1356,  1359,  1362,  1366,  1369,
    1372,  1375,  1378,  1381,  1384,  1388,  1391,  1393,  1396,  1398,
    1400,  1402,  1405,  1407,  1410,  1412,  1415,  1417,  1420,  1422,
    1425,  1427,  1430,  1433,  1435,  1437,  1440,  1443,  1447,  1450,
    1454,  1457,  1460,  1462,  1465,  1468,  1470,  1472,  1474,  1476,
    1478,  1480,  1482,  1484,  1486,  1490,  1494,  1498,  1502,  1506,
    1510,  1514,  1520,  1524
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     102,     0,    -1,   116,    -1,    51,   211,    -1,    -1,    52,
     106,   103,   114,    -1,    -1,    53,   110,   104,   114,    -1,
      52,    -1,    53,    -1,    -1,    54,   176,   105,   114,    -1,
      54,    -1,     1,    95,    -1,    -1,    43,   107,   202,    -1,
      -1,    43,    94,   108,   202,    -1,    -1,    43,    70,   109,
     202,    -1,   202,    -1,    94,   202,    -1,    70,   202,    -1,
      -1,    43,   111,   196,    -1,    -1,    43,    94,   112,   196,
      -1,    -1,    43,    70,   113,   196,    -1,   196,    -1,    94,
     196,    -1,    70,   196,    -1,   202,    -1,    43,    -1,    -1,
     117,    -1,   115,   117,    -1,   115,    -1,    -1,   118,    -1,
     119,    -1,   120,    -1,   121,    -1,   122,    -1,   123,    -1,
     124,    -1,   128,    -1,   125,    -1,   144,    -1,   145,    -1,
     133,    -1,   147,    -1,   136,    -1,     6,   219,   131,    -1,
       6,   219,     1,    -1,     7,   189,    81,   219,   131,    -1,
       7,   189,    81,   219,     1,    -1,     8,   219,   131,    -1,
       8,   219,     1,    -1,     9,   219,   131,    -1,     9,   219,
       1,    -1,    10,   219,   131,    -1,    10,   219,     1,    -1,
      11,   189,    81,   219,   116,    16,   219,    -1,    11,   189,
      81,   219,     1,    -1,    12,   189,    81,   219,   131,    -1,
      12,   189,    81,   219,     1,    -1,    13,   189,    81,   219,
     126,    16,   219,    -1,    13,   189,    81,   219,   126,   130,
     189,    81,   219,   116,    16,   219,    -1,    13,   189,    81,
     219,     1,    -1,   116,   127,    -1,    14,   219,   126,    -1,
      15,   219,   126,    -1,    -1,   129,   189,    81,   219,   116,
      16,   219,    -1,   129,   189,    81,   219,   116,   130,   189,
      81,   219,   116,    16,   219,    -1,   129,   189,    81,   219,
       1,    -1,    17,    -1,    21,    -1,    18,    -1,    26,    -1,
     116,   132,    -1,    16,   219,    -1,    14,   219,   131,    -1,
      15,   219,   131,    -1,    34,   207,    81,   219,   116,   134,
     135,    16,   219,    -1,    34,   207,    81,   219,     1,    -1,
      79,   207,    81,   219,   116,   134,    -1,    -1,    78,   219,
     116,    -1,    -1,   137,    95,    -1,   138,    -1,    -1,   141,
      -1,   141,   138,    -1,     4,    -1,     3,    -1,   209,    -1,
      27,    -1,   139,    -1,   139,   140,    -1,   140,    -1,   163,
      -1,   184,    -1,    19,   189,    81,   137,    16,    -1,    19,
     189,    81,   137,   130,   189,    81,   137,    16,    -1,    23,
     189,    81,   138,    16,    -1,    23,   189,    81,   138,   130,
     189,    81,   138,    16,    -1,    11,   189,    81,   138,    16,
      -1,    19,     1,    -1,    23,     1,    -1,    11,     1,    -1,
       6,   142,    -1,     7,   189,    81,   142,    -1,     8,   142,
      -1,     9,   142,    -1,    10,   142,    -1,    12,   189,    81,
     142,    -1,    30,   188,    81,   138,    16,    -1,   137,   143,
      -1,    16,    -1,    14,   142,    -1,    15,   142,    -1,    30,
     188,    81,   219,   116,    16,   219,    -1,    30,    81,   219,
     116,    16,   219,    -1,    30,     1,    -1,    30,   188,    81,
     219,     1,    -1,    30,    81,   219,     1,    -1,    31,   219,
     116,   146,    16,   219,    -1,    31,   219,     1,    -1,    32,
      81,   219,   116,   146,    -1,    32,   188,    81,   219,   116,
     146,    -1,    33,   219,   116,    -1,    -1,    32,    81,   219,
       1,    -1,    32,   188,    81,   219,     1,    -1,    33,   219,
       1,    -1,   148,    81,   159,    95,   149,    16,   219,    -1,
     148,    81,   219,    16,   219,    -1,   148,    81,   219,   149,
      16,   219,    -1,   148,   188,    81,   219,   149,    16,   219,
      -1,   148,   188,    81,   159,    95,   149,    16,   219,    -1,
     148,     1,    -1,   148,    81,   159,    95,     1,    -1,   148,
      81,   219,     1,    -1,   148,   188,    81,   159,    95,     1,
      -1,   148,   188,    81,   219,     1,    -1,    20,    -1,    22,
      -1,   150,    -1,   150,   149,    -1,   151,    -1,   153,    -1,
     157,    -1,    21,   207,    81,   219,   156,   152,    16,   219,
      -1,    21,   219,     1,    -1,    24,   219,   156,   152,    -1,
      25,   219,   156,   152,    -1,    26,   189,    81,   219,   156,
     152,    -1,    27,   219,   156,   152,    -1,    28,   189,    81,
     219,   156,   152,    -1,    29,   189,    81,   219,   156,   152,
      -1,    -1,    34,   202,    81,   219,   156,   154,   155,    16,
     219,    -1,    34,    81,    -1,    34,   202,    81,   219,     1,
      -1,    79,   207,    81,   219,   156,   154,    -1,    -1,    78,
     219,   156,    -1,    -1,   149,    -1,    -1,   158,    95,    -1,
     159,    -1,    -1,   160,    -1,   160,   159,    -1,   232,    -1,
     232,   159,    -1,     4,    -1,     3,    -1,   166,    -1,   187,
      -1,   161,    -1,    23,   207,    81,   158,   162,    16,    -1,
      23,     1,    -1,    24,   158,   162,    -1,    25,   158,   162,
      -1,    26,   189,    81,   158,   162,    -1,    27,   158,   162,
      -1,    28,   189,    81,   158,   162,    -1,    29,   189,    81,
     158,   162,    -1,    -1,     5,    -1,    76,     5,    77,    -1,
      76,     5,   165,    77,    -1,   164,     5,    -1,   164,    76,
       5,    77,    -1,   164,    76,     5,   209,    77,    -1,   164,
      76,     5,    56,    77,    -1,     5,     1,    -1,   164,     1,
      -1,    90,    -1,    56,    -1,   209,    -1,   187,    -1,     5,
      -1,     5,    -1,    76,   202,   207,    77,    -1,     5,     1,
      -1,    74,    76,   202,   207,    77,    -1,    74,    76,     1,
      -1,    96,   184,    -1,    96,     1,    -1,    39,   184,    -1,
      39,     1,    -1,    40,   184,    -1,    40,     1,    -1,    41,
     184,    -1,    41,     1,    -1,    45,   184,    -1,    45,     1,
      -1,    46,   184,    -1,    46,     1,    -1,    42,   176,    -1,
      -1,    42,    85,   175,   176,    -1,    56,    -1,    58,    -1,
      97,    97,    -1,    97,   225,    97,    -1,    73,    80,    -1,
      73,   181,   180,    80,    -1,    76,    77,    -1,    76,   182,
     180,    77,    -1,    -1,    89,   177,   208,    -1,    -1,    65,
     178,   208,    -1,    -1,    59,   179,   176,    -1,    60,    -1,
      97,     1,    -1,    73,     1,    -1,    76,     1,    -1,    83,
      -1,    -1,   176,    -1,   181,    83,   176,    -1,   181,   176,
      -1,   181,     1,    -1,   176,   183,   176,    -1,   182,    83,
     176,   183,   176,    -1,   176,   176,    -1,   182,   176,     1,
      -1,   176,     1,    -1,     5,    -1,    98,    -1,    72,   190,
      81,    -1,    72,    94,   190,    81,    -1,    72,    81,    -1,
      72,    68,   202,    81,    -1,    72,    67,   202,    81,    -1,
      72,     1,    -1,    74,   202,    -1,    74,     1,    -1,    66,
     202,    -1,    66,     1,    -1,    73,    94,   190,    80,    -1,
      73,   190,    80,    -1,    73,    80,    -1,    73,    68,   202,
      80,    -1,    73,    67,   202,    80,    -1,    73,     1,    -1,
     184,    -1,   186,    -1,   185,    -1,   190,    -1,   188,    -1,
      -1,   191,    -1,   191,    67,   202,    -1,   202,    -1,    -1,
      43,   192,   202,    -1,    -1,    43,    94,   193,   202,    -1,
      -1,   191,    43,   194,   202,    -1,    -1,   191,    43,    94,
     195,   202,    -1,   191,   202,    -1,    48,   227,    -1,   191,
      48,   227,    -1,    50,   228,    -1,   191,    50,   228,    -1,
       5,    -1,    57,    -1,    56,    -1,   187,    -1,   168,    -1,
     169,    -1,   170,    -1,   171,    -1,   172,    -1,   173,    -1,
     174,    -1,   210,    -1,   221,    -1,   220,    -1,   222,    -1,
      47,   227,    -1,    49,   228,    -1,   229,    -1,    84,   201,
      -1,    -1,    85,   197,   201,    -1,    -1,    83,   198,   201,
      -1,    -1,    64,   199,   201,    -1,    -1,    59,   200,   201,
      -1,    60,    -1,    94,   196,    -1,   196,    -1,     5,    -1,
      57,    -1,    56,    -1,   187,    -1,   168,    -1,   169,    -1,
     170,    -1,   171,    -1,   172,    -1,   173,    -1,   174,    -1,
     210,    -1,   221,    -1,   220,    -1,   222,    -1,    47,   227,
      -1,    49,   228,    -1,   229,    -1,    84,   208,    -1,    -1,
      85,   203,   208,    -1,    -1,    83,   204,   208,    -1,    -1,
      64,   205,   208,    -1,   202,    38,   202,    -1,   202,    38,
      94,   202,    -1,   202,    55,   202,    -1,   202,    55,    94,
     202,    -1,   202,    94,   202,    -1,   202,    70,   202,    -1,
      69,   202,    -1,    71,   202,    -1,    -1,    59,   206,   208,
      -1,    60,    -1,   190,    -1,    -1,    94,   202,    -1,    70,
     202,    -1,   202,    -1,    87,   211,    87,    -1,    87,     1,
      -1,    37,   211,    87,    -1,    37,     1,    -1,   212,    -1,
     211,    86,   211,    -1,   211,    88,   211,    -1,    89,   211,
      -1,    -1,   213,    -1,   213,   212,    -1,   213,    89,   211,
      -1,   213,    90,    -1,   213,    92,    -1,   213,    91,    -1,
     213,    93,   211,    -1,    73,   214,    80,    -1,    73,    80,
      -1,    73,     1,    -1,    94,    -1,    80,    -1,    82,    -1,
      61,    -1,   218,    -1,     4,    -1,    72,   211,    81,    -1,
      72,     1,    -1,   215,    -1,   215,   214,    -1,   216,    -1,
     217,    -1,   218,    -1,   217,    82,   217,    -1,    91,    -1,
      94,    -1,    90,    -1,    92,    -1,    72,    -1,    81,    -1,
      86,    -1,    89,    -1,    88,    -1,    93,    -1,    87,    -1,
      61,    -1,    62,    -1,    95,    -1,     1,    95,    -1,    97,
      97,    -1,    97,   225,    97,    -1,    97,     1,    -1,    36,
       5,    -1,    36,    63,    -1,    36,     4,    -1,    36,     1,
      -1,    99,    99,    -1,    99,   223,    99,    -1,    99,     1,
      -1,   224,    -1,   224,   223,    -1,   225,    -1,   167,    -1,
      57,    -1,    74,   202,    -1,    63,    -1,    63,   226,    -1,
       4,    -1,     4,   226,    -1,    63,    -1,   226,    63,    -1,
       4,    -1,   226,     4,    -1,    97,    -1,   100,   227,    -1,
     225,   227,    -1,     1,    -1,    99,    -1,   100,   228,    -1,
     223,    99,    -1,   223,   100,   228,    -1,    44,    84,    -1,
      44,   230,    84,    -1,    44,     1,    -1,   230,   231,    -1,
     231,    -1,    63,    63,    -1,    63,     1,    -1,     6,    -1,
       7,    -1,     8,    -1,     9,    -1,    10,    -1,    14,    -1,
      15,    -1,    31,    -1,    33,    -1,    11,   189,    81,    -1,
      12,   189,    81,    -1,    17,   189,    81,    -1,    19,   189,
      81,    -1,    13,   189,    81,    -1,    30,   189,    81,    -1,
      32,   189,    81,    -1,    34,   202,   202,   189,    81,    -1,
      20,   189,    81,    -1,    22,   189,    81,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   177,   177,   178,   181,   180,   184,   183,   186,   193,
     200,   200,   203,   210,   219,   219,   222,   222,   225,   225,
     228,   229,   230,   233,   233,   236,   236,   239,   239,   242,
     243,   244,   249,   250,   251,   254,   255,   258,   259,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   274,
     275,   276,   277,   280,   282,   286,   289,   295,   297,   301,
     303,   307,   309,   313,   324,   329,   332,   337,   346,   358,
     363,   367,   368,   369,   372,   378,   390,   395,   396,   399,
     400,   403,   406,   407,   408,   411,   434,   438,   451,   454,
     459,   462,   465,   466,   469,   471,   476,   477,   485,   487,
     490,   491,   494,   496,   498,   509,   512,   520,   523,   532,
     535,   537,   539,   541,   542,   544,   545,   546,   547,   550,
     556,   559,   560,   561,   564,   569,   573,   575,   577,   582,
     590,   595,   600,   606,   611,   612,   615,   618,   624,   629,
     631,   634,   638,   643,   645,   648,   651,   654,   659,   660,
     663,   664,   667,   668,   669,   672,   678,   683,   687,   691,
     700,   704,   711,   718,   721,   733,   736,   740,   751,   754,
     757,   760,   761,   763,   766,   768,   771,   772,   773,   774,
     777,   779,   781,   782,   784,   787,   790,   794,   797,   800,
     808,   811,   817,   823,   830,   831,   832,   833,   834,   835,
     839,   844,   847,   851,   854,   855,   857,   859,   862,   867,
     876,   881,   884,   889,   894,   898,   906,   910,   920,   924,
     928,   932,   937,   941,   956,   960,   962,   962,   966,   967,
     968,   969,   971,   972,   978,   979,   985,   985,   990,   990,
     995,   995,   998,   999,  1001,  1003,  1007,  1009,  1012,  1015,
    1023,  1025,  1029,  1034,  1043,  1044,  1046,  1049,  1053,  1057,
    1058,  1064,  1065,  1066,  1067,  1071,  1076,  1080,  1085,  1089,
    1093,  1094,  1095,  1096,  1097,  1101,  1102,  1103,  1106,  1109,
    1110,  1113,  1117,  1122,  1125,  1125,  1129,  1129,  1133,  1133,
    1136,  1136,  1139,  1142,  1144,  1148,  1150,  1156,  1157,  1159,
    1160,  1161,  1162,  1163,  1164,  1165,  1166,  1167,  1168,  1169,
    1170,  1171,  1172,  1173,  1174,  1175,  1177,  1177,  1181,  1181,
    1185,  1185,  1189,  1189,  1192,  1195,  1196,  1198,  1199,  1201,
    1202,  1203,  1204,  1205,  1206,  1207,  1208,  1209,  1210,  1211,
    1212,  1213,  1214,  1215,  1216,  1217,  1219,  1219,  1223,  1223,
    1227,  1227,  1231,  1234,  1240,  1244,  1250,  1251,  1254,  1255,
    1256,  1256,  1259,  1262,  1263,  1266,  1267,  1268,  1271,  1274,
    1279,  1283,  1289,  1292,  1293,  1294,  1295,  1298,  1299,  1300,
    1303,  1304,  1305,  1306,  1307,  1314,  1315,  1317,  1318,  1319,
    1320,  1321,  1322,  1323,  1324,  1328,  1329,  1332,  1333,  1334,
    1337,  1339,  1340,  1341,  1342,  1343,  1344,  1345,  1346,  1347,
    1348,  1349,  1350,  1353,  1367,  1368,  1372,  1373,  1375,  1379,
    1392,  1394,  1398,  1403,  1404,  1407,  1411,  1413,  1417,  1418,
    1419,  1421,  1428,  1429,  1431,  1432,  1435,  1436,  1437,  1438,
    1441,  1442,  1443,  1445,  1449,  1450,  1451,  1453,  1459,  1461,
    1464,  1469,  1471,  1475,  1476,  1483,  1484,  1485,  1486,  1487,
    1488,  1489,  1490,  1491,  1492,  1494,  1496,  1498,  1500,  1502,
    1504,  1506,  1511,  1513
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "SPACE", "TEXT", "SYMTOK", "ALL", "SOME",
  "NONE", "MAYBE", "CASES", "BLOCK", "CHOOSE", "GATHER", "AND", "OR",
  "END", "COLLECT", "UNTIL", "COLL", "OUTPUT", "REPEAT", "PUSH", "REP",
  "SINGLE", "FIRST", "LAST", "EMPTY", "MOD", "MODLAST", "DEFINE", "TRY",
  "CATCH", "FINALLY", "IF", "ERRTOK", "HASH_BACKSLASH", "HASH_SLASH",
  "DOTDOT", "HASH_H", "HASH_S", "HASH_R", "HASH_J", "HASH_SEMI",
  "HASH_B_QUOTE", "HASH_N", "HASH_T", "WORDS", "WSPLICE", "QWORDS",
  "QWSPLICE", "SECRET_ESCAPE_R", "SECRET_ESCAPE_E", "SECRET_ESCAPE_I",
  "SECRET_ESCAPE_J", "OLD_DOTDOT", "NUMBER", "METANUM", "JSKW",
  "HASH_N_EQUALS", "HASH_N_HASH", "REGCHAR", "REGTOKEN", "LITCHAR",
  "SPLICE", "JSPLICE", "OLD_AT", "CONSDOT", "LAMBDOT", "UREFDOT",
  "OREFDOT", "UOREFDOT", "'('", "'['", "'@'", "LOW", "'{'", "'}'", "ELSE",
  "ELIF", "']'", "')'", "'-'", "','", "'\\''", "'^'", "'|'", "'/'", "'&'",
  "'~'", "'*'", "'?'", "'+'", "'%'", "'.'", "'\\n'", "'#'", "'\"'", "':'",
  "'`'", "' '", "$accept", "spec", "$@1", "$@2", "$@3",
  "hash_semi_or_n_expr", "$@4", "$@5", "$@6", "hash_semi_or_i_expr", "$@7",
  "$@8", "$@9", "byacc_fool", "clauses_rev", "clauses_opt", "clause",
  "all_clause", "some_clause", "none_clause", "maybe_clause",
  "cases_clause", "block_clause", "choose_clause", "gather_clause",
  "gather_parts", "additional_gather_parts", "collect_clause",
  "collect_repeat", "until_last", "clause_parts", "additional_parts",
  "if_clause", "elif_clauses_opt", "else_clause_opt", "line", "elems_opt",
  "elems", "text", "texts", "elem", "clause_parts_h", "additional_parts_h",
  "define_clause", "try_clause", "catch_clauses_opt", "output_clause",
  "output_push", "out_clauses", "out_clause", "repeat_clause",
  "repeat_parts_opt", "out_if_clause", "out_elif_clauses_opt",
  "out_else_clause_opt", "out_clauses_opt", "o_line", "o_elems_opt",
  "o_elems", "o_elem", "rep_elem", "rep_parts_opt", "var", "var_op",
  "modifiers", "o_var", "q_var", "vector", "hash", "struct", "range",
  "tnode", "tree", "json", "$@10", "json_val", "$@11", "$@12", "$@13",
  "opt_comma", "json_vals", "json_pairs", "json_col", "list", "meta",
  "dwim", "compound", "exprs", "exprs_opt", "n_exprs", "listacc", "$@14",
  "$@15", "$@16", "$@17", "i_expr", "$@18", "$@19", "$@20", "$@21",
  "i_dot_expr", "n_expr", "$@22", "$@23", "$@24", "$@25", "n_exprs_opt",
  "n_dot_expr", "regex", "lisp_regex", "regexpr", "regbranch", "regterm",
  "regclass", "regclassterm", "regrange", "regchar", "regtoken", "newl",
  "strlit", "chrlit", "quasilit", "quasi_items", "quasi_item", "litchars",
  "restlitchar", "wordslit", "wordsqlit", "buflit", "buflit_items",
  "buflit_item", "not_a_clause", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    40,    91,    64,   327,   123,   125,   328,   329,
      93,    41,    45,    44,    39,    94,   124,    47,    38,   126,
      42,    63,    43,    37,    46,    10,    35,    34,    58,    96,
      32
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   101,   102,   102,   103,   102,   104,   102,   102,   102,
     105,   102,   102,   102,   107,   106,   108,   106,   109,   106,
     106,   106,   106,   111,   110,   112,   110,   113,   110,   110,
     110,   110,   114,   114,   114,   115,   115,   116,   116,   117,
     117,   117,   117,   117,   117,   117,   117,   117,   117,   117,
     117,   117,   117,   118,   118,   119,   119,   120,   120,   121,
     121,   122,   122,   123,   123,   124,   124,   125,   125,   125,
     126,   127,   127,   127,   128,   128,   128,   129,   129,   130,
     130,   131,   132,   132,   132,   133,   133,   134,   134,   135,
     135,   136,   137,   137,   138,   138,   139,   139,   139,   139,
     140,   140,   141,   141,   141,   141,   141,   141,   141,   141,
     141,   141,   141,   141,   141,   141,   141,   141,   141,   141,
     142,   143,   143,   143,   144,   144,   144,   144,   144,   145,
     145,   146,   146,   146,   146,   146,   146,   146,   147,   147,
     147,   147,   147,   147,   147,   147,   147,   147,   148,   148,
     149,   149,   150,   150,   150,   151,   151,   152,   152,   152,
     152,   152,   152,   152,   153,   153,   153,   154,   154,   155,
     155,   156,   156,   157,   158,   158,   159,   159,   159,   159,
     160,   160,   160,   160,   160,   161,   161,   162,   162,   162,
     162,   162,   162,   162,   163,   163,   163,   163,   163,   163,
     163,   163,   163,   164,   165,   165,   165,   165,   166,   166,
     166,   167,   167,   168,   168,   169,   169,   170,   170,   171,
     171,   172,   172,   173,   173,   174,   175,   174,   176,   176,
     176,   176,   176,   176,   176,   176,   177,   176,   178,   176,
     179,   176,   176,   176,   176,   176,   180,   180,   181,   181,
     181,   181,   182,   182,   182,   182,   182,   183,   183,   184,
     184,   184,   184,   184,   184,   185,   185,   185,   185,   186,
     186,   186,   186,   186,   186,   187,   187,   187,   188,   189,
     189,   190,   190,   191,   192,   191,   193,   191,   194,   191,
     195,   191,   191,   191,   191,   191,   191,   196,   196,   196,
     196,   196,   196,   196,   196,   196,   196,   196,   196,   196,
     196,   196,   196,   196,   196,   196,   197,   196,   198,   196,
     199,   196,   200,   196,   196,   201,   201,   202,   202,   202,
     202,   202,   202,   202,   202,   202,   202,   202,   202,   202,
     202,   202,   202,   202,   202,   202,   203,   202,   204,   202,
     205,   202,   202,   202,   202,   202,   202,   202,   202,   202,
     206,   202,   202,   207,   207,   208,   208,   208,   209,   209,
     210,   210,   211,   211,   211,   211,   211,   212,   212,   212,
     213,   213,   213,   213,   213,   213,   213,   213,   213,   213,
     213,   213,   213,   213,   213,   214,   214,   215,   215,   215,
     216,   217,   217,   217,   217,   217,   217,   217,   217,   217,
     217,   217,   217,   218,   219,   219,   220,   220,   220,   221,
     221,   221,   221,   222,   222,   222,   223,   223,   224,   224,
     224,   224,   225,   225,   225,   225,   226,   226,   226,   226,
     227,   227,   227,   227,   228,   228,   228,   228,   229,   229,
     229,   230,   230,   231,   231,   232,   232,   232,   232,   232,
     232,   232,   232,   232,   232,   232,   232,   232,   232,   232,
     232,   232,   232,   232
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     0,     4,     0,     4,     1,     1,
       0,     4,     1,     2,     0,     3,     0,     4,     0,     4,
       1,     2,     2,     0,     3,     0,     4,     0,     4,     1,
       2,     2,     1,     1,     0,     1,     2,     1,     0,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     3,     5,     5,     3,     3,     3,
       3,     3,     3,     7,     5,     5,     5,     7,    12,     5,
       2,     3,     3,     0,     7,    12,     5,     1,     1,     1,
       1,     2,     2,     3,     3,     9,     5,     6,     0,     3,
       0,     2,     1,     0,     1,     2,     1,     1,     1,     1,
       1,     2,     1,     1,     1,     5,     9,     5,     9,     5,
       2,     2,     2,     2,     4,     2,     2,     2,     4,     5,
       2,     1,     2,     2,     7,     6,     2,     5,     4,     6,
       3,     5,     6,     3,     0,     4,     5,     3,     7,     5,
       6,     7,     8,     2,     5,     4,     6,     5,     1,     1,
       1,     2,     1,     1,     1,     8,     3,     4,     4,     6,
       4,     6,     6,     0,     9,     2,     5,     6,     0,     3,
       0,     1,     0,     2,     1,     0,     1,     2,     1,     2,
       1,     1,     1,     1,     1,     6,     2,     3,     3,     5,
       3,     5,     5,     0,     1,     3,     4,     2,     4,     5,
       5,     2,     2,     1,     1,     1,     1,     1,     1,     4,
       2,     5,     3,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     0,     4,     1,     1,
       2,     3,     2,     4,     2,     4,     0,     3,     0,     3,
       0,     3,     1,     2,     2,     2,     1,     0,     1,     3,
       2,     2,     3,     5,     2,     3,     2,     1,     1,     3,
       4,     2,     4,     4,     2,     2,     2,     2,     2,     4,
       3,     2,     4,     4,     2,     1,     1,     1,     1,     1,
       0,     1,     3,     1,     0,     3,     0,     4,     0,     4,
       0,     5,     2,     2,     3,     2,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     1,     2,     0,     3,     0,     3,
       0,     3,     0,     3,     1,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     1,     2,     0,     3,     0,     3,
       0,     3,     3,     4,     3,     4,     3,     3,     2,     2,
       0,     3,     1,     1,     0,     2,     2,     1,     3,     2,
       3,     2,     1,     3,     3,     2,     0,     1,     2,     3,
       2,     2,     2,     3,     3,     2,     2,     1,     1,     1,
       1,     1,     1,     3,     2,     1,     2,     1,     1,     1,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     2,     3,     2,     2,
       2,     2,     2,     2,     3,     2,     1,     2,     1,     1,
       1,     2,     1,     2,     1,     2,     1,     2,     1,     2,
       1,     2,     2,     1,     1,     2,     2,     3,     2,     3,
       2,     2,     1,     2,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     3,     3,     3,     3,     3,
       3,     5,     3,     3
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,     0,    97,    96,     0,     0,   280,     0,     0,     0,
       0,   280,   280,    77,     0,   148,    78,   149,     0,    99,
       0,     0,   364,   376,     8,     9,    12,     0,     0,     0,
     203,     0,    37,     2,    35,    39,    40,    41,    42,    43,
      44,    45,    47,    46,   280,    50,    52,     0,    92,   100,
     102,    94,    48,    49,    51,     0,   103,     0,   104,    98,
      13,   201,     0,    93,   280,    93,    93,    93,     0,   280,
       0,   414,     0,   113,     0,   327,     0,     0,     0,     0,
       0,     0,   284,     0,     0,     0,     0,     0,     0,     0,
     329,   328,   360,   362,   350,     0,     0,     0,     0,     0,
     348,     0,   346,     0,     0,     0,   331,   332,   333,   334,
     335,   336,   337,   275,   277,   276,   330,   279,     0,   278,
     281,   283,   338,   340,   339,   341,   344,   115,     0,   116,
       0,   117,     0,   112,     0,     0,     0,   110,     0,   111,
       0,   126,     0,     0,     0,   363,     0,   392,   390,   413,
       0,     0,   388,   389,   376,   387,     3,   372,   377,   391,
      14,     0,     0,     4,    20,   297,    23,     0,     0,   299,
     298,   322,   324,   320,     0,   318,     0,   316,     0,     6,
     301,   302,   303,   304,   305,   306,   307,   300,    29,   308,
     310,   309,   311,   314,   228,   229,   240,   242,   238,     0,
       0,   236,     0,    10,   264,     0,     0,   261,     0,     0,
       0,   369,     0,     1,    36,     0,    91,   101,    95,   143,
       0,     0,   202,   197,     0,   415,     0,     0,     0,     0,
      93,    93,   121,   120,    54,     0,    53,   422,   421,   419,
     420,   371,     0,   216,   215,   218,   217,   220,   219,   226,
     225,   286,     0,   450,     0,   448,     0,   452,   222,   221,
     224,   223,   443,   434,   432,   440,     0,     0,   342,   293,
     430,     0,   444,     0,   429,     0,   426,   428,   343,   295,
       0,     0,   268,   267,   358,   359,   274,     0,     0,   271,
       0,     0,   266,   265,     0,     0,     0,   367,   345,     0,
     214,   213,   418,   416,     0,   425,   423,     0,     0,   288,
       0,     0,     0,   292,     0,     0,     0,     0,    58,    57,
      60,    59,    62,    61,     0,     0,     0,    93,     0,     0,
       0,   130,   134,     0,   394,     0,   386,   412,   405,   385,
     406,   407,   411,   409,   408,   403,   401,   404,   410,   402,
       0,   395,   397,   398,   399,   375,   376,   376,   376,   380,
     382,   381,   376,   378,    18,    16,     0,    22,    21,    34,
      27,    25,     0,   312,   313,     0,     0,    31,     0,     0,
     326,   315,     0,    30,    34,     0,     0,   244,   232,   248,
       0,   245,   234,     0,   247,     0,   243,   230,     0,    34,
       0,     0,     0,   259,   207,   204,   195,     0,   206,   205,
     368,     0,   181,   180,     0,   455,   456,   457,   458,   459,
     280,   280,   280,   460,   461,   280,   280,   280,   280,     0,
     280,   462,   280,   463,     0,     0,     0,   176,   184,   182,
     183,     0,   178,     0,     0,    93,     0,    93,     0,   122,
     123,     0,     0,     0,    81,   370,     0,     0,   285,   454,
     453,   449,   451,   438,   436,   435,   433,   441,   442,     0,
     431,   445,   446,     0,   427,   361,   351,     0,     0,     0,
     270,   349,   366,   365,   347,   417,   424,   114,     0,   290,
       0,   294,   296,   282,     0,   352,     0,   354,   357,   356,
       0,     0,   118,     0,     0,     0,     0,   128,     0,     0,
       0,     0,     0,     0,     0,   393,   384,   396,     0,   373,
     374,   379,   383,     0,     0,    15,    33,     5,    32,     0,
       0,    24,   323,   321,   319,   325,   317,     7,   241,   239,
     251,   246,   250,     0,   256,   257,   258,   254,     0,   246,
       0,     0,   237,   231,    11,   263,   262,   260,   196,     0,
     210,     0,     0,     0,     0,     0,     0,     0,   186,     0,
       0,     0,     0,   364,     0,   177,   145,     0,     0,     0,
       0,   150,   152,   153,   154,     0,   174,   179,     0,     0,
       0,   198,     0,    38,    38,    82,   227,   287,   439,   437,
     212,   364,   447,   273,   272,   269,    56,    55,     0,   289,
     353,   355,   109,    64,     0,    66,    65,    69,    73,     0,
     105,    79,    80,   280,   107,   280,     0,   119,   127,     0,
       0,     0,     0,     0,    86,    88,   400,    19,    17,    28,
      26,   249,   233,   252,     0,   255,   235,    76,     0,   464,
     465,   468,   466,   467,   472,   473,   175,   469,   470,   280,
       0,   144,     0,   139,     0,     0,   165,     0,     0,   151,
     173,     0,   147,     0,   200,   199,    83,    84,     0,   291,
       0,     0,     0,    70,     0,   280,     0,     0,   125,     0,
       0,     0,   137,   133,   129,   364,    90,     0,     0,   280,
     193,     0,   209,     0,     0,   156,     0,   140,   146,     0,
       0,   211,    63,    38,    38,    67,     0,    93,     0,   124,
     135,   134,     0,     0,     0,     0,   253,    74,     0,   175,
     175,   280,   175,   280,   280,     0,   471,   138,   172,     0,
       0,   141,    71,    72,     0,     0,     0,   131,   136,   134,
       0,    38,     0,     0,   193,   193,     0,   193,     0,     0,
     185,   171,   163,   166,   168,   142,    38,   106,   108,   132,
      38,    89,    85,    38,   187,   188,   175,   190,   175,   175,
       0,     0,   280,     0,   280,   280,     0,   364,   170,     0,
      88,     0,   193,   193,   193,   172,   172,     0,   172,     0,
       0,     0,     0,     0,     0,     0,    87,     0,   189,   191,
     192,   163,   163,     0,   163,     0,     0,   155,     0,   172,
       0,    68,    75,   157,   158,   172,   160,   172,   172,   172,
     169,   164,   163,   163,   163,   168,   159,   161,   162,   167
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    31,   369,   384,   399,   163,   366,   524,   523,   179,
     372,   530,   529,   527,    32,   235,    34,    35,    36,    37,
      38,    39,    40,    41,    42,   619,   683,    43,    44,   623,
     236,   454,    45,   696,   725,    46,    47,    48,    49,    50,
      51,    73,   233,    52,    53,   513,    54,    55,   761,   581,
     582,   786,   583,   788,   804,   762,   584,   585,   586,   437,
     438,   735,    56,    57,   407,   439,   274,   106,   107,   108,
     109,   110,   111,   112,   456,   203,   395,   386,   385,   543,
     390,   394,   548,   113,   114,   115,   116,   117,   118,   119,
     120,   252,   457,   490,   608,   380,   382,   378,   376,   375,
     381,   121,   299,   294,   281,   280,   146,   298,    59,   122,
     156,   157,   158,   350,   351,   352,   353,   159,    74,   123,
     124,   125,   275,   276,   277,   465,   268,   278,   126,   256,
     257,   442
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -664
static const yytype_int16 yypact[] =
{
    2085,   -55,  -664,  -664,  3053,  4597,  2630,  4597,  4597,  4597,
    1393,  2630,  2630,  -664,  1467,  -664,  -664,  -664,  1541,  -664,
    1615,    19,  2630,   830,  2695,  3130,  3373,  1141,    55,   226,
    -664,    63,  4751,  -664,  -664,  -664,  -664,  -664,  -664,  -664,
    -664,  -664,  -664,  -664,  2630,  -664,  -664,   -29,  -664,    42,
    -664,  4010,  -664,  -664,  -664,  1689,  -664,    71,  -664,  -664,
    -664,  -664,    -6,  4010,  2630,  4010,  4010,  4010,  1393,  2630,
    2630,  -664,   315,  -664,  3227,  -664,   176,  1079,    47,    48,
      50,  1034,     3,    31,    60,    72,    37,    37,    39,    39,
    -664,  -664,  -664,  -664,  -664,  1837,  4204,  4204,  1222,  1911,
    -664,  2878,  -664,    86,    43,    27,  -664,  -664,  -664,  -664,
    -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,    22,  -664,
    2430,   135,  -664,  -664,  -664,  -664,  -664,  -664,  3259,  -664,
    3352,  -664,  3384,  -664,    52,    78,    83,  -664,    85,  -664,
      94,  -664,    19,   110,  3477,  -664,   115,  -664,  -664,  -664,
    1242,  2350,  -664,  -664,   830,  -664,   -32,  -664,  3247,  -664,
      93,  4204,  4204,  -664,   135,  -664,   101,    37,    39,  -664,
    -664,  -664,  -664,  -664,  4500,  -664,  4269,  -664,  4500,  -664,
    -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,
    -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,   915,
     961,  -664,    58,  -664,  -664,  4204,  4204,  -664,  2630,   133,
     995,  -664,   308,  -664,  -664,   137,  -664,  -664,  -664,  -664,
    3511,   139,  -664,  -664,   131,  -664,   141,   144,   166,   168,
    4010,  4010,  -664,  -664,  -664,   427,  -664,  -664,  -664,  -664,
    -664,  -664,   480,  -664,  -664,  -664,  -664,  -664,  -664,  -664,
    -664,  -664,  4204,  -664,    49,  -664,     4,  -664,  -664,  -664,
    -664,  -664,  -664,    11,    99,  -664,    37,    37,  -664,  -664,
    -664,  3552,  -664,    39,  -664,    18,    67,  -664,  -664,  -664,
    2878,  2878,  -664,   135,   113,   113,  -664,  4204,  4204,  -664,
    2630,   114,  -664,   195,  2878,  4204,  4204,   135,  -664,  2878,
    -664,  -664,  -664,  -664,   157,  -664,  -664,   159,  4597,   169,
      37,    39,  4204,   135,  3617,  3682,  4204,  4204,  -664,  -664,
    -664,  -664,  -664,  -664,  4625,  4597,    19,  4010,  4010,  2869,
    4625,  -664,   167,    19,  -664,    23,  -664,  -664,  -664,  -664,
    -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,
     180,  1324,  -664,   179,  -664,  -664,   830,   830,   830,  -664,
    -664,  -664,   830,  -664,  -664,  -664,  4204,   135,   135,  3747,
    -664,  -664,  4500,  -664,  -664,  4269,  4269,  -664,  4269,  4500,
    -664,  -664,  4269,  -664,  3747,  3373,  2878,  -664,  -664,  -664,
     562,  -664,  -664,   197,  3361,  2878,  -664,  -664,   175,  3747,
     230,   359,   185,  -664,  -664,  -664,  -664,   192,  -664,  -664,
    -664,    19,  -664,  -664,  2178,  -664,  -664,  -664,  -664,  -664,
    2630,  2630,  2630,  -664,  -664,  2630,  2630,  2630,  2630,  1763,
    2630,  -664,  2630,  -664,  4204,  4204,   183,  4844,  -664,  -664,
    -664,  2792,  4844,  3511,   116,  4010,  4010,  4010,  4010,  -664,
    -664,    19,    19,    19,  -664,  -664,  3373,  4204,   135,  -664,
    -664,  -664,  -664,  -664,  -664,    35,   220,  -664,  -664,  1985,
     135,  -664,  -664,    39,  -664,  -664,  -664,   255,   410,   204,
    -664,  -664,   113,   113,  -664,  -664,  -664,  -664,  3844,  -664,
    4204,  -664,  -664,   135,  4204,   135,  4204,   195,   113,   113,
     259,  4366,  -664,  3876,  2826,   208,   327,  -664,   276,   280,
    4398,  2495,    19,   281,  2143,  -664,  -664,  -664,  2039,   217,
    -664,  -664,  -664,  4204,  4204,   135,  -664,  -664,   135,  4500,
    4500,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,
    -664,  3373,  -664,   227,  -664,  -664,  -664,  -664,  3373,  3373,
     320,   232,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  3969,
    -664,   235,   246,   251,   263,   266,   270,   271,  -664,   283,
     290,   293,  2560,  2219,  2975,  -664,  -664,    19,  1307,  4021,
     341,  4718,  -664,  -664,  -664,   267,  -664,  -664,   282,  3012,
     304,  -664,   330,  4751,  4751,  -664,  -664,   135,  -664,  -664,
    -664,  2219,  -664,  -664,  -664,  -664,  -664,  -664,  4204,   135,
     113,   113,  -664,  -664,   369,  -664,  -664,  -664,   221,   385,
    -664,  -664,  -664,  2630,  -664,  2630,    19,  -664,  -664,   399,
      19,   337,  4491,    19,  -664,   340,  -664,   135,   135,  -664,
    -664,  -664,  -664,  -664,    25,  -664,  -664,  -664,   515,  -664,
    -664,  -664,  -664,  -664,  -664,  -664,  4844,  -664,  -664,  2219,
     345,  -664,   409,  -664,   349,   430,  -664,  2289,    19,  -664,
    -664,  3089,  -664,   422,  -664,  -664,  -664,  -664,   362,   135,
      19,    19,    19,  -664,    19,  2630,   371,   376,  -664,    19,
    4118,    19,  -664,  -664,  -664,  2630,   382,  3373,    19,  2630,
     581,   386,  -664,    19,    19,  -664,    19,  -664,  -664,   450,
      19,  -664,  -664,  4751,  4751,  -664,   389,  4010,  4010,  -664,
    -664,   167,  4152,   390,    19,   456,  -664,  -664,   395,  4844,
    4844,  2630,  4844,  2630,  2630,   461,  -664,  -664,  4718,  2386,
      19,  -664,  -664,  -664,    19,   467,   470,  -664,  -664,   167,
      19,  4751,    19,    19,   581,   581,   407,   581,   408,   414,
    -664,  -664,   628,  -664,   420,  -664,  4751,  -664,  -664,  -664,
    4751,  -664,  -664,  4751,  -664,  -664,  4844,  -664,  4844,  4844,
      19,    19,  2630,    19,  2630,  2630,   484,  2630,   432,   499,
     340,   502,   581,   581,   581,  4718,  4718,   438,  4718,   441,
     443,    19,   453,    19,   519,    19,  -664,    19,  -664,  -664,
    -664,   628,   628,    19,   628,    19,    19,  -664,    19,  4718,
      19,  -664,  -664,  -664,  -664,  4718,  -664,  4718,  4718,  4718,
    -664,  -664,   628,   628,   628,   420,  -664,  -664,  -664,  -664
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,  -664,
    -664,  -664,  -664,  -347,  -664,   127,   513,  -664,  -664,  -664,
    -664,  -664,  -664,  -664,  -664,  -472,  -664,  -664,  -664,  -488,
    -120,  -664,  -664,  -238,  -664,  -664,    14,   -48,  -664,   504,
    -664,   224,  -664,  -664,  -664,  -663,  -664,  -664,  -428,  -664,
    -664,  -256,  -664,  -274,  -664,  -302,  -664,  -622,  -191,  -664,
    -664,  -490,  -664,  -664,  -664,  -664,  -664,     0,    30,    45,
     103,   164,   172,   212,  -664,   -57,  -664,  -664,  -664,   170,
    -664,  -664,   -75,   384,  -664,  -664,    -9,   -13,    81,   -16,
    -664,  -664,  -664,  -664,  -664,     8,  -664,  -664,  -664,  -664,
     -17,   761,  -664,  -664,  -664,  -664,  -361,  -216,  -206,   472,
      -2,   415,  -664,   228,  -664,  -664,    64,  -142,    -7,   558,
     574,   579,   -88,  -664,   -51,   317,   -82,   -63,   614,  -664,
     333,  -664
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -377
static const yytype_int16 yytable[] =
{
     128,   130,   132,   218,   409,   269,   145,   143,   319,   354,
     321,   209,   323,   580,   144,   463,   187,   307,   625,    72,
      62,    72,    72,    72,   250,   180,   279,   212,   305,   436,
     545,   263,   253,   188,   700,   267,   267,   537,   262,   598,
      60,   263,   221,   263,   302,     2,     3,   263,   243,   245,
     459,   247,   554,   304,   356,   181,   357,   229,   747,   396,
     210,   258,   263,   213,   475,   476,   216,   254,   569,    19,
     182,   263,   222,   260,   464,   242,   223,    72,   481,    72,
      72,    72,   291,   484,   270,   373,   769,   300,   461,   225,
     264,   134,   135,   136,   254,   138,   270,   251,   599,   140,
     264,   271,   264,   308,   515,   374,   264,   754,   755,   356,
     757,   357,   460,   271,    71,   255,   267,   472,   473,    27,
      27,   264,    27,   546,   270,   215,   306,    33,   183,    29,
     264,   685,    27,   324,   265,   329,   444,   266,   272,   273,
     303,   271,   389,   393,    27,   226,   662,   224,   335,   227,
     228,   398,   355,   669,   792,   397,   793,   794,    27,   325,
     699,   673,   464,   364,   326,   187,   327,   187,   315,   187,
     539,   370,   590,   314,   180,   328,   180,   237,   180,   552,
     238,   239,   377,   316,   467,   468,   383,   365,   474,   184,
     315,   330,   402,   591,   480,   371,   333,   185,   544,   511,
     512,   408,   545,    29,   181,   316,   181,   317,   181,   354,
     471,   440,   660,   441,   403,   267,   267,   664,   411,   182,
     443,   182,   445,   182,   620,   446,   621,   211,   491,   317,
     147,   127,   129,   131,   622,   681,   682,   186,   592,   240,
     678,   742,   743,   709,    72,    72,   575,   447,   492,   448,
     315,   587,   588,   194,   485,   195,   196,   197,   486,   267,
     516,   518,   198,   489,   774,   775,   557,   777,   314,   558,
     199,   332,   553,   200,   479,   612,   500,   183,   574,   183,
     506,   183,   509,   599,   605,   315,   201,   148,   149,   127,
     129,   131,   626,   314,   202,   546,   627,   633,   150,   151,
     316,   488,   808,   809,   810,   357,   152,   642,   153,   646,
     315,   555,  -376,  -376,  -376,   154,   649,   501,   503,   504,
     155,   645,    72,   510,   317,   316,   514,   650,   538,   230,
     231,   232,   651,   542,   723,   603,   547,   550,   184,    72,
     184,   505,   184,   624,   652,   621,   185,   653,   185,   317,
     185,   654,   655,   622,   519,   520,   521,   668,   532,   533,
     522,   534,   670,   187,   656,   536,   187,   187,   607,   187,
     187,   657,   180,   187,   658,   180,   180,   671,   180,   180,
     531,   674,   180,   616,    58,   680,   186,   535,   186,    58,
     186,    58,    58,    58,   356,   410,   357,   314,   500,   596,
     509,   684,   181,   621,   559,   181,   181,   675,   181,   181,
     602,   622,   181,   145,   315,   689,    58,   182,   691,   695,
     182,   182,   702,   182,   182,   703,   802,   182,   440,   316,
     704,   705,   440,   440,   440,    58,   589,   764,   710,   711,
     556,   451,   452,   453,   593,   594,   595,    58,   314,    58,
      58,    58,   717,   317,   449,   450,   508,   718,    58,    72,
     724,    72,   244,   246,   248,   315,   740,   736,   259,   261,
     744,   750,   752,   676,   677,   183,   753,   760,   183,   183,
     316,   183,   183,   767,   641,   183,   768,   301,   776,   778,
     604,   643,   644,   811,   812,   779,   814,   189,   631,   787,
     801,   561,   562,   563,   317,   632,   564,   565,   566,   567,
     803,   570,    58,   571,    58,   805,    58,   830,   807,   813,
     187,   187,   815,   832,   816,   833,   834,   835,    58,   180,
     180,   698,   487,   621,   818,   820,   184,   639,   640,   184,
     184,   622,   184,   184,   185,   214,   184,   185,   185,   502,
     185,   185,   806,   217,   185,   823,   824,   145,   826,   181,
     181,   839,   145,   540,   551,   440,   356,   455,   357,   697,
     663,   665,   440,   363,   182,   182,   836,   837,   838,   517,
     440,   466,   636,   190,   186,   145,     0,   186,   186,   462,
     186,   186,     0,     0,   186,     0,     0,     0,     0,   191,
       0,     0,     0,     0,   192,   729,   730,   731,   732,   733,
     734,     0,     0,     0,    58,    58,     0,     0,   194,   688,
     195,   196,   197,   690,     0,     0,   694,   198,   614,     0,
       0,   618,   183,   183,     0,   199,     0,   629,   200,   193,
     726,   635,  -247,     0,     0,   541,   189,   440,   189,     0,
     189,   201,   780,   781,   782,   783,   784,   785,     0,   202,
       0,   707,   440,     0,     0,     0,     0,     0,     0,   487,
     746,   502,     0,   712,   713,   714,     0,   715,     0,   145,
       0,     0,   719,     0,   722,     0,   648,     0,     0,     0,
       0,   727,    58,   184,   184,     0,   737,   738,     0,   739,
       0,   185,   185,   741,   686,     0,   687,     0,    58,    58,
       0,    58,    58,    58,    58,     0,     0,   751,     0,     0,
     440,   440,     0,   440,     0,     0,     0,     0,     0,   440,
     440,   745,   190,   765,   190,     0,   190,   766,     0,     0,
     701,   186,   186,   770,     0,   772,   773,     0,   191,     0,
     191,     0,   191,   192,     0,   192,     0,   192,     0,   693,
       0,     0,     0,     0,     0,     0,   716,   440,     0,   440,
     440,   145,     0,   795,   796,     0,   798,     0,     0,     0,
     728,     0,     0,     0,     0,   164,   440,   440,   193,   440,
     193,     0,   193,     0,   817,     0,   819,     0,   821,     0,
     822,     0,     0,     0,     0,     0,   825,     0,   827,   828,
     440,   829,   756,   831,   758,   759,   440,   721,   440,   440,
     440,     0,     0,     0,     0,     0,     0,     0,     0,    58,
      58,    58,    58,     0,   147,     0,     0,     0,     0,     0,
     618,   618,     0,     0,   189,     0,     0,   189,   189,   749,
     189,   189,     0,     0,   189,     0,   283,   284,   285,     0,
     293,     0,   297,   797,     0,   799,   800,     0,     0,     0,
       0,     0,    58,     0,     0,     0,     0,     0,   771,     0,
       0,   313,     0,     0,     0,    58,     0,    58,    58,     0,
       0,   148,   149,   789,    58,     0,     0,   790,    58,     0,
     791,     0,   150,   151,     0,     0,     0,     0,     0,     0,
     152,     0,   153,     0,     0,     0,   387,     0,     0,   154,
       0,     0,   367,   368,   155,     0,     0,     0,     0,     0,
     190,     0,     0,   190,   190,     0,   190,   190,     0,     0,
     190,     0,     0,    58,     0,     0,   191,     0,     0,   191,
     191,   192,   191,   191,   192,   192,   191,   192,   192,     0,
       0,   192,   391,     0,     0,     0,   400,   401,     0,     0,
       0,   194,     0,   195,   196,   197,     0,    58,    58,     0,
     198,     0,     0,     0,     0,     0,   193,     0,   199,   193,
     193,   200,   193,   193,     0,   388,   193,     0,     0,     0,
     404,   189,   189,     0,   201,     0,     0,     0,     0,     0,
       0,     0,   202,   458,     0,     0,    58,   194,     0,   195,
     196,   197,     0,     0,     0,     0,   198,     0,     0,     0,
       0,     0,   470,     0,   199,     0,     0,   200,   392,     0,
       0,   297,   297,     0,     0,     0,     0,     0,   477,   478,
     201,   405,     0,     0,     0,   297,   482,   483,   202,     0,
     297,    95,     0,     0,     0,     0,     0,    27,    98,    99,
       0,     0,   406,   493,    58,   495,   497,   498,   499,     0,
     241,     0,    29,   147,     0,     0,     0,   190,   190,     0,
     194,     0,   195,   196,   197,     0,     0,    58,    58,   198,
       0,    58,    58,   191,   191,     0,    58,   199,   192,   192,
     200,     0,     0,     0,     0,     0,     0,     0,     0,   249,
       0,     0,     0,   201,     0,     0,     0,   525,     0,     0,
     528,   202,     0,     0,     0,    58,     0,     0,     0,     0,
     148,   149,   204,   193,   193,   528,    75,   297,     0,     0,
      58,   150,   151,     0,    58,     0,   297,    58,     0,   152,
     528,   153,     0,     0,     0,  -376,  -376,  -376,   154,     0,
       0,     0,     0,   155,     0,     0,     0,    76,    77,     0,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,     0,     0,     0,   572,   573,    90,    91,     0,
      92,    93,     0,     0,     0,    94,     0,    95,   205,   206,
      96,     0,    97,    27,    98,    99,     0,     0,   597,     0,
       0,     0,   207,   286,   100,   101,   102,    75,     0,     0,
     601,     0,     0,     0,     0,   208,     0,   103,   104,     0,
     105,     0,     0,   334,     0,     0,   147,     0,     0,     0,
       0,   609,     0,     0,     0,   610,     0,   611,    76,    77,
       0,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,     0,     0,     0,     0,     0,    90,    91,
       0,    92,    93,     0,   637,   638,    94,     0,    95,   287,
     288,    96,     0,    97,    27,    98,    99,     0,     0,     0,
       0,     0,   289,   148,   149,   100,   101,   102,    62,     0,
       0,     0,    75,     0,   150,   151,   290,     0,   103,   104,
       0,   105,   152,  -376,   153,     0,     0,     0,  -376,     0,
    -376,   154,     0,   659,     0,     0,   155,     0,     0,     0,
     667,     0,     0,    76,    77,     0,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,     0,     0,
       0,     0,     0,    90,    91,     0,    92,    93,     0,   679,
       0,    94,     0,    95,     0,     0,    96,     0,    97,    27,
      98,    99,     0,     0,     0,   337,   149,     0,  -364,     0,
     100,   101,   102,     0,   133,     0,   338,     0,    75,     0,
       0,     0,    71,   103,   104,   340,   105,     0,     0,     0,
     341,   342,   343,   344,   345,   346,   347,   348,   349,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   659,    76,
      77,     0,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,     0,     0,     0,     0,     0,    90,
      91,     0,    92,    93,     0,     0,     0,    94,     0,    95,
       0,     0,    96,     0,    97,    27,    98,    99,   137,     0,
       0,     0,    75,     0,  -280,     0,   100,   101,   102,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   103,
     104,     0,   105,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    76,    77,     0,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,     0,     0,
       0,     0,     0,    90,    91,     0,    92,    93,     0,     0,
       0,    94,     0,    95,     0,     0,    96,     0,    97,    27,
      98,    99,   139,     0,     0,     0,    75,     0,  -280,     0,
     100,   101,   102,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   103,   104,     0,   105,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    76,    77,     0,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,     0,     0,     0,     0,     0,    90,    91,     0,
      92,    93,     0,     0,     0,    94,     0,    95,     0,     0,
      96,     0,    97,    27,    98,    99,   141,     0,     0,     0,
      75,     0,  -280,     0,   100,   101,   102,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   103,   104,     0,
     105,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    76,    77,     0,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,     0,     0,     0,     0,
       0,    90,    91,     0,    92,    93,     0,     0,     0,    94,
       0,    95,     0,     0,    96,     0,    97,    27,    98,    99,
     219,     0,     0,     0,    75,     0,   142,     0,   100,   101,
     102,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   103,   104,     0,   105,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    76,    77,     0,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
       0,     0,     0,     0,     0,    90,    91,     0,    92,    93,
       0,     0,     0,    94,     0,    95,     0,     0,    96,     0,
      97,    27,    98,    99,   568,     0,     0,     0,    75,     0,
     220,     0,   100,   101,   102,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   103,   104,     0,   105,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    76,
      77,     0,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,     0,     0,     0,     0,     0,    90,
      91,     0,    92,    93,     0,     0,     0,    94,     0,    95,
       0,     0,    96,     0,    97,    27,    98,    99,   282,     0,
       0,     0,    75,     0,  -364,     0,   100,   101,   102,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   103,
     104,     0,   105,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    76,    77,     0,    78,    79,    80,    81,
       0,    83,    84,    85,    86,     0,    88,     0,     0,     0,
       0,     0,     0,    90,    91,     0,    92,    93,     0,     0,
       0,    94,     0,    95,     0,     0,    96,     0,    97,    27,
      98,    99,   292,     0,     0,     0,    75,     0,     0,     0,
     100,   101,   102,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   103,   104,     0,   105,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    76,    77,     0,
      78,    79,    80,    81,     0,    83,    84,    85,    86,     0,
      88,     0,     0,     0,     0,     0,     0,    90,    91,     0,
      92,    93,     0,     0,     0,    94,     0,    95,     0,     0,
      96,     0,    97,    27,    98,    99,   600,     0,     0,     0,
      75,     0,     0,     0,   100,   101,   102,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   103,   104,     0,
     105,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    76,    77,     0,    78,    79,    80,    81,     0,    83,
      84,    85,    86,     0,    88,     0,     0,     0,     0,     0,
       0,    90,    91,     0,    92,    93,     0,     0,     0,    94,
       0,    95,     0,     0,    96,     0,    97,    27,    98,    99,
       0,     0,     0,     0,     0,     0,     0,     0,   100,   101,
     102,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   103,   104,     0,   105,   -38,     1,     0,     2,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,     0,
     337,     0,    13,     0,    14,    15,    16,    17,    18,     0,
       0,   338,    19,     0,     0,    20,    21,     0,     0,    22,
     340,     0,     0,     0,     0,   341,   342,   343,   344,   345,
     346,   347,   348,   349,     0,     0,    23,    24,    25,    26,
       0,     0,     0,     0,   634,     0,     2,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    27,     0,   -38,
      13,    28,    14,    15,    16,    17,    18,     0,     0,     0,
      19,     0,    29,    20,    21,    30,     0,    22,     0,   560,
     -93,  -208,  -208,  -208,  -208,  -208,  -208,  -208,  -208,  -208,
    -208,  -208,  -208,  -208,  -208,  -208,     0,  -208,  -208,     0,
    -208,  -208,  -208,  -208,  -208,  -208,  -208,  -208,  -208,  -208,
    -208,  -208,  -208,     0,     0,    27,     0,     0,     0,    28,
       0,   -38,   -38,     0,    75,     0,     0,     0,     0,     0,
      29,     0,     0,    30,     0,     0,     0,     0,   -93,     0,
       0,     0,     0,     0,  -208,     0,     0,     0,     0,     0,
    -208,  -208,  -208,     0,  -208,    76,    77,   314,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
       0,     0,     0,  -208,   315,    90,    91,     0,    92,    93,
       0,     0,     0,    94,     0,    95,     0,     0,    96,   316,
      97,    27,    98,    99,    75,     0,     0,     0,     0,     0,
       0,     0,   100,   101,   102,     0,     0,     0,     0,     0,
       0,     0,     0,   317,     0,   103,   104,     0,   105,     0,
       0,     0,     0,     0,     0,    76,    77,   314,    78,    79,
      80,    81,     0,    83,    84,    85,    86,     0,    88,     0,
       0,     0,     0,     0,   315,    90,    91,     0,    92,    93,
       0,   336,     0,    94,     0,    95,     0,     0,    96,   316,
      97,    27,    98,    99,     0,     0,     0,     0,     0,     0,
     706,     0,   100,   101,   102,     0,     0,     0,     0,     0,
       0,     0,     0,   317,     0,   103,   104,   763,   105,   412,
     413,   414,   415,   416,   417,   418,   419,   420,   421,   422,
     423,   424,  -172,   425,     0,   426,   427,   578,   428,   429,
       0,   337,   149,     0,     0,     0,   430,   431,   432,   433,
     579,     0,   338,     0,     0,     0,     0,     0,     0,     0,
     339,   340,     0,     0,     0,    75,   341,   342,   343,   344,
     345,   346,   347,   348,   349,     0,     0,     0,     0,     0,
       0,     0,    95,     0,     0,     0,     0,     0,    27,    98,
      99,     0,   435,     0,  -172,  -172,    76,    77,     0,    78,
      79,    80,    81,   309,    83,    84,    85,    86,   310,    88,
     311,  -175,     0,     0,     0,     0,    90,    91,     0,    92,
      93,     0,     0,     0,    94,     0,    95,   312,     0,    96,
      75,    97,    27,    98,    99,     0,     0,     0,     0,     0,
       0,     0,     0,   100,   101,   102,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   103,   104,     0,   105,
       0,    76,    77,     0,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,     0,     0,     0,     0,
       0,    90,    91,     0,    92,    93,     0,     0,     0,    94,
       0,    95,     0,     0,    96,    75,    97,    27,    98,    99,
       0,     0,     0,     0,     0,     0,   630,     0,   100,   101,
     102,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   103,   104,     0,   105,     0,    76,    77,   314,    78,
      79,    80,    81,     0,    83,    84,    85,    86,     0,    88,
       0,     0,     0,     0,     0,   315,    90,    91,     0,    92,
      93,     0,     0,     0,    94,     0,    95,     0,     0,    96,
     316,    97,    27,    98,    99,    75,     0,     0,     0,     0,
       0,     0,     0,   100,   101,   102,     0,     0,     0,     0,
       0,     0,     0,     0,   317,     0,   103,   104,     0,   105,
       0,     0,     0,     0,     0,     0,    76,    77,     0,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,     0,     0,     0,     0,     0,    90,    91,     0,    92,
      93,     0,     0,     0,    94,     0,    95,     0,     0,    96,
      75,    97,    27,    98,    99,     0,     0,     0,     0,     0,
       0,     0,     0,   100,   101,   102,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   103,   104,     0,   105,
       0,    76,    77,     0,    78,    79,    80,    81,   160,    83,
      84,    85,    86,     0,    88,     0,     0,     0,     0,     0,
       0,    90,    91,     0,    92,    93,     0,     0,     0,    94,
       0,    95,     0,     0,    96,   161,    97,    27,    98,    99,
       0,     0,     0,     0,     0,     0,     0,     0,   100,   101,
     102,     0,     0,     0,     0,     0,     0,     0,     0,   162,
       0,   103,   104,   576,   105,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,   577,   425,
       0,   426,   427,   578,   428,   429,     0,     0,     0,     0,
       0,     0,   430,   431,   432,   433,   579,   617,     0,     2,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
     -38,   -38,   -38,    13,   -38,    14,    15,    16,    17,    18,
       0,     0,   -38,    19,     0,     0,    20,    21,    95,     0,
      22,     0,     0,     0,    27,    98,    99,     0,   435,     0,
     507,     0,     2,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    75,     0,   -38,    13,  -175,    14,    15,
      16,    17,    18,     0,     0,     0,    19,     0,    27,    20,
      21,     0,    28,    22,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    29,    76,    77,    30,    78,    79,    80,
      81,   -93,    83,    84,    85,    86,     0,    88,     0,     0,
       0,     0,     0,     0,    90,    91,     0,    92,    93,     0,
       0,    27,    94,     0,    95,    28,     0,    96,   295,    97,
      27,    98,    99,     0,     0,     0,    29,     0,     0,    30,
       0,   100,   101,   102,   -93,     0,     0,     0,     0,     0,
       0,     0,   296,     0,   103,   104,   661,   105,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,     0,   425,     0,   426,   427,   578,   428,   429,     0,
       0,     0,     0,     0,     0,   430,   431,   432,   433,   579,
       0,     0,     0,   672,     0,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   421,   422,   423,   424,     0,   425,
       0,   426,   427,   578,   428,   429,     0,     0,     0,     0,
       0,    95,   430,   431,   432,   433,   579,    27,    98,    99,
       0,   435,     0,     0,    61,     0,  -194,  -194,  -194,  -194,
    -194,  -194,  -194,  -194,  -194,  -194,     0,  -194,  -194,  -194,
    -175,  -194,  -194,     0,     0,     0,  -194,     0,    95,  -194,
    -194,     0,     0,  -194,    27,    98,    99,     0,   435,     0,
     708,     0,   412,   413,   414,   415,   416,   417,   418,   419,
     420,   421,   422,   423,   424,     0,   425,  -175,   426,   427,
     578,   428,   429,     0,     0,     0,     0,     0,     0,   430,
     431,   432,   433,   579,     0,  -194,     0,     0,     0,  -194,
       0,     0,     0,     0,     0,   165,     0,     0,     0,     0,
    -194,     0,     0,  -194,     0,     0,     0,     0,  -194,     0,
       0,     0,     0,     0,     0,    95,     0,     0,     0,     0,
       0,    27,    98,    99,     0,   435,    76,    77,     0,    78,
      79,    80,    81,   166,    83,    84,    85,   167,     0,   168,
       0,     0,     0,     0,  -175,     0,   169,   170,     0,   171,
     172,     0,     0,     0,   173,     0,    95,     0,     0,     0,
     174,     0,    27,    98,    99,     0,     0,     0,     0,     0,
       0,     0,     0,   175,   176,   177,     0,     0,     0,     0,
       0,     0,     0,     0,   178,     0,   103,   104,   234,   105,
       2,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,   -38,   -38,   -38,    13,     0,    14,    15,    16,    17,
      18,   147,     0,     0,    19,     0,     0,    20,    21,     0,
     318,    22,     2,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,   -38,   -38,   -38,    13,     0,    14,    15,
      16,    17,    18,     0,     0,     0,    19,     0,     0,    20,
      21,     0,     0,    22,     0,     0,     0,     0,     0,    27,
       0,     0,     0,    28,     0,     0,     0,     0,   148,   149,
       0,     0,     0,     0,    29,     0,     0,    30,     0,   150,
     151,     0,   -93,     0,     0,     0,     0,   152,     0,   153,
       0,    27,     0,     0,     0,    28,   358,   359,   360,   361,
     362,   155,     0,     0,     0,     0,    29,     0,     0,    30,
       0,     0,     0,   320,   -93,     2,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,   -38,   -38,   -38,    13,
       0,    14,    15,    16,    17,    18,     0,     0,     0,    19,
       0,     0,    20,    21,     0,   322,    22,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,   -38,   -38,
     -38,    13,     0,    14,    15,    16,    17,    18,     0,     0,
       0,    19,     0,     0,    20,    21,     0,   194,    22,   195,
     196,   197,     0,     0,    27,     0,   198,     0,    28,   194,
       0,   195,   196,   197,   199,     0,     0,   200,   198,    29,
       0,     0,    30,     0,   549,     0,   199,   -93,     0,   200,
     201,     0,     0,     0,     0,     0,    27,     0,   202,     0,
      28,     0,   201,     0,     0,     0,     0,     0,     0,     0,
     202,    29,     0,     0,    30,     0,     0,     0,   331,   -93,
       2,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,     0,     0,   -38,    13,     0,    14,    15,    16,    17,
      18,     0,     0,     0,    19,     0,     0,    20,    21,   -38,
     -38,    22,    62,     0,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   423,   424,     0,   425,     0,
     426,   427,     0,   428,   429,     0,     0,     0,     0,     0,
       0,   430,   431,   432,   433,   434,     0,     0,     0,    27,
       0,     0,     0,    28,     0,     0,     0,    75,     0,     0,
       0,     0,     0,     0,    29,     0,     0,    30,     0,     0,
       0,     0,   -93,     0,     0,     0,     0,    95,     0,     0,
       0,     0,     0,    27,    98,    99,     0,   435,    76,    77,
       0,    78,    79,    80,    81,     0,    83,    84,    85,    86,
       0,    88,     0,     0,     0,     0,    71,     0,    90,    91,
       0,    92,    93,     0,     0,     0,    94,     0,    95,     0,
       0,    96,    75,    97,    27,    98,    99,     0,   469,     0,
       0,     0,     0,     0,     0,   100,   101,   102,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   103,   104,
       0,   105,     0,    76,    77,     0,    78,    79,    80,    81,
       0,    83,    84,    85,    86,     0,    88,     0,     0,     0,
       0,     0,     0,    90,    91,     0,    92,    93,     0,     0,
       0,    94,     0,    95,     0,     0,    96,    75,    97,    27,
      98,    99,     0,     0,     0,     0,     0,     0,     0,     0,
     100,   101,   102,     0,     0,     0,     0,     0,     0,     0,
       0,   494,     0,   103,   104,     0,   105,     0,    76,    77,
       0,    78,    79,    80,    81,     0,    83,    84,    85,    86,
       0,    88,     0,     0,     0,     0,     0,     0,    90,    91,
       0,    92,    93,     0,     0,     0,    94,     0,    95,     0,
       0,    96,    75,    97,    27,    98,    99,     0,     0,     0,
       0,     0,     0,     0,     0,   100,   101,   102,     0,     0,
       0,     0,     0,     0,     0,     0,   496,     0,   103,   104,
       0,   105,     0,    76,    77,     0,    78,    79,    80,    81,
     526,    83,    84,    85,    86,     0,    88,     0,     0,     0,
       0,     0,     0,    90,    91,     0,    92,    93,     0,     0,
       0,    94,     0,    95,     0,     0,    96,     0,    97,    27,
      98,    99,     0,     0,     0,     0,     0,     0,     0,     0,
     100,   101,   102,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   103,   104,   606,   105,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,   -38,   -38,
     -38,    13,     0,    14,    15,    16,    17,    18,     0,     0,
       0,    19,     0,     0,    20,    21,     0,   615,    22,     2,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
     -38,   -38,   -38,    13,     0,    14,    15,    16,    17,    18,
       0,     0,     0,    19,     0,     0,    20,    21,     0,     0,
      22,     0,     0,     0,     0,     0,    27,     0,     0,     0,
      28,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    29,     0,     0,    30,     0,     0,     0,     0,   -93,
       0,     0,     0,     0,     0,     0,     0,     0,    27,     0,
       0,     0,    28,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    29,     0,     0,    30,     0,     0,     0,
     647,   -93,     2,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,     0,     0,   -38,    13,   -38,    14,    15,
      16,    17,    18,     0,     0,   -38,    19,     0,     0,    20,
      21,     0,     0,    22,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     2,     3,     4,    63,    64,    65,    66,
      67,    68,    69,     0,     0,     0,    75,     0,     0,    14,
       0,     0,     0,    18,     0,     0,     0,    19,     0,     0,
      70,    27,     0,     0,     0,    28,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    29,    76,    77,    30,
      78,    79,    80,    81,   -93,    83,    84,    85,    86,     0,
      88,     0,     0,     0,     0,     0,     0,    90,    91,     0,
      92,    93,    27,     0,     0,    94,    28,    95,     0,     0,
      96,     0,    97,    27,    98,    99,     0,    29,     0,     0,
      30,     0,   666,     0,   100,   101,   102,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   103,   104,   720,
     105,     2,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,     0,     0,   -38,    13,     0,    14,    15,    16,
      17,    18,     0,     0,     0,    19,     0,     0,    20,    21,
     -38,   -38,    22,   748,     0,     2,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,     0,     0,   -38,    13,
       0,    14,    15,    16,    17,    18,     0,     0,     0,    19,
       0,     0,    20,    21,   -38,   -38,    22,     0,     0,     0,
      27,     0,     0,     0,    28,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    29,     0,     0,    30,    75,
       0,     0,     0,   -93,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    27,     0,     0,     0,    28,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    29,
      76,    77,    30,    78,    79,    80,    81,   -93,    83,    84,
      85,    86,     0,    88,     0,     0,     0,     0,     0,     0,
      90,    91,     0,    92,    93,     0,     0,     0,    94,     0,
      95,     0,     0,    96,   165,    97,    27,    98,    99,     0,
       0,     0,     0,     0,     0,     0,     0,   100,   101,   102,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     103,   104,     0,   105,     0,    76,    77,     0,    78,    79,
      80,    81,     0,    83,    84,    85,   167,     0,   168,     0,
       0,     0,     0,     0,     0,   169,   170,     0,   171,   172,
       0,     0,     0,   173,     0,    95,     0,     0,     0,     0,
       0,    27,    98,    99,     0,     0,     0,     0,     0,     0,
       0,     0,   175,   176,   177,     0,     0,     0,     0,     0,
       0,     0,     0,   379,     0,   103,   104,   613,   105,     2,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
       0,     0,   -38,    13,     0,    14,    15,    16,    17,    18,
       0,     0,     0,    19,     0,     0,    20,    21,     0,   628,
      22,     2,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,     0,     0,   -38,    13,     0,    14,    15,    16,
      17,    18,     0,     0,     0,    19,     0,     0,    20,    21,
       0,     0,    22,     0,     0,     0,     0,     0,    27,     0,
       0,     0,    28,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    29,     0,     0,    30,     0,     0,     0,
       0,   -93,     0,     0,     0,     0,     0,     0,     0,     0,
      27,     0,     0,     0,    28,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    29,     0,     0,    30,     0,
       0,     0,   692,   -93,     2,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,   165,     0,   -38,    13,     0,
      14,    15,    16,    17,    18,     0,     0,     0,    19,     0,
       0,    20,    21,     0,     0,    22,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    76,    77,     0,    78,
      79,    80,    81,     0,    83,    84,    85,   167,     0,   168,
       0,     0,     0,     0,     0,     0,   169,   170,     0,   171,
     172,     0,     0,    27,   173,     0,    95,    28,     0,     0,
       0,     0,    27,    98,    99,     0,     0,     0,    29,     0,
       0,    30,     0,   175,   176,   177,   -93,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   103,   104,    62,   105,
       2,     3,     4,    63,    64,    65,    66,    67,    68,    69,
       0,   -93,   -93,   -93,     0,     0,    14,     0,     0,     0,
      18,     0,     0,     0,    19,     0,    62,    70,     2,     3,
       4,    63,    64,    65,    66,    67,    68,    69,     0,     0,
       0,     0,     0,     0,    14,     0,     0,     0,    18,     0,
       0,     0,    19,     0,     0,    70,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    27,
       0,     0,     0,    28,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    29,     0,     0,    30,     0,     0,
       0,     0,    71,     0,     0,     0,     0,    27,     0,     0,
       0,    28,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    29,     0,     0,    30,     0,     0,     0,     0,
      71,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,     0,   425,     0,   426,   427,   578,
     428,   429,     0,     0,     0,     0,     0,     0,   430,   431,
     432,   433,   579,     0,     2,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,     0,     0,     0,    13,     0,
      14,    15,    16,    17,    18,     0,     0,     0,    19,     0,
       0,    20,    21,     0,    95,    22,     0,     0,     0,     0,
      27,    98,    99,     0,   435,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  -175,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    27,     0,     0,     0,    28,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    29,     0,
       0,    30,     0,     0,     0,     0,   -93,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
       0,   425,     0,   426,   427,     0,   428,   429,     0,     0,
       0,     0,     0,     0,   430,   431,   432,   433,   434,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      95,     0,     0,     0,     0,     0,    27,    98,    99,     0,
     435
};

#define yypact_value_is_default(yystate) \
  ((yystate) == (-664))

#define yytable_value_is_error(yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
       7,     8,     9,    51,   210,    87,    22,    20,   128,   151,
     130,    27,   132,   441,    21,     4,    25,   105,   506,     5,
       1,     7,     8,     9,    81,    25,    89,    29,     1,   220,
       5,     4,     1,    25,   656,    86,    87,   384,     1,     4,
      95,     4,    55,     4,     1,     3,     4,     4,     1,     1,
       1,     1,   399,   104,    86,    25,    88,    70,   721,     1,
       5,     1,     4,     0,   280,   281,    95,    63,   429,    27,
      25,     4,     1,     1,    63,    77,     5,    63,   294,    65,
      66,    67,    98,   299,    57,   167,   749,     1,    84,    95,
      63,    10,    11,    12,    63,    14,    57,    94,    63,    18,
      63,    74,    63,    81,    81,   168,    63,   729,   730,    86,
     732,    88,    63,    74,    95,    84,   167,    99,   100,    72,
      72,    63,    72,    98,    57,    44,    99,     0,    25,    87,
      63,   619,    72,    81,    97,   142,     5,   100,    99,   100,
      97,    74,   199,   200,    72,    64,   574,    76,   150,    68,
      69,   202,   154,   581,   776,    97,   778,   779,    72,    81,
     648,   589,    63,    70,    81,   174,    81,   176,    55,   178,
     386,    70,    56,    38,   174,    81,   176,     1,   178,   395,
       4,     5,   174,    70,   266,   267,   178,    94,   276,    25,
      55,    81,   208,    77,    80,    94,    81,    25,     1,    32,
      33,   210,     5,    87,   174,    70,   176,    94,   178,   351,
     273,   220,   573,   220,    81,   266,   267,   578,    81,   174,
      81,   176,    81,   178,    16,    81,    18,     1,   310,    94,
       4,     7,     8,     9,    26,    14,    15,    25,   444,    63,
     601,   713,   714,   671,   230,   231,   437,    81,   311,    81,
      55,   442,   443,    56,    97,    58,    59,    60,    99,   310,
      80,    82,    65,    94,   754,   755,    81,   757,    38,    77,
      73,   144,    97,    76,   290,    16,   324,   174,    95,   176,
     328,   178,   330,    63,    80,    55,    89,    61,    62,    65,
      66,    67,    16,    38,    97,    98,    16,    16,    72,    73,
      70,   308,   792,   793,   794,    88,    80,    80,    82,    77,
      55,    81,    86,    87,    88,    89,    81,   324,   325,   326,
      94,     1,   308,   330,    94,    70,   333,    81,   385,    14,
      15,    16,    81,   390,   695,    80,   393,   394,   174,   325,
     176,   327,   178,    16,    81,    18,   174,    81,   176,    94,
     178,    81,    81,    26,   356,   357,   358,    16,   375,   376,
     362,   378,    95,   372,    81,   382,   375,   376,   488,   378,
     379,    81,   372,   382,    81,   375,   376,    95,   378,   379,
     372,    77,   382,   503,     0,    16,   174,   379,   176,     5,
     178,     7,     8,     9,    86,    87,    88,    38,   446,   456,
     448,    16,   372,    18,   411,   375,   376,    77,   378,   379,
     473,    26,   382,   429,    55,    16,    32,   372,    81,    79,
     375,   376,    77,   378,   379,    16,   787,   382,   437,    70,
      81,     1,   441,   442,   443,    51,   443,   739,    16,    77,
      81,    14,    15,    16,   451,   452,   453,    63,    38,    65,
      66,    67,    81,    94,   230,   231,   329,    81,    74,   445,
      78,   447,    78,    79,    80,    55,    16,    81,    84,    85,
      81,    81,    16,   593,   594,   372,    81,    16,   375,   376,
      70,   378,   379,    16,   541,   382,    16,   103,    81,    81,
      80,   548,   549,   795,   796,    81,   798,    25,   511,    79,
      16,   420,   421,   422,    94,   512,   425,   426,   427,   428,
      78,   430,   128,   432,   130,    16,   132,   819,    16,    81,
     529,   530,    81,   825,    81,   827,   828,   829,   144,   529,
     530,    16,   308,    18,    81,    16,   372,   529,   530,   375,
     376,    26,   378,   379,   372,    32,   382,   375,   376,   325,
     378,   379,   790,    49,   382,   811,   812,   573,   814,   529,
     530,   835,   578,     1,   394,   574,    86,    87,    88,   644,
     577,   578,   581,   158,   529,   530,   832,   833,   834,   351,
     589,   264,   518,    25,   372,   601,    -1,   375,   376,   256,
     378,   379,    -1,    -1,   382,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    -1,    -1,    25,    24,    25,    26,    27,    28,
      29,    -1,    -1,    -1,   230,   231,    -1,    -1,    56,   626,
      58,    59,    60,   630,    -1,    -1,   633,    65,   501,    -1,
      -1,   504,   529,   530,    -1,    73,    -1,   510,    76,    25,
     697,   514,    80,    -1,    -1,    83,   174,   656,   176,    -1,
     178,    89,    24,    25,    26,    27,    28,    29,    -1,    97,
      -1,   668,   671,    -1,    -1,    -1,    -1,    -1,    -1,   445,
     718,   447,    -1,   680,   681,   682,    -1,   684,    -1,   695,
      -1,    -1,   689,    -1,   691,    -1,   559,    -1,    -1,    -1,
      -1,   698,   308,   529,   530,    -1,   703,   704,    -1,   706,
      -1,   529,   530,   710,   623,    -1,   625,    -1,   324,   325,
      -1,   327,   328,   329,   330,    -1,    -1,   724,    -1,    -1,
     729,   730,    -1,   732,    -1,    -1,    -1,    -1,    -1,   738,
     739,   717,   174,   740,   176,    -1,   178,   744,    -1,    -1,
     659,   529,   530,   750,    -1,   752,   753,    -1,   174,    -1,
     176,    -1,   178,   174,    -1,   176,    -1,   178,    -1,   632,
      -1,    -1,    -1,    -1,    -1,    -1,   685,   776,    -1,   778,
     779,   787,    -1,   780,   781,    -1,   783,    -1,    -1,    -1,
     699,    -1,    -1,    -1,    -1,    24,   795,   796,   174,   798,
     176,    -1,   178,    -1,   801,    -1,   803,    -1,   805,    -1,
     807,    -1,    -1,    -1,    -1,    -1,   813,    -1,   815,   816,
     819,   818,   731,   820,   733,   734,   825,   690,   827,   828,
     829,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   445,
     446,   447,   448,    -1,     4,    -1,    -1,    -1,    -1,    -1,
     713,   714,    -1,    -1,   372,    -1,    -1,   375,   376,   722,
     378,   379,    -1,    -1,   382,    -1,    95,    96,    97,    -1,
      99,    -1,   101,   782,    -1,   784,   785,    -1,    -1,    -1,
      -1,    -1,   488,    -1,    -1,    -1,    -1,    -1,   751,    -1,
      -1,   120,    -1,    -1,    -1,   501,    -1,   503,   504,    -1,
      -1,    61,    62,   766,   510,    -1,    -1,   770,   514,    -1,
     773,    -1,    72,    73,    -1,    -1,    -1,    -1,    -1,    -1,
      80,    -1,    82,    -1,    -1,    -1,     1,    -1,    -1,    89,
      -1,    -1,   161,   162,    94,    -1,    -1,    -1,    -1,    -1,
     372,    -1,    -1,   375,   376,    -1,   378,   379,    -1,    -1,
     382,    -1,    -1,   559,    -1,    -1,   372,    -1,    -1,   375,
     376,   372,   378,   379,   375,   376,   382,   378,   379,    -1,
      -1,   382,     1,    -1,    -1,    -1,   205,   206,    -1,    -1,
      -1,    56,    -1,    58,    59,    60,    -1,   593,   594,    -1,
      65,    -1,    -1,    -1,    -1,    -1,   372,    -1,    73,   375,
     376,    76,   378,   379,    -1,    80,   382,    -1,    -1,    -1,
       5,   529,   530,    -1,    89,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    97,   252,    -1,    -1,   632,    56,    -1,    58,
      59,    60,    -1,    -1,    -1,    -1,    65,    -1,    -1,    -1,
      -1,    -1,   271,    -1,    73,    -1,    -1,    76,    77,    -1,
      -1,   280,   281,    -1,    -1,    -1,    -1,    -1,   287,   288,
      89,    56,    -1,    -1,    -1,   294,   295,   296,    97,    -1,
     299,    66,    -1,    -1,    -1,    -1,    -1,    72,    73,    74,
      -1,    -1,    77,   312,   690,   314,   315,   316,   317,    -1,
       1,    -1,    87,     4,    -1,    -1,    -1,   529,   530,    -1,
      56,    -1,    58,    59,    60,    -1,    -1,   713,   714,    65,
      -1,   717,   718,   529,   530,    -1,   722,    73,   529,   530,
      76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    85,
      -1,    -1,    -1,    89,    -1,    -1,    -1,   366,    -1,    -1,
     369,    97,    -1,    -1,    -1,   751,    -1,    -1,    -1,    -1,
      61,    62,     1,   529,   530,   384,     5,   386,    -1,    -1,
     766,    72,    73,    -1,   770,    -1,   395,   773,    -1,    80,
     399,    82,    -1,    -1,    -1,    86,    87,    88,    89,    -1,
      -1,    -1,    -1,    94,    -1,    -1,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    -1,    -1,    -1,   434,   435,    56,    57,    -1,
      59,    60,    -1,    -1,    -1,    64,    -1,    66,    67,    68,
      69,    -1,    71,    72,    73,    74,    -1,    -1,   457,    -1,
      -1,    -1,    81,     1,    83,    84,    85,     5,    -1,    -1,
     469,    -1,    -1,    -1,    -1,    94,    -1,    96,    97,    -1,
      99,    -1,    -1,     1,    -1,    -1,     4,    -1,    -1,    -1,
      -1,   490,    -1,    -1,    -1,   494,    -1,   496,    36,    37,
      -1,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    -1,    -1,    -1,    -1,    -1,    56,    57,
      -1,    59,    60,    -1,   523,   524,    64,    -1,    66,    67,
      68,    69,    -1,    71,    72,    73,    74,    -1,    -1,    -1,
      -1,    -1,    80,    61,    62,    83,    84,    85,     1,    -1,
      -1,    -1,     5,    -1,    72,    73,    94,    -1,    96,    97,
      -1,    99,    80,    81,    82,    -1,    -1,    -1,    86,    -1,
      88,    89,    -1,   572,    -1,    -1,    94,    -1,    -1,    -1,
     579,    -1,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    -1,    -1,
      -1,    -1,    -1,    56,    57,    -1,    59,    60,    -1,   608,
      -1,    64,    -1,    66,    -1,    -1,    69,    -1,    71,    72,
      73,    74,    -1,    -1,    -1,    61,    62,    -1,    81,    -1,
      83,    84,    85,    -1,     1,    -1,    72,    -1,     5,    -1,
      -1,    -1,    95,    96,    97,    81,    99,    -1,    -1,    -1,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   667,    36,
      37,    -1,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    -1,    -1,    -1,    -1,    -1,    56,
      57,    -1,    59,    60,    -1,    -1,    -1,    64,    -1,    66,
      -1,    -1,    69,    -1,    71,    72,    73,    74,     1,    -1,
      -1,    -1,     5,    -1,    81,    -1,    83,    84,    85,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,
      97,    -1,    99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    -1,    -1,
      -1,    -1,    -1,    56,    57,    -1,    59,    60,    -1,    -1,
      -1,    64,    -1,    66,    -1,    -1,    69,    -1,    71,    72,
      73,    74,     1,    -1,    -1,    -1,     5,    -1,    81,    -1,
      83,    84,    85,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    96,    97,    -1,    99,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    36,    37,    -1,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    -1,    -1,    -1,    -1,    -1,    56,    57,    -1,
      59,    60,    -1,    -1,    -1,    64,    -1,    66,    -1,    -1,
      69,    -1,    71,    72,    73,    74,     1,    -1,    -1,    -1,
       5,    -1,    81,    -1,    83,    84,    85,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,    97,    -1,
      99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    -1,    -1,    -1,    -1,
      -1,    56,    57,    -1,    59,    60,    -1,    -1,    -1,    64,
      -1,    66,    -1,    -1,    69,    -1,    71,    72,    73,    74,
       1,    -1,    -1,    -1,     5,    -1,    81,    -1,    83,    84,
      85,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    96,    97,    -1,    99,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    36,    37,    -1,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      -1,    -1,    -1,    -1,    -1,    56,    57,    -1,    59,    60,
      -1,    -1,    -1,    64,    -1,    66,    -1,    -1,    69,    -1,
      71,    72,    73,    74,     1,    -1,    -1,    -1,     5,    -1,
      81,    -1,    83,    84,    85,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    96,    97,    -1,    99,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    36,
      37,    -1,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    -1,    -1,    -1,    -1,    -1,    56,
      57,    -1,    59,    60,    -1,    -1,    -1,    64,    -1,    66,
      -1,    -1,    69,    -1,    71,    72,    73,    74,     1,    -1,
      -1,    -1,     5,    -1,    81,    -1,    83,    84,    85,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,
      97,    -1,    99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    36,    37,    -1,    39,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    -1,    -1,    -1,
      -1,    -1,    -1,    56,    57,    -1,    59,    60,    -1,    -1,
      -1,    64,    -1,    66,    -1,    -1,    69,    -1,    71,    72,
      73,    74,     1,    -1,    -1,    -1,     5,    -1,    -1,    -1,
      83,    84,    85,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    96,    97,    -1,    99,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    36,    37,    -1,
      39,    40,    41,    42,    -1,    44,    45,    46,    47,    -1,
      49,    -1,    -1,    -1,    -1,    -1,    -1,    56,    57,    -1,
      59,    60,    -1,    -1,    -1,    64,    -1,    66,    -1,    -1,
      69,    -1,    71,    72,    73,    74,     1,    -1,    -1,    -1,
       5,    -1,    -1,    -1,    83,    84,    85,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,    97,    -1,
      99,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    36,    37,    -1,    39,    40,    41,    42,    -1,    44,
      45,    46,    47,    -1,    49,    -1,    -1,    -1,    -1,    -1,
      -1,    56,    57,    -1,    59,    60,    -1,    -1,    -1,    64,
      -1,    66,    -1,    -1,    69,    -1,    71,    72,    73,    74,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,    84,
      85,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    96,    97,    -1,    99,     0,     1,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
      61,    -1,    17,    -1,    19,    20,    21,    22,    23,    -1,
      -1,    72,    27,    -1,    -1,    30,    31,    -1,    -1,    34,
      81,    -1,    -1,    -1,    -1,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    -1,    -1,    51,    52,    53,    54,
      -1,    -1,    -1,    -1,     1,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    72,    -1,    16,
      17,    76,    19,    20,    21,    22,    23,    -1,    -1,    -1,
      27,    -1,    87,    30,    31,    90,    -1,    34,    -1,     1,
      95,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    -1,    19,    20,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    -1,    -1,    72,    -1,    -1,    -1,    76,
      -1,    78,    79,    -1,     5,    -1,    -1,    -1,    -1,    -1,
      87,    -1,    -1,    90,    -1,    -1,    -1,    -1,    95,    -1,
      -1,    -1,    -1,    -1,    66,    -1,    -1,    -1,    -1,    -1,
      72,    73,    74,    -1,    76,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      -1,    -1,    -1,    95,    55,    56,    57,    -1,    59,    60,
      -1,    -1,    -1,    64,    -1,    66,    -1,    -1,    69,    70,
      71,    72,    73,    74,     5,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    83,    84,    85,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    -1,    96,    97,    -1,    99,    -1,
      -1,    -1,    -1,    -1,    -1,    36,    37,    38,    39,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    -1,
      -1,    -1,    -1,    -1,    55,    56,    57,    -1,    59,    60,
      -1,     1,    -1,    64,    -1,    66,    -1,    -1,    69,    70,
      71,    72,    73,    74,    -1,    -1,    -1,    -1,    -1,    -1,
      81,    -1,    83,    84,    85,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    -1,    96,    97,     1,    99,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    -1,    19,    20,    21,    22,    23,
      -1,    61,    62,    -1,    -1,    -1,    30,    31,    32,    33,
      34,    -1,    72,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      80,    81,    -1,    -1,    -1,     5,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    66,    -1,    -1,    -1,    -1,    -1,    72,    73,
      74,    -1,    76,    -1,    78,    79,    36,    37,    -1,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    95,    -1,    -1,    -1,    -1,    56,    57,    -1,    59,
      60,    -1,    -1,    -1,    64,    -1,    66,    67,    -1,    69,
       5,    71,    72,    73,    74,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    83,    84,    85,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    96,    97,    -1,    99,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    -1,    -1,    -1,    -1,
      -1,    56,    57,    -1,    59,    60,    -1,    -1,    -1,    64,
      -1,    66,    -1,    -1,    69,     5,    71,    72,    73,    74,
      -1,    -1,    -1,    -1,    -1,    -1,    81,    -1,    83,    84,
      85,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    96,    97,    -1,    99,    -1,    36,    37,    38,    39,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      -1,    -1,    -1,    -1,    -1,    55,    56,    57,    -1,    59,
      60,    -1,    -1,    -1,    64,    -1,    66,    -1,    -1,    69,
      70,    71,    72,    73,    74,     5,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    83,    84,    85,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    -1,    96,    97,    -1,    99,
      -1,    -1,    -1,    -1,    -1,    -1,    36,    37,    -1,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    -1,    -1,    -1,    -1,    -1,    56,    57,    -1,    59,
      60,    -1,    -1,    -1,    64,    -1,    66,    -1,    -1,    69,
       5,    71,    72,    73,    74,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    83,    84,    85,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    96,    97,    -1,    99,
      -1,    36,    37,    -1,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    -1,    49,    -1,    -1,    -1,    -1,    -1,
      -1,    56,    57,    -1,    59,    60,    -1,    -1,    -1,    64,
      -1,    66,    -1,    -1,    69,    70,    71,    72,    73,    74,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,    84,
      85,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      -1,    96,    97,     1,    99,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      -1,    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,
      -1,    -1,    30,    31,    32,    33,    34,     1,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      -1,    -1,    26,    27,    -1,    -1,    30,    31,    66,    -1,
      34,    -1,    -1,    -1,    72,    73,    74,    -1,    76,    -1,
       1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,     5,    -1,    16,    17,    95,    19,    20,
      21,    22,    23,    -1,    -1,    -1,    27,    -1,    72,    30,
      31,    -1,    76,    34,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    87,    36,    37,    90,    39,    40,    41,
      42,    95,    44,    45,    46,    47,    -1,    49,    -1,    -1,
      -1,    -1,    -1,    -1,    56,    57,    -1,    59,    60,    -1,
      -1,    72,    64,    -1,    66,    76,    -1,    69,    70,    71,
      72,    73,    74,    -1,    -1,    -1,    87,    -1,    -1,    90,
      -1,    83,    84,    85,    95,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    -1,    96,    97,     1,    99,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    -1,    17,    -1,    19,    20,    21,    22,    23,    -1,
      -1,    -1,    -1,    -1,    -1,    30,    31,    32,    33,    34,
      -1,    -1,    -1,     1,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    -1,    17,
      -1,    19,    20,    21,    22,    23,    -1,    -1,    -1,    -1,
      -1,    66,    30,    31,    32,    33,    34,    72,    73,    74,
      -1,    76,    -1,    -1,     1,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    -1,    14,    15,    16,
      95,    18,    19,    -1,    -1,    -1,    23,    -1,    66,    26,
      27,    -1,    -1,    30,    72,    73,    74,    -1,    76,    -1,
       1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    -1,    17,    95,    19,    20,
      21,    22,    23,    -1,    -1,    -1,    -1,    -1,    -1,    30,
      31,    32,    33,    34,    -1,    72,    -1,    -1,    -1,    76,
      -1,    -1,    -1,    -1,    -1,     5,    -1,    -1,    -1,    -1,
      87,    -1,    -1,    90,    -1,    -1,    -1,    -1,    95,    -1,
      -1,    -1,    -1,    -1,    -1,    66,    -1,    -1,    -1,    -1,
      -1,    72,    73,    74,    -1,    76,    36,    37,    -1,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    -1,    49,
      -1,    -1,    -1,    -1,    95,    -1,    56,    57,    -1,    59,
      60,    -1,    -1,    -1,    64,    -1,    66,    -1,    -1,    -1,
      70,    -1,    72,    73,    74,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    83,    84,    85,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    94,    -1,    96,    97,     1,    99,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    -1,    19,    20,    21,    22,
      23,     4,    -1,    -1,    27,    -1,    -1,    30,    31,    -1,
       1,    34,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    -1,    19,    20,
      21,    22,    23,    -1,    -1,    -1,    27,    -1,    -1,    30,
      31,    -1,    -1,    34,    -1,    -1,    -1,    -1,    -1,    72,
      -1,    -1,    -1,    76,    -1,    -1,    -1,    -1,    61,    62,
      -1,    -1,    -1,    -1,    87,    -1,    -1,    90,    -1,    72,
      73,    -1,    95,    -1,    -1,    -1,    -1,    80,    -1,    82,
      -1,    72,    -1,    -1,    -1,    76,    89,    90,    91,    92,
      93,    94,    -1,    -1,    -1,    -1,    87,    -1,    -1,    90,
      -1,    -1,    -1,     1,    95,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      -1,    19,    20,    21,    22,    23,    -1,    -1,    -1,    27,
      -1,    -1,    30,    31,    -1,     1,    34,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    -1,    19,    20,    21,    22,    23,    -1,    -1,
      -1,    27,    -1,    -1,    30,    31,    -1,    56,    34,    58,
      59,    60,    -1,    -1,    72,    -1,    65,    -1,    76,    56,
      -1,    58,    59,    60,    73,    -1,    -1,    76,    65,    87,
      -1,    -1,    90,    -1,    83,    -1,    73,    95,    -1,    76,
      89,    -1,    -1,    -1,    -1,    -1,    72,    -1,    97,    -1,
      76,    -1,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      97,    87,    -1,    -1,    90,    -1,    -1,    -1,     1,    95,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    -1,    16,    17,    -1,    19,    20,    21,    22,
      23,    -1,    -1,    -1,    27,    -1,    -1,    30,    31,    32,
      33,    34,     1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    -1,    17,    -1,
      19,    20,    -1,    22,    23,    -1,    -1,    -1,    -1,    -1,
      -1,    30,    31,    32,    33,    34,    -1,    -1,    -1,    72,
      -1,    -1,    -1,    76,    -1,    -1,    -1,     5,    -1,    -1,
      -1,    -1,    -1,    -1,    87,    -1,    -1,    90,    -1,    -1,
      -1,    -1,    95,    -1,    -1,    -1,    -1,    66,    -1,    -1,
      -1,    -1,    -1,    72,    73,    74,    -1,    76,    36,    37,
      -1,    39,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    -1,    -1,    -1,    -1,    95,    -1,    56,    57,
      -1,    59,    60,    -1,    -1,    -1,    64,    -1,    66,    -1,
      -1,    69,     5,    71,    72,    73,    74,    -1,    76,    -1,
      -1,    -1,    -1,    -1,    -1,    83,    84,    85,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,    97,
      -1,    99,    -1,    36,    37,    -1,    39,    40,    41,    42,
      -1,    44,    45,    46,    47,    -1,    49,    -1,    -1,    -1,
      -1,    -1,    -1,    56,    57,    -1,    59,    60,    -1,    -1,
      -1,    64,    -1,    66,    -1,    -1,    69,     5,    71,    72,
      73,    74,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      83,    84,    85,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    94,    -1,    96,    97,    -1,    99,    -1,    36,    37,
      -1,    39,    40,    41,    42,    -1,    44,    45,    46,    47,
      -1,    49,    -1,    -1,    -1,    -1,    -1,    -1,    56,    57,
      -1,    59,    60,    -1,    -1,    -1,    64,    -1,    66,    -1,
      -1,    69,     5,    71,    72,    73,    74,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    83,    84,    85,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    94,    -1,    96,    97,
      -1,    99,    -1,    36,    37,    -1,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    -1,    49,    -1,    -1,    -1,
      -1,    -1,    -1,    56,    57,    -1,    59,    60,    -1,    -1,
      -1,    64,    -1,    66,    -1,    -1,    69,    -1,    71,    72,
      73,    74,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      83,    84,    85,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    96,    97,     1,    99,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    -1,    19,    20,    21,    22,    23,    -1,    -1,
      -1,    27,    -1,    -1,    30,    31,    -1,     1,    34,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    -1,    19,    20,    21,    22,    23,
      -1,    -1,    -1,    27,    -1,    -1,    30,    31,    -1,    -1,
      34,    -1,    -1,    -1,    -1,    -1,    72,    -1,    -1,    -1,
      76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    87,    -1,    -1,    90,    -1,    -1,    -1,    -1,    95,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    72,    -1,
      -1,    -1,    76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    87,    -1,    -1,    90,    -1,    -1,    -1,
       1,    95,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    -1,    -1,    16,    17,    18,    19,    20,
      21,    22,    23,    -1,    -1,    26,    27,    -1,    -1,    30,
      31,    -1,    -1,    34,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    -1,    -1,    -1,     5,    -1,    -1,    19,
      -1,    -1,    -1,    23,    -1,    -1,    -1,    27,    -1,    -1,
      30,    72,    -1,    -1,    -1,    76,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    87,    36,    37,    90,
      39,    40,    41,    42,    95,    44,    45,    46,    47,    -1,
      49,    -1,    -1,    -1,    -1,    -1,    -1,    56,    57,    -1,
      59,    60,    72,    -1,    -1,    64,    76,    66,    -1,    -1,
      69,    -1,    71,    72,    73,    74,    -1,    87,    -1,    -1,
      90,    -1,    81,    -1,    83,    84,    85,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,    97,     1,
      99,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    -1,    16,    17,    -1,    19,    20,    21,
      22,    23,    -1,    -1,    -1,    27,    -1,    -1,    30,    31,
      32,    33,    34,     1,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    -1,    16,    17,
      -1,    19,    20,    21,    22,    23,    -1,    -1,    -1,    27,
      -1,    -1,    30,    31,    32,    33,    34,    -1,    -1,    -1,
      72,    -1,    -1,    -1,    76,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    87,    -1,    -1,    90,     5,
      -1,    -1,    -1,    95,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    72,    -1,    -1,    -1,    76,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      36,    37,    90,    39,    40,    41,    42,    95,    44,    45,
      46,    47,    -1,    49,    -1,    -1,    -1,    -1,    -1,    -1,
      56,    57,    -1,    59,    60,    -1,    -1,    -1,    64,    -1,
      66,    -1,    -1,    69,     5,    71,    72,    73,    74,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,    84,    85,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      96,    97,    -1,    99,    -1,    36,    37,    -1,    39,    40,
      41,    42,    -1,    44,    45,    46,    47,    -1,    49,    -1,
      -1,    -1,    -1,    -1,    -1,    56,    57,    -1,    59,    60,
      -1,    -1,    -1,    64,    -1,    66,    -1,    -1,    -1,    -1,
      -1,    72,    73,    74,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    83,    84,    85,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    94,    -1,    96,    97,     1,    99,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    -1,    16,    17,    -1,    19,    20,    21,    22,    23,
      -1,    -1,    -1,    27,    -1,    -1,    30,    31,    -1,     1,
      34,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    -1,    -1,    16,    17,    -1,    19,    20,    21,
      22,    23,    -1,    -1,    -1,    27,    -1,    -1,    30,    31,
      -1,    -1,    34,    -1,    -1,    -1,    -1,    -1,    72,    -1,
      -1,    -1,    76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    87,    -1,    -1,    90,    -1,    -1,    -1,
      -1,    95,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      72,    -1,    -1,    -1,    76,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    87,    -1,    -1,    90,    -1,
      -1,    -1,     1,    95,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,     5,    -1,    16,    17,    -1,
      19,    20,    21,    22,    23,    -1,    -1,    -1,    27,    -1,
      -1,    30,    31,    -1,    -1,    34,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    36,    37,    -1,    39,
      40,    41,    42,    -1,    44,    45,    46,    47,    -1,    49,
      -1,    -1,    -1,    -1,    -1,    -1,    56,    57,    -1,    59,
      60,    -1,    -1,    72,    64,    -1,    66,    76,    -1,    -1,
      -1,    -1,    72,    73,    74,    -1,    -1,    -1,    87,    -1,
      -1,    90,    -1,    83,    84,    85,    95,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    96,    97,     1,    99,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      -1,    14,    15,    16,    -1,    -1,    19,    -1,    -1,    -1,
      23,    -1,    -1,    -1,    27,    -1,     1,    30,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    19,    -1,    -1,    -1,    23,    -1,
      -1,    -1,    27,    -1,    -1,    30,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    72,
      -1,    -1,    -1,    76,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    87,    -1,    -1,    90,    -1,    -1,
      -1,    -1,    95,    -1,    -1,    -1,    -1,    72,    -1,    -1,
      -1,    76,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    87,    -1,    -1,    90,    -1,    -1,    -1,    -1,
      95,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    -1,    17,    -1,    19,    20,    21,
      22,    23,    -1,    -1,    -1,    -1,    -1,    -1,    30,    31,
      32,    33,    34,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    -1,    -1,    -1,    17,    -1,
      19,    20,    21,    22,    23,    -1,    -1,    -1,    27,    -1,
      -1,    30,    31,    -1,    66,    34,    -1,    -1,    -1,    -1,
      72,    73,    74,    -1,    76,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    72,    -1,    -1,    -1,    76,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,    -1,
      -1,    90,    -1,    -1,    -1,    -1,    95,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      -1,    17,    -1,    19,    20,    -1,    22,    23,    -1,    -1,
      -1,    -1,    -1,    -1,    30,    31,    32,    33,    34,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      66,    -1,    -1,    -1,    -1,    -1,    72,    73,    74,    -1,
      76
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     1,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    17,    19,    20,    21,    22,    23,    27,
      30,    31,    34,    51,    52,    53,    54,    72,    76,    87,
      90,   102,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   128,   129,   133,   136,   137,   138,   139,
     140,   141,   144,   145,   147,   148,   163,   164,   184,   209,
      95,     1,     1,     6,     7,     8,     9,    10,    11,    12,
      30,    95,   137,   142,   219,     5,    36,    37,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      56,    57,    59,    60,    64,    66,    69,    71,    73,    74,
      83,    84,    85,    96,    97,    99,   168,   169,   170,   171,
     172,   173,   174,   184,   185,   186,   187,   188,   189,   190,
     191,   202,   210,   220,   221,   222,   229,   142,   219,   142,
     219,   142,   219,     1,   189,   189,   189,     1,   189,     1,
     189,     1,    81,   188,   219,   190,   207,     4,    61,    62,
      72,    73,    80,    82,    89,    94,   211,   212,   213,   218,
      43,    70,    94,   106,   202,     5,    43,    47,    49,    56,
      57,    59,    60,    64,    70,    83,    84,    85,    94,   110,
     168,   169,   170,   171,   172,   173,   174,   187,   196,   210,
     220,   221,   222,   229,    56,    58,    59,    60,    65,    73,
      76,    89,    97,   176,     1,    67,    68,    81,    94,   190,
       5,     1,   211,     0,   117,   189,    95,   140,   138,     1,
      81,   188,     1,     5,    76,    95,   189,   189,   189,   188,
      14,    15,    16,   143,     1,   116,   131,     1,     4,     5,
      63,     1,   211,     1,   184,     1,   184,     1,   184,    85,
     176,    94,   192,     1,    63,    84,   230,   231,     1,   184,
       1,   184,     1,     4,    63,    97,   100,   225,   227,   227,
      57,    74,    99,   100,   167,   223,   224,   225,   228,   228,
     206,   205,     1,   202,   202,   202,     1,    67,    68,    80,
      94,   190,     1,   202,   204,    70,    94,   202,   208,   203,
       1,   184,     1,    97,   225,     1,    99,   223,    81,    43,
      48,    50,    67,   202,    38,    55,    70,    94,     1,   131,
       1,   131,     1,   131,    81,    81,    81,    81,    81,   219,
      81,     1,   116,    81,     1,   211,     1,    61,    72,    80,
      81,    86,    87,    88,    89,    90,    91,    92,    93,    94,
     214,   215,   216,   217,   218,   211,    86,    88,    89,    90,
      91,    92,    93,   212,    70,    94,   107,   202,   202,   103,
      70,    94,   111,   227,   228,   200,   199,   196,   198,    94,
     196,   201,   197,   196,   104,   179,   178,     1,    80,   176,
     181,     1,    77,   176,   182,   177,     1,    97,   225,   105,
     202,   202,   190,    81,     5,    56,    77,   165,   187,   209,
      87,    81,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    17,    19,    20,    22,    23,
      30,    31,    32,    33,    34,    76,   159,   160,   161,   166,
     187,   219,   232,    81,     5,    81,    81,    81,    81,   142,
     142,    14,    15,    16,   132,    87,   175,   193,   202,     1,
      63,    84,   231,     4,    63,   226,   226,   227,   227,    76,
     202,   228,    99,   100,   223,   208,   208,   202,   202,   190,
      80,   208,   202,   202,   208,    97,    99,   142,   219,    94,
     194,   227,   228,   202,    94,   202,    94,   202,   202,   202,
     138,   219,   142,   219,   219,   137,   138,     1,   116,   138,
     219,    32,    33,   146,   219,    81,    80,   214,    82,   211,
     211,   211,   211,   109,   108,   202,    43,   114,   202,   113,
     112,   196,   201,   201,   201,   196,   201,   114,   176,   208,
       1,    83,   176,   180,     1,     5,    98,   176,   183,    83,
     176,   180,   208,    97,   114,    81,    81,    81,    77,   219,
       1,   189,   189,   189,   189,   189,   189,   189,     1,   207,
     189,   189,   202,   202,    95,   159,     1,    16,    21,    34,
     149,   150,   151,   153,   157,   158,   159,   159,   159,   219,
      56,    77,   209,   219,   219,   219,   176,   202,     4,    63,
       1,   202,   228,    80,    80,    80,     1,   131,   195,   202,
     202,   202,    16,     1,   116,     1,   131,     1,   116,   126,
      16,    18,    26,   130,    16,   130,    16,    16,     1,   116,
      81,   188,   219,    16,     1,   116,   217,   202,   202,   196,
     196,   176,    80,   176,   176,     1,    77,     1,   116,    81,
      81,    81,    81,    81,    81,    81,    81,    81,    81,   202,
     207,     1,   149,   219,   207,   219,    81,   202,    16,   149,
      95,    95,     1,   149,    77,    77,   131,   131,   207,   202,
      16,    14,    15,   127,    16,   130,   189,   189,   219,    16,
     219,    81,     1,   116,   219,    79,   134,   183,    16,   130,
     158,   189,    77,    16,    81,     1,    81,   219,     1,   149,
      16,    77,   219,   219,   219,   219,   189,    81,    81,   219,
       1,   116,   219,   207,    78,   135,   176,   219,   189,    24,
      25,    26,    27,    28,    29,   162,    81,   219,   219,   219,
      16,   219,   126,   126,    81,   137,   138,   146,     1,   116,
      81,   219,    16,    81,   158,   158,   189,   158,   189,   189,
      16,   149,   156,     1,   156,   219,   219,    16,    16,   146,
     219,   116,   219,   219,   162,   162,    81,   162,    81,    81,
      24,    25,    26,    27,    28,    29,   152,    79,   154,   116,
     116,   116,   158,   158,   158,   219,   219,   189,   219,   189,
     189,    16,   207,    78,   155,    16,   134,    16,   162,   162,
     162,   156,   156,    81,   156,    81,    81,   219,    81,   219,
      16,   219,   219,   152,   152,   219,   152,   219,   219,   219,
     156,   219,   156,   156,   156,   156,   152,   152,   152,   154
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (scnr, parser, YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* This macro is provided for backward compatibility. */

#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval, scnr)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, scnr, parser); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, scanner_t *scnr, parser_t *parser)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, scnr, parser)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    scanner_t *scnr;
    parser_t *parser;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (scnr);
  YYUSE (parser);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, scanner_t *scnr, parser_t *parser)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, scnr, parser)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    scanner_t *scnr;
    parser_t *parser;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep, scnr, parser);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule, scanner_t *scnr, parser_t *parser)
#else
static void
yy_reduce_print (yyvsp, yyrule, scnr, parser)
    YYSTYPE *yyvsp;
    int yyrule;
    scanner_t *scnr;
    parser_t *parser;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       , scnr, parser);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule, scnr, parser); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  YYSIZE_T yysize1;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = 0;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                yysize1 = yysize + yytnamerr (0, yytname[yyx]);
                if (! (yysize <= yysize1
                       && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                  return 2;
                yysize = yysize1;
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  yysize1 = yysize + yystrlen (yyformat);
  if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
    return 2;
  yysize = yysize1;

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, scanner_t *scnr, parser_t *parser)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, scnr, parser)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    scanner_t *scnr;
    parser_t *parser;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (scnr);
  YYUSE (parser);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (scanner_t *scnr, parser_t *parser);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (scanner_t *scnr, parser_t *parser)
#else
int
yyparse (scnr, parser)
    scanner_t *scnr;
    parser_t *parser;
#endif
#endif
{
/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1806 of yacc.c  */
#line 177 "parser.y"
    { set_syntax_tree(parser, (yyvsp[(1) - (1)].val)); }
    break;

  case 3:

/* Line 1806 of yacc.c  */
#line 178 "parser.y"
    { set_syntax_tree(parser, (yyvsp[(2) - (2)].val));
                                  end_of_regex(scnr); }
    break;

  case 4:

/* Line 1806 of yacc.c  */
#line 181 "parser.y"
    { set_syntax_tree(parser, (yyvsp[(2) - (2)].val)); YYACCEPT; }
    break;

  case 5:

/* Line 1806 of yacc.c  */
#line 182 "parser.y"
    { internal_error("notreached"); }
    break;

  case 6:

/* Line 1806 of yacc.c  */
#line 184 "parser.y"
    { set_syntax_tree(parser, (yyvsp[(2) - (2)].val)); YYACCEPT; }
    break;

  case 7:

/* Line 1806 of yacc.c  */
#line 185 "parser.y"
    { internal_error("notreached"); }
    break;

  case 8:

/* Line 1806 of yacc.c  */
#line 186 "parser.y"
    { if (yychar == YYEOF) {
                                    parser->syntax_tree = nao;
                                    YYACCEPT;
                                  } else {
                                    yybadtok(yychar, nil);
                                    parser->syntax_tree = nil;
                                  } }
    break;

  case 9:

/* Line 1806 of yacc.c  */
#line 193 "parser.y"
    { if (yychar == YYEOF) {
                                    parser->syntax_tree = nao;
                                    YYACCEPT;
                                  } else {
                                    yybadtok(yychar, nil);
                                    parser->syntax_tree = nil;
                                  } }
    break;

  case 10:

/* Line 1806 of yacc.c  */
#line 200 "parser.y"
    { set_syntax_tree(parser, (yyvsp[(2) - (2)].val));
                                  YYACCEPT; }
    break;

  case 11:

/* Line 1806 of yacc.c  */
#line 202 "parser.y"
    { internal_error("notreached"); }
    break;

  case 12:

/* Line 1806 of yacc.c  */
#line 203 "parser.y"
    { if (yychar == YYEOF) {
                                    parser->syntax_tree = nao;
                                    YYACCEPT;
                                  } else {
                                    yybadtok(yychar, nil);
                                    parser->syntax_tree = nil;
                                  } }
    break;

  case 13:

/* Line 1806 of yacc.c  */
#line 210 "parser.y"
    { parser->syntax_tree = nil;
                                  if (parser->errors >= 8)
                                    YYABORT;
                                  yyerrok;
                                  yybadtok(yychar, nil); }
    break;

  case 14:

/* Line 1806 of yacc.c  */
#line 219 "parser.y"
    { parser->ignore = 1; }
    break;

  case 15:

/* Line 1806 of yacc.c  */
#line 220 "parser.y"
    { parser->ignore = 0;
                                                  (yyval.val) = nao; }
    break;

  case 16:

/* Line 1806 of yacc.c  */
#line 222 "parser.y"
    { parser->ignore = 1; }
    break;

  case 17:

/* Line 1806 of yacc.c  */
#line 223 "parser.y"
    { parser->ignore = 0;
                                                  (yyval.val) = nao; }
    break;

  case 18:

/* Line 1806 of yacc.c  */
#line 225 "parser.y"
    { parser->ignore = 1; }
    break;

  case 19:

/* Line 1806 of yacc.c  */
#line 226 "parser.y"
    { parser->ignore = 0;
                                                  (yyval.val) = nao; }
    break;

  case 20:

/* Line 1806 of yacc.c  */
#line 228 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 21:

/* Line 1806 of yacc.c  */
#line 229 "parser.y"
    { (yyval.val) = uref_helper(parser, (yyvsp[(2) - (2)].val)); }
    break;

  case 22:

/* Line 1806 of yacc.c  */
#line 230 "parser.y"
    { (yyval.val) = uoref_helper(parser, (yyvsp[(2) - (2)].val)); }
    break;

  case 23:

/* Line 1806 of yacc.c  */
#line 233 "parser.y"
    { parser->ignore = 1; }
    break;

  case 24:

/* Line 1806 of yacc.c  */
#line 234 "parser.y"
    { parser->ignore = 0;
                                                  (yyval.val) = nao; }
    break;

  case 25:

/* Line 1806 of yacc.c  */
#line 236 "parser.y"
    { parser->ignore = 1; }
    break;

  case 26:

/* Line 1806 of yacc.c  */
#line 237 "parser.y"
    { parser->ignore = 0;
                                                  (yyval.val) = nao; }
    break;

  case 27:

/* Line 1806 of yacc.c  */
#line 239 "parser.y"
    { parser->ignore = 1; }
    break;

  case 28:

/* Line 1806 of yacc.c  */
#line 240 "parser.y"
    { parser->ignore = 0;
                                                  (yyval.val) = nao; }
    break;

  case 29:

/* Line 1806 of yacc.c  */
#line 242 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 30:

/* Line 1806 of yacc.c  */
#line 243 "parser.y"
    { (yyval.val) = uref_helper(parser, (yyvsp[(2) - (2)].val)); }
    break;

  case 31:

/* Line 1806 of yacc.c  */
#line 244 "parser.y"
    { (yyval.val) = uoref_helper(parser, (yyvsp[(2) - (2)].val)); }
    break;

  case 32:

/* Line 1806 of yacc.c  */
#line 249 "parser.y"
    { internal_error("notreached"); }
    break;

  case 33:

/* Line 1806 of yacc.c  */
#line 250 "parser.y"
    { internal_error("notreached"); }
    break;

  case 34:

/* Line 1806 of yacc.c  */
#line 251 "parser.y"
    { internal_error("notreached"); }
    break;

  case 35:

/* Line 1806 of yacc.c  */
#line 254 "parser.y"
    { (yyval.val) = check_parse_time_action(cons((yyvsp[(1) - (1)].val), nil)); }
    break;

  case 36:

/* Line 1806 of yacc.c  */
#line 255 "parser.y"
    { (yyval.val) = check_parse_time_action(cons((yyvsp[(2) - (2)].val), (yyvsp[(1) - (2)].val)));  }
    break;

  case 37:

/* Line 1806 of yacc.c  */
#line 258 "parser.y"
    { (yyval.val) = us_nreverse((yyvsp[(1) - (1)].val)); }
    break;

  case 38:

/* Line 1806 of yacc.c  */
#line 259 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 39:

/* Line 1806 of yacc.c  */
#line 262 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil); rlc((yyval.val), (yyvsp[(1) - (1)].val)); }
    break;

  case 40:

/* Line 1806 of yacc.c  */
#line 263 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil); rlc((yyval.val), (yyvsp[(1) - (1)].val)); }
    break;

  case 41:

/* Line 1806 of yacc.c  */
#line 264 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil); rlc((yyval.val), (yyvsp[(1) - (1)].val)); }
    break;

  case 42:

/* Line 1806 of yacc.c  */
#line 265 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil); rlc((yyval.val), (yyvsp[(1) - (1)].val)); }
    break;

  case 43:

/* Line 1806 of yacc.c  */
#line 266 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil); rlc((yyval.val), (yyvsp[(1) - (1)].val)); }
    break;

  case 44:

/* Line 1806 of yacc.c  */
#line 267 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil); rlc((yyval.val), (yyvsp[(1) - (1)].val)); }
    break;

  case 45:

/* Line 1806 of yacc.c  */
#line 268 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil); rlc((yyval.val), (yyvsp[(1) - (1)].val)); }
    break;

  case 46:

/* Line 1806 of yacc.c  */
#line 269 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil); rlc((yyval.val), (yyvsp[(1) - (1)].val)); }
    break;

  case 47:

/* Line 1806 of yacc.c  */
#line 270 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil); rlc((yyval.val), (yyvsp[(1) - (1)].val)); }
    break;

  case 48:

/* Line 1806 of yacc.c  */
#line 271 "parser.y"
    { (yyval.val) = list(define_transform(parser, (yyvsp[(1) - (1)].val)), nao);
                                  rlc(car((yyval.val)), (yyvsp[(1) - (1)].val));
                                  rlc((yyval.val), (yyvsp[(1) - (1)].val)); }
    break;

  case 49:

/* Line 1806 of yacc.c  */
#line 274 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil); rlc((yyval.val), (yyvsp[(1) - (1)].val)); }
    break;

  case 50:

/* Line 1806 of yacc.c  */
#line 275 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil); rlc((yyval.val), (yyvsp[(1) - (1)].val)); }
    break;

  case 51:

/* Line 1806 of yacc.c  */
#line 276 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil); rlc((yyval.val), (yyvsp[(1) - (1)].val)); }
    break;

  case 52:

/* Line 1806 of yacc.c  */
#line 277 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 53:

/* Line 1806 of yacc.c  */
#line 280 "parser.y"
    { (yyval.val) = list(all_s, (yyvsp[(3) - (3)].val), nao);
                                          rl((yyval.val), num((yyvsp[(1) - (3)].lineno))); }
    break;

  case 54:

/* Line 1806 of yacc.c  */
#line 282 "parser.y"
    { (yyval.val) = nil;
                                          yybadtok(yychar, lit("all clause")); }
    break;

  case 55:

/* Line 1806 of yacc.c  */
#line 287 "parser.y"
    { (yyval.val) = list(some_s, (yyvsp[(5) - (5)].val), (yyvsp[(2) - (5)].val), nao);
                                          rl((yyval.val), num((yyvsp[(1) - (5)].lineno))); }
    break;

  case 56:

/* Line 1806 of yacc.c  */
#line 291 "parser.y"
    { (yyval.val) = nil;
                                          yybadtok(yychar, lit("some clause")); }
    break;

  case 57:

/* Line 1806 of yacc.c  */
#line 295 "parser.y"
    { (yyval.val) = list(none_s, (yyvsp[(3) - (3)].val), nao);
                                          rl((yyval.val), num((yyvsp[(1) - (3)].lineno))); }
    break;

  case 58:

/* Line 1806 of yacc.c  */
#line 297 "parser.y"
    { (yyval.val) = nil;
                                          yybadtok(yychar, lit("none clause")); }
    break;

  case 59:

/* Line 1806 of yacc.c  */
#line 301 "parser.y"
    { (yyval.val) = list(maybe_s, (yyvsp[(3) - (3)].val), nao);
                                          rl((yyval.val), num((yyvsp[(1) - (3)].lineno))); }
    break;

  case 60:

/* Line 1806 of yacc.c  */
#line 303 "parser.y"
    { (yyval.val) = nil;
                                          yybadtok(yychar, lit("maybe clause")); }
    break;

  case 61:

/* Line 1806 of yacc.c  */
#line 307 "parser.y"
    { (yyval.val) = list(cases_s, (yyvsp[(3) - (3)].val), nao);
                                          rl((yyval.val), num((yyvsp[(1) - (3)].lineno))); }
    break;

  case 62:

/* Line 1806 of yacc.c  */
#line 309 "parser.y"
    { (yyval.val) = nil;
                                          yybadtok(yychar, lit("cases clause")); }
    break;

  case 63:

/* Line 1806 of yacc.c  */
#line 315 "parser.y"
    { val name = first((yyvsp[(2) - (7)].val));
                                          if (gt(length((yyvsp[(2) - (7)].val)), one))
                                            yyerr("block: takes zero or no arguments");
                                          if (name && !bindable(name))
                                            yyerrorf(scnr,
                                                     lit("block: ~s is not a bindable symbol"),
                                                     name, nao);
                                          (yyval.val) = list(block_s, name, (yyvsp[(5) - (7)].val), nao);
                                          rl((yyval.val), num((yyvsp[(1) - (7)].lineno))); }
    break;

  case 64:

/* Line 1806 of yacc.c  */
#line 325 "parser.y"
    { (yyval.val) = nil;
                                          yybadtok(yychar, lit("block clause")); }
    break;

  case 65:

/* Line 1806 of yacc.c  */
#line 330 "parser.y"
    { (yyval.val) = list(choose_s, (yyvsp[(5) - (5)].val), (yyvsp[(2) - (5)].val), nao);
                                          rl((yyval.val), num((yyvsp[(1) - (5)].lineno))); }
    break;

  case 66:

/* Line 1806 of yacc.c  */
#line 333 "parser.y"
    { (yyval.val) = nil;
                                          yybadtok(yychar, lit("choose clause")); }
    break;

  case 67:

/* Line 1806 of yacc.c  */
#line 339 "parser.y"
    { val args = match_expand_keyword_args((yyvsp[(2) - (7)].val));
                                          (yyval.val) = list(gather_s,
                                                    append2(mapcar(pa_12_1(func_n2(cons), nil),
                                                                   first((yyvsp[(5) - (7)].val))), rest((yyvsp[(5) - (7)].val))),
                                                    args, nao);
                                          rl((yyval.val), num((yyvsp[(1) - (7)].lineno))); }
    break;

  case 68:

/* Line 1806 of yacc.c  */
#line 350 "parser.y"
    { val args = match_expand_keyword_args((yyvsp[(2) - (12)].val));
                                          (yyval.val) = list(gather_s,
                                                    append2(mapcar(pa_12_1(func_n2(cons), nil),
                                                                   first((yyvsp[(5) - (12)].val))), rest((yyvsp[(5) - (12)].val))),
                                                    args, cons(cdr((yyvsp[(6) - (12)].val)),
                                                             cons((yyvsp[(7) - (12)].val), (yyvsp[(10) - (12)].val))), nao);
                                          rl((yyval.val), num((yyvsp[(1) - (12)].lineno))); }
    break;

  case 69:

/* Line 1806 of yacc.c  */
#line 359 "parser.y"
    { (yyval.val) = nil;
                                          yybadtok(yychar, lit("gather clause")); }
    break;

  case 70:

/* Line 1806 of yacc.c  */
#line 364 "parser.y"
    { (yyval.val) = if2((yyvsp[(1) - (2)].val), cons((yyvsp[(1) - (2)].val), (yyvsp[(2) - (2)].val))); }
    break;

  case 71:

/* Line 1806 of yacc.c  */
#line 367 "parser.y"
    { (yyval.val) = (yyvsp[(3) - (3)].val); }
    break;

  case 72:

/* Line 1806 of yacc.c  */
#line 368 "parser.y"
    { (yyval.val) = (yyvsp[(3) - (3)].val); }
    break;

  case 73:

/* Line 1806 of yacc.c  */
#line 369 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 74:

/* Line 1806 of yacc.c  */
#line 373 "parser.y"
    { val args = match_expand_keyword_args((yyvsp[(2) - (7)].val));
                                            (yyval.val) = list(car((yyvsp[(1) - (7)].val)),
                                                      (yyvsp[(5) - (7)].val), nil, args,
                                                      nao);
                                            rl((yyval.val), cdr((yyvsp[(1) - (7)].val))); }
    break;

  case 75:

/* Line 1806 of yacc.c  */
#line 381 "parser.y"
    { val args = match_expand_keyword_args((yyvsp[(2) - (12)].val));
                                            if (nilp((yyvsp[(10) - (12)].val)))
                                              yyerr("empty until/last in collect");
                                            (yyval.val) = list(car((yyvsp[(1) - (12)].val)), (yyvsp[(5) - (12)].val),
                                                      cons(cdr((yyvsp[(6) - (12)].val)),
                                                           cons((yyvsp[(7) - (12)].val), (yyvsp[(10) - (12)].val))),
                                                      args, nao);
                                            rl((yyval.val), cdr((yyvsp[(1) - (12)].val)));
                                            rl((yyvsp[(10) - (12)].val), car((yyvsp[(6) - (12)].val))); }
    break;

  case 76:

/* Line 1806 of yacc.c  */
#line 391 "parser.y"
    { (yyval.val) = nil;
                                          yybadtok(yychar, lit("collect clause")); }
    break;

  case 77:

/* Line 1806 of yacc.c  */
#line 395 "parser.y"
    { (yyval.val) = cons(collect_s, num((yyvsp[(1) - (1)].lineno))); }
    break;

  case 78:

/* Line 1806 of yacc.c  */
#line 396 "parser.y"
    { (yyval.val) = cons(repeat_s, num((yyvsp[(1) - (1)].lineno))); }
    break;

  case 79:

/* Line 1806 of yacc.c  */
#line 399 "parser.y"
    { (yyval.val) = cons(num((yyvsp[(1) - (1)].lineno)), until_s); }
    break;

  case 80:

/* Line 1806 of yacc.c  */
#line 400 "parser.y"
    { (yyval.val) = cons(num((yyvsp[(1) - (1)].lineno)), last_s); }
    break;

  case 81:

/* Line 1806 of yacc.c  */
#line 403 "parser.y"
    { (yyval.val) = if2((yyvsp[(1) - (2)].val), cons((yyvsp[(1) - (2)].val), (yyvsp[(2) - (2)].val))); }
    break;

  case 82:

/* Line 1806 of yacc.c  */
#line 406 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 83:

/* Line 1806 of yacc.c  */
#line 407 "parser.y"
    { (yyval.val) = (yyvsp[(3) - (3)].val); }
    break;

  case 84:

/* Line 1806 of yacc.c  */
#line 408 "parser.y"
    { (yyval.val) = (yyvsp[(3) - (3)].val); }
    break;

  case 85:

/* Line 1806 of yacc.c  */
#line 415 "parser.y"
    { if (opt_compat && opt_compat <= 136)
                                  { val xexp = expand_meta((yyvsp[(2) - (9)].val), nil);
                                    val req = rlc(cons(require_s, xexp), (yyvsp[(2) - (9)].val));
                                    val iff = rlc(cons(cons(cons(req, nil), (yyvsp[(5) - (9)].val)), nil), (yyvsp[(2) - (9)].val));
                                    val elifs = (yyvsp[(6) - (9)].val);
                                    val els = cons((yyvsp[(7) - (9)].val), nil);
                                    val cases = nappend2(nappend2(iff, elifs), els);
                                    (yyval.val) = list(cases_s, cases, nao); }
                                  else
                                  { val expr = expand(car((yyvsp[(2) - (9)].val)), nil);
                                    val ifs = (yyvsp[(5) - (9)].val);
                                    val branch = cons(cons(expr, ifs), nil);
                                    val elifs = (yyvsp[(6) - (9)].val);
                                    val els = (yyvsp[(7) - (9)].val);
                                    if (cdr((yyvsp[(2) - (9)].val)))
                                      yyerr("extra expression in if");
                                    (yyval.val) = cons(if_s,
                                              nappend2(branch, nappend2(elifs, els)));
                                    rl((yyval.val), num((yyvsp[(1) - (9)].lineno))); } }
    break;

  case 86:

/* Line 1806 of yacc.c  */
#line 435 "parser.y"
    { (yyval.val) = nil; yybadtok(yychar, lit("if clause")); }
    break;

  case 87:

/* Line 1806 of yacc.c  */
#line 440 "parser.y"
    { if (opt_compat && opt_compat <= 136)
                                       { val xexp = expand_meta((yyvsp[(2) - (6)].val), nil);
                                         val req = rlc(cons(require_s, xexp), (yyvsp[(2) - (6)].val));
                                         (yyval.val) = cons(cons(cons(req, nil), (yyvsp[(5) - (6)].val)), (yyvsp[(6) - (6)].val)); }
                                       else
                                       { val expr = expand(car((yyvsp[(2) - (6)].val)), nil);
                                         val elifs = (yyvsp[(5) - (6)].val);
                                         val branch = cons(cons(expr, elifs), nil);
                                         if (cdr((yyvsp[(2) - (6)].val)))
                                           yyerr("extra expression in elif");
                                         (yyval.val) = nappend2(branch, (yyvsp[(6) - (6)].val)); } }
    break;

  case 88:

/* Line 1806 of yacc.c  */
#line 451 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 89:

/* Line 1806 of yacc.c  */
#line 455 "parser.y"
    { if (opt_compat && opt_compat <= 136)
                                       { (yyval.val) = (yyvsp[(3) - (3)].val); }
                                       else
                                       { (yyval.val) = cons(cons(t, (yyvsp[(3) - (3)].val)), nil); } }
    break;

  case 90:

/* Line 1806 of yacc.c  */
#line 459 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 91:

/* Line 1806 of yacc.c  */
#line 462 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (2)].val); }
    break;

  case 92:

/* Line 1806 of yacc.c  */
#line 465 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 93:

/* Line 1806 of yacc.c  */
#line 466 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 94:

/* Line 1806 of yacc.c  */
#line 469 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil);
                                  rlc((yyval.val), (yyvsp[(1) - (1)].val)); }
    break;

  case 95:

/* Line 1806 of yacc.c  */
#line 471 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (2)].val), (yyvsp[(2) - (2)].val));
                                  rlc((yyval.val), (yyvsp[(1) - (2)].val)); }
    break;

  case 96:

/* Line 1806 of yacc.c  */
#line 476 "parser.y"
    { (yyval.val) = rl(string_own((yyvsp[(1) - (1)].lexeme)), num(parser->lineno)); }
    break;

  case 97:

/* Line 1806 of yacc.c  */
#line 477 "parser.y"
    { if ((yyvsp[(1) - (1)].lexeme)[0] == ' ' && (yyvsp[(1) - (1)].lexeme)[1] == 0)
                                  { val spaces = list(oneplus_s,
                                                      chr(' '), nao);
                                    free((yyvsp[(1) - (1)].lexeme));
                                    (yyval.val) = regex_compile(spaces, nil);
                                    rl((yyval.val), num(parser->lineno)); }
                                  else
                                  { (yyval.val) = rl(string_own((yyvsp[(1) - (1)].lexeme)), num(parser->lineno)); }}
    break;

  case 98:

/* Line 1806 of yacc.c  */
#line 485 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val);
                                  rl((yyval.val), num(parser->lineno)); }
    break;

  case 99:

/* Line 1806 of yacc.c  */
#line 487 "parser.y"
    { (yyval.val) = null_string; }
    break;

  case 100:

/* Line 1806 of yacc.c  */
#line 490 "parser.y"
    { (yyval.val) = rlc(cons((yyvsp[(1) - (1)].val), nil), (yyvsp[(1) - (1)].val)); }
    break;

  case 101:

/* Line 1806 of yacc.c  */
#line 491 "parser.y"
    { (yyval.val) = rlc(cons((yyvsp[(1) - (2)].val), (yyvsp[(2) - (2)].val)), (yyvsp[(2) - (2)].val)); }
    break;

  case 102:

/* Line 1806 of yacc.c  */
#line 494 "parser.y"
    { (yyval.val) = rlc(cons(text_s, (yyvsp[(1) - (1)].val)), (yyvsp[(1) - (1)].val));
                                  (yyval.val) = rlc(optimize_text((yyval.val)), (yyval.val)); }
    break;

  case 103:

/* Line 1806 of yacc.c  */
#line 496 "parser.y"
    { (yyval.val) = rl((yyvsp[(1) - (1)].val), num(parser->lineno));
                                  match_reg_elem((yyval.val)); }
    break;

  case 104:

/* Line 1806 of yacc.c  */
#line 498 "parser.y"
    { val sym = first((yyvsp[(1) - (1)].val));
                                  if (sym ==  do_s || sym == require_s)
                                    (yyval.val) = rlc(cons(sym,
                                                   expand_forms(rest((yyvsp[(1) - (1)].val)), nil)),
                                              (yyvsp[(1) - (1)].val));
                                  else if (sym == mdo_s)
                                  { eval_intrinsic(cons(progn_s, cdr((yyvsp[(1) - (1)].val))), nil, nil);
                                    (yyval.val) = cons(do_s, nil); }
                                  else
                                  { (yyval.val) = match_expand_elem((yyvsp[(1) - (1)].val));
                                    match_reg_elem((yyval.val)); } }
    break;

  case 105:

/* Line 1806 of yacc.c  */
#line 509 "parser.y"
    { val args = match_expand_keyword_args((yyvsp[(2) - (5)].val));
                                          (yyval.val) = list(coll_s, (yyvsp[(4) - (5)].val), nil, args, nao);
                                          rl((yyval.val), num((yyvsp[(1) - (5)].lineno))); }
    break;

  case 106:

/* Line 1806 of yacc.c  */
#line 514 "parser.y"
    { val args = match_expand_keyword_args((yyvsp[(2) - (9)].val));
                                  (yyval.val) = list(coll_s, (yyvsp[(4) - (9)].val), cons(cdr((yyvsp[(5) - (9)].val)),
                                                             cons((yyvsp[(6) - (9)].val), (yyvsp[(8) - (9)].val))),
                                            args, nao);
                                  rl((yyval.val), num((yyvsp[(1) - (9)].lineno)));
                                  rl((yyvsp[(6) - (9)].val), car((yyvsp[(5) - (9)].val))); }
    break;

  case 107:

/* Line 1806 of yacc.c  */
#line 520 "parser.y"
    { val args = match_expand_keyword_args((yyvsp[(2) - (5)].val));
                                         (yyval.val) = list(rep_s, (yyvsp[(4) - (5)].val), nil, args, nao);
                                         rl((yyval.val), num((yyvsp[(1) - (5)].lineno))); }
    break;

  case 108:

/* Line 1806 of yacc.c  */
#line 526 "parser.y"
    { val args = match_expand_keyword_args((yyvsp[(2) - (9)].val));
                                  (yyval.val) = list(rep_s, (yyvsp[(4) - (9)].val), cons(cdr((yyvsp[(5) - (9)].val)),
                                                            cons((yyvsp[(6) - (9)].val), (yyvsp[(8) - (9)].val))),
                                            args, nao);
                                  rl((yyval.val), num((yyvsp[(1) - (9)].lineno)));
                                  rl((yyvsp[(6) - (9)].val), car((yyvsp[(5) - (9)].val))); }
    break;

  case 109:

/* Line 1806 of yacc.c  */
#line 532 "parser.y"
    { (yyval.val) = list(block_s, car((yyvsp[(2) - (5)].val)),
                                                 cons((yyvsp[(4) - (5)].val), nil), nao);
                                       rl((yyval.val), num((yyvsp[(1) - (5)].lineno))); }
    break;

  case 110:

/* Line 1806 of yacc.c  */
#line 535 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("coll clause")); }
    break;

  case 111:

/* Line 1806 of yacc.c  */
#line 537 "parser.y"
    { (yyval.val) = nil;
                                 yybadtok(yychar, lit("rep clause")); }
    break;

  case 112:

/* Line 1806 of yacc.c  */
#line 539 "parser.y"
    { (yyval.val) = nil;
                                 yybadtok(yychar, lit("rep clause")); }
    break;

  case 113:

/* Line 1806 of yacc.c  */
#line 541 "parser.y"
    { (yyval.val) = rl(list(all_s, t, (yyvsp[(2) - (2)].val), nao), num((yyvsp[(1) - (2)].lineno))); }
    break;

  case 114:

/* Line 1806 of yacc.c  */
#line 543 "parser.y"
    { (yyval.val) = rl(list(some_s, t, (yyvsp[(4) - (4)].val), (yyvsp[(2) - (4)].val), nao), num((yyvsp[(1) - (4)].lineno))); }
    break;

  case 115:

/* Line 1806 of yacc.c  */
#line 544 "parser.y"
    { (yyval.val) = rl(list(none_s, t, (yyvsp[(2) - (2)].val), nao), num((yyvsp[(1) - (2)].lineno))); }
    break;

  case 116:

/* Line 1806 of yacc.c  */
#line 545 "parser.y"
    { (yyval.val) = rl(list(maybe_s, t, (yyvsp[(2) - (2)].val), nao), num((yyvsp[(1) - (2)].lineno))); }
    break;

  case 117:

/* Line 1806 of yacc.c  */
#line 546 "parser.y"
    { (yyval.val) = rl(list(cases_s, t, (yyvsp[(2) - (2)].val), nao), num((yyvsp[(1) - (2)].lineno))); }
    break;

  case 118:

/* Line 1806 of yacc.c  */
#line 548 "parser.y"
    { (yyval.val) = list(choose_s, t, (yyvsp[(4) - (4)].val), (yyvsp[(2) - (4)].val), nao);
                                  rl((yyval.val), num((yyvsp[(1) - (4)].lineno))); }
    break;

  case 119:

/* Line 1806 of yacc.c  */
#line 551 "parser.y"
    { (yyval.val) = list(define_s, t, (yyvsp[(4) - (5)].val), (yyvsp[(2) - (5)].val), nao);
                                  rl((yyval.val), num((yyvsp[(1) - (5)].lineno)));
                                  match_reg_params(second((yyvsp[(2) - (5)].val))); }
    break;

  case 120:

/* Line 1806 of yacc.c  */
#line 556 "parser.y"
    { (yyval.val) = if2((yyvsp[(1) - (2)].val), cons((yyvsp[(1) - (2)].val), (yyvsp[(2) - (2)].val))); }
    break;

  case 121:

/* Line 1806 of yacc.c  */
#line 559 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 122:

/* Line 1806 of yacc.c  */
#line 560 "parser.y"
    { (yyval.val) = (yyvsp[(2) - (2)].val); }
    break;

  case 123:

/* Line 1806 of yacc.c  */
#line 561 "parser.y"
    { (yyval.val) = (yyvsp[(2) - (2)].val); }
    break;

  case 124:

/* Line 1806 of yacc.c  */
#line 566 "parser.y"
    { (yyval.val) = list(define_s, (yyvsp[(2) - (7)].val), (yyvsp[(5) - (7)].val), nao);
                                  rl((yyval.val), num((yyvsp[(1) - (7)].lineno)));
                                  match_reg_params(second((yyvsp[(2) - (7)].val))); }
    break;

  case 125:

/* Line 1806 of yacc.c  */
#line 571 "parser.y"
    { (yyval.val) = list(define_s, nil, (yyvsp[(4) - (6)].val), nao);
                                  rl((yyval.val), num((yyvsp[(1) - (6)].lineno))); }
    break;

  case 126:

/* Line 1806 of yacc.c  */
#line 573 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("define directive")); }
    break;

  case 127:

/* Line 1806 of yacc.c  */
#line 576 "parser.y"
    { (yyval.val) = nil; yybadtok(yychar, lit("define")); }
    break;

  case 128:

/* Line 1806 of yacc.c  */
#line 578 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("define")); }
    break;

  case 129:

/* Line 1806 of yacc.c  */
#line 585 "parser.y"
    { (yyval.val) = list(try_s,
                                            flatten(mapcar(func_n1(second),
                                                           (yyvsp[(4) - (6)].val))),
                                            (yyvsp[(3) - (6)].val), (yyvsp[(4) - (6)].val), nao);
                                  rl((yyval.val), num((yyvsp[(1) - (6)].lineno))); }
    break;

  case 130:

/* Line 1806 of yacc.c  */
#line 591 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("try clause")); }
    break;

  case 131:

/* Line 1806 of yacc.c  */
#line 597 "parser.y"
    { (yyval.val) = cons(list(catch_s, cons(t, nil),
                                                         (yyvsp[(4) - (5)].val), nao), (yyvsp[(5) - (5)].val));
                                          rl((yyval.val), num((yyvsp[(1) - (5)].lineno))); }
    break;

  case 132:

/* Line 1806 of yacc.c  */
#line 602 "parser.y"
    { (yyval.val) = cons(list(catch_s, (yyvsp[(2) - (6)].val), (yyvsp[(5) - (6)].val), nao),
                                                    (yyvsp[(6) - (6)].val));
                                          process_catch_exprs((yyvsp[(2) - (6)].val));
                                          rl((yyval.val), num((yyvsp[(1) - (6)].lineno))); }
    break;

  case 133:

/* Line 1806 of yacc.c  */
#line 607 "parser.y"
    { (yyval.val) = cons(list(finally_s, nil,
                                                         (yyvsp[(3) - (3)].val), nao),
                                                    nil);
                                          rl((yyval.val), num((yyvsp[(1) - (3)].lineno))); }
    break;

  case 134:

/* Line 1806 of yacc.c  */
#line 611 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 135:

/* Line 1806 of yacc.c  */
#line 613 "parser.y"
    { (yyval.val) = nil;
                                          yybadtok(yychar, lit("catch clause")); }
    break;

  case 136:

/* Line 1806 of yacc.c  */
#line 616 "parser.y"
    { (yyval.val) = nil;
                                          yybadtok(yychar, lit("catch clause")); }
    break;

  case 137:

/* Line 1806 of yacc.c  */
#line 619 "parser.y"
    { (yyval.val) = nil;
                                          yybadtok(yychar, lit("finally clause")); }
    break;

  case 138:

/* Line 1806 of yacc.c  */
#line 626 "parser.y"
    { (yyval.val) = nil;
                                  yyerrorf(scnr, lit("~a: traling material"),
                                           car((yyvsp[(1) - (7)].val)), nao); }
    break;

  case 139:

/* Line 1806 of yacc.c  */
#line 630 "parser.y"
    { (yyval.val) = rl(list(car((yyvsp[(1) - (5)].val)), nao), (yyvsp[(1) - (5)].val)); }
    break;

  case 140:

/* Line 1806 of yacc.c  */
#line 633 "parser.y"
    { (yyval.val) = rl(list(car((yyvsp[(1) - (6)].val)), (yyvsp[(4) - (6)].val), nao), (yyvsp[(1) - (6)].val)); }
    break;

  case 141:

/* Line 1806 of yacc.c  */
#line 636 "parser.y"
    { (yyval.val) = output_helper(parser, car((yyvsp[(1) - (7)].val)), (yyvsp[(2) - (7)].val), (yyvsp[(5) - (7)].val));
                                  rl((yyval.val), (yyvsp[(1) - (7)].val)); }
    break;

  case 142:

/* Line 1806 of yacc.c  */
#line 640 "parser.y"
    { (yyval.val) = nil;
                                  yyerr("invalid combination of old and "
                                        "new syntax in output directive"); }
    break;

  case 143:

/* Line 1806 of yacc.c  */
#line 643 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("output directive")); }
    break;

  case 144:

/* Line 1806 of yacc.c  */
#line 646 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("output clause")); }
    break;

  case 145:

/* Line 1806 of yacc.c  */
#line 649 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("output clause")); }
    break;

  case 146:

/* Line 1806 of yacc.c  */
#line 652 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("output clause")); }
    break;

  case 147:

/* Line 1806 of yacc.c  */
#line 655 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("output clause")); }
    break;

  case 148:

/* Line 1806 of yacc.c  */
#line 659 "parser.y"
    { (yyval.val) = cons(output_s, num((yyvsp[(1) - (1)].lineno))); }
    break;

  case 149:

/* Line 1806 of yacc.c  */
#line 660 "parser.y"
    { (yyval.val) = cons(push_s, num((yyvsp[(1) - (1)].lineno))); }
    break;

  case 150:

/* Line 1806 of yacc.c  */
#line 663 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil); }
    break;

  case 151:

/* Line 1806 of yacc.c  */
#line 664 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (2)].val), (yyvsp[(2) - (2)].val));  }
    break;

  case 152:

/* Line 1806 of yacc.c  */
#line 667 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil); }
    break;

  case 153:

/* Line 1806 of yacc.c  */
#line 668 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil); }
    break;

  case 154:

/* Line 1806 of yacc.c  */
#line 669 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 155:

/* Line 1806 of yacc.c  */
#line 675 "parser.y"
    { (yyval.val) = repeat_rep_helper(repeat_s,
                                                                 (yyvsp[(2) - (8)].val), (yyvsp[(5) - (8)].val), (yyvsp[(6) - (8)].val));
                                          rl((yyval.val), num((yyvsp[(1) - (8)].lineno))); }
    break;

  case 156:

/* Line 1806 of yacc.c  */
#line 679 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("repeat clause")); }
    break;

  case 157:

/* Line 1806 of yacc.c  */
#line 685 "parser.y"
    { (yyval.val) = cons(cons(single_s, (yyvsp[(3) - (4)].val)), (yyvsp[(4) - (4)].val));
                                          rl((yyval.val), num((yyvsp[(1) - (4)].lineno))); }
    break;

  case 158:

/* Line 1806 of yacc.c  */
#line 689 "parser.y"
    { (yyval.val) = cons(cons(first_s, (yyvsp[(3) - (4)].val)), (yyvsp[(4) - (4)].val));
                                          rl((yyval.val), num((yyvsp[(1) - (4)].lineno))); }
    break;

  case 159:

/* Line 1806 of yacc.c  */
#line 693 "parser.y"
    { if ((yyvsp[(2) - (6)].val))
                                            yyerrorf(scnr,
                                                     lit("last: in output, "
                                                         "takes no arguments"),
                                                     nao);
                                          (yyval.val) = cons(cons(last_s, (yyvsp[(5) - (6)].val)), (yyvsp[(6) - (6)].val));
                                          rl((yyval.val), num((yyvsp[(1) - (6)].lineno))); }
    break;

  case 160:

/* Line 1806 of yacc.c  */
#line 702 "parser.y"
    { (yyval.val) = cons(cons(empty_s, (yyvsp[(3) - (4)].val)), (yyvsp[(4) - (4)].val));
                                          rl((yyval.val), num((yyvsp[(1) - (4)].lineno))); }
    break;

  case 161:

/* Line 1806 of yacc.c  */
#line 707 "parser.y"
    { (yyval.val) = cons(cons(mod_s,
                                                         cons(expand_forms_ver((yyvsp[(2) - (6)].val), 166),
                                                              (yyvsp[(5) - (6)].val))), (yyvsp[(6) - (6)].val));
                                          rl((yyval.val), num((yyvsp[(1) - (6)].lineno))); }
    break;

  case 162:

/* Line 1806 of yacc.c  */
#line 714 "parser.y"
    { (yyval.val) = cons(cons(modlast_s,
                                                         cons(expand_forms_ver((yyvsp[(2) - (6)].val), 166),
                                                              (yyvsp[(5) - (6)].val))), (yyvsp[(6) - (6)].val));
                                          rl((yyval.val), num((yyvsp[(1) - (6)].lineno))); }
    break;

  case 163:

/* Line 1806 of yacc.c  */
#line 718 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 164:

/* Line 1806 of yacc.c  */
#line 725 "parser.y"
    { val expr = expand((yyvsp[(2) - (9)].val), nil);
                                  val ifs = (yyvsp[(5) - (9)].val);
                                  val branch = cons(cons(expr, ifs), nil);
                                  val elifs = (yyvsp[(6) - (9)].val);
                                  val els = (yyvsp[(7) - (9)].val);
                                  (yyval.val) = cons(if_s,
                                            nappend2(branch, nappend2(elifs, els)));
                                  rl((yyval.val), num((yyvsp[(1) - (9)].lineno))); }
    break;

  case 165:

/* Line 1806 of yacc.c  */
#line 734 "parser.y"
    { (yyval.val) = nil;
                                  yyerr("if requires expression"); }
    break;

  case 166:

/* Line 1806 of yacc.c  */
#line 737 "parser.y"
    { (yyval.val) = nil; yybadtok(yychar, lit("if clause")); }
    break;

  case 167:

/* Line 1806 of yacc.c  */
#line 743 "parser.y"
    { val expr = expand(car((yyvsp[(2) - (6)].val)), nil);
                                  val elifs = (yyvsp[(5) - (6)].val);
                                  val branch = cons(cons(expr, elifs), nil);
                                  if (null((yyvsp[(2) - (6)].val)))
                                    yyerr("elif requires expression");
                                  else if (cdr((yyvsp[(2) - (6)].val)))
                                    yyerr("extra expression in elif");
                                  (yyval.val) = nappend2(branch, (yyvsp[(6) - (6)].val)); }
    break;

  case 168:

/* Line 1806 of yacc.c  */
#line 751 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 169:

/* Line 1806 of yacc.c  */
#line 756 "parser.y"
    { (yyval.val) = cons(cons(t, (yyvsp[(3) - (3)].val)), nil); }
    break;

  case 170:

/* Line 1806 of yacc.c  */
#line 757 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 171:

/* Line 1806 of yacc.c  */
#line 760 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 172:

/* Line 1806 of yacc.c  */
#line 761 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 173:

/* Line 1806 of yacc.c  */
#line 763 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (2)].val); }
    break;

  case 174:

/* Line 1806 of yacc.c  */
#line 766 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val);
                                  rl((yyval.val), num(parser->lineno)); }
    break;

  case 175:

/* Line 1806 of yacc.c  */
#line 768 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 176:

/* Line 1806 of yacc.c  */
#line 771 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil); }
    break;

  case 177:

/* Line 1806 of yacc.c  */
#line 772 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (2)].val), (yyvsp[(2) - (2)].val)); }
    break;

  case 178:

/* Line 1806 of yacc.c  */
#line 773 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil); }
    break;

  case 179:

/* Line 1806 of yacc.c  */
#line 774 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (2)].val), (yyvsp[(2) - (2)].val)); }
    break;

  case 180:

/* Line 1806 of yacc.c  */
#line 777 "parser.y"
    { (yyval.val) = string_own((yyvsp[(1) - (1)].lexeme));
                                  rl((yyval.val), num(parser->lineno)); }
    break;

  case 181:

/* Line 1806 of yacc.c  */
#line 779 "parser.y"
    { (yyval.val) = string_own((yyvsp[(1) - (1)].lexeme));
                                  rl((yyval.val), num(parser->lineno)); }
    break;

  case 182:

/* Line 1806 of yacc.c  */
#line 781 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 183:

/* Line 1806 of yacc.c  */
#line 782 "parser.y"
    { (yyval.val) = rlc(list(expr_s,
                                                 expand((yyvsp[(1) - (1)].val), nil), nao), (yyvsp[(1) - (1)].val)); }
    break;

  case 184:

/* Line 1806 of yacc.c  */
#line 784 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 185:

/* Line 1806 of yacc.c  */
#line 788 "parser.y"
    { (yyval.val) = repeat_rep_helper(rep_s, (yyvsp[(2) - (6)].val), (yyvsp[(4) - (6)].val), (yyvsp[(5) - (6)].val));
                                  rl((yyval.val), num((yyvsp[(1) - (6)].lineno))); }
    break;

  case 186:

/* Line 1806 of yacc.c  */
#line 790 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("rep clause")); }
    break;

  case 187:

/* Line 1806 of yacc.c  */
#line 795 "parser.y"
    { (yyval.val) = cons(cons(single_s, (yyvsp[(2) - (3)].val)), (yyvsp[(3) - (3)].val));
                                          rl((yyval.val), num((yyvsp[(1) - (3)].lineno))); }
    break;

  case 188:

/* Line 1806 of yacc.c  */
#line 798 "parser.y"
    { (yyval.val) = cons(cons(first_s, (yyvsp[(2) - (3)].val)), (yyvsp[(3) - (3)].val));
                                          rl((yyval.val), num((yyvsp[(1) - (3)].lineno))); }
    break;

  case 189:

/* Line 1806 of yacc.c  */
#line 801 "parser.y"
    { if ((yyvsp[(2) - (5)].val))
                                            yyerrorf(scnr,
                                                     lit("last: in output, "
                                                         "takes no arguments"),
                                                     nao);
                                          (yyval.val) = cons(cons(last_s, (yyvsp[(4) - (5)].val)), (yyvsp[(5) - (5)].val));
                                          rl((yyval.val), num((yyvsp[(1) - (5)].lineno))); }
    break;

  case 190:

/* Line 1806 of yacc.c  */
#line 809 "parser.y"
    { (yyval.val) = cons(cons(empty_s, (yyvsp[(2) - (3)].val)), (yyvsp[(3) - (3)].val));
                                          rl((yyval.val), num((yyvsp[(1) - (3)].lineno))); }
    break;

  case 191:

/* Line 1806 of yacc.c  */
#line 813 "parser.y"
    { (yyval.val) = cons(cons(mod_s,
                                                         cons(expand_forms_ver((yyvsp[(2) - (5)].val), 166),
                                                              (yyvsp[(4) - (5)].val))), (yyvsp[(5) - (5)].val));
                                          rl((yyval.val), num((yyvsp[(1) - (5)].lineno))); }
    break;

  case 192:

/* Line 1806 of yacc.c  */
#line 819 "parser.y"
    { (yyval.val) = cons(cons(modlast_s,
                                                         cons(expand_forms_ver((yyvsp[(2) - (5)].val), 166),
                                                              (yyvsp[(4) - (5)].val))), (yyvsp[(5) - (5)].val));
                                          rl((yyval.val), num((yyvsp[(1) - (5)].lineno))); }
    break;

  case 193:

/* Line 1806 of yacc.c  */
#line 823 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 194:

/* Line 1806 of yacc.c  */
#line 830 "parser.y"
    { (yyval.val) = list(var_s, symhlpr((yyvsp[(1) - (1)].lexeme), nil), nao); }
    break;

  case 195:

/* Line 1806 of yacc.c  */
#line 831 "parser.y"
    { (yyval.val) = list(var_s, symhlpr((yyvsp[(2) - (3)].lexeme), nil), nao); }
    break;

  case 196:

/* Line 1806 of yacc.c  */
#line 832 "parser.y"
    { (yyval.val) = list(var_s, symhlpr((yyvsp[(2) - (4)].lexeme), nil), (yyvsp[(3) - (4)].val), nao); }
    break;

  case 197:

/* Line 1806 of yacc.c  */
#line 833 "parser.y"
    { (yyval.val) = list(var_s, symhlpr((yyvsp[(2) - (2)].lexeme), nil), (yyvsp[(1) - (2)].val), nao); }
    break;

  case 198:

/* Line 1806 of yacc.c  */
#line 834 "parser.y"
    { (yyval.val) = list(var_s, symhlpr((yyvsp[(3) - (4)].lexeme), nil), (yyvsp[(1) - (4)].val), nao); }
    break;

  case 199:

/* Line 1806 of yacc.c  */
#line 835 "parser.y"
    { (yyval.val) = nil;
                                          free((yyvsp[(3) - (5)].lexeme));
                                          yyerr("longest match "
                                                "not useable with regex"); }
    break;

  case 200:

/* Line 1806 of yacc.c  */
#line 839 "parser.y"
    { (yyval.val) = nil;
                                          free((yyvsp[(3) - (5)].lexeme));
                                          yyerr("longest match "
                                                "not useable with "
                                                "fixed width match"); }
    break;

  case 201:

/* Line 1806 of yacc.c  */
#line 844 "parser.y"
    { (yyval.val) = nil;
                                  free((yyvsp[(1) - (2)].lexeme));
                                  yybadtok(yychar, lit("variable spec")); }
    break;

  case 202:

/* Line 1806 of yacc.c  */
#line 847 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("variable spec")); }
    break;

  case 203:

/* Line 1806 of yacc.c  */
#line 851 "parser.y"
    { (yyval.val) = list(t, nao); }
    break;

  case 204:

/* Line 1806 of yacc.c  */
#line 854 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil); }
    break;

  case 205:

/* Line 1806 of yacc.c  */
#line 855 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil);
                                  rlc((yyval.val), (yyvsp[(1) - (1)].val)); }
    break;

  case 206:

/* Line 1806 of yacc.c  */
#line 857 "parser.y"
    { (yyval.val) = rlc(cons(expand_meta((yyvsp[(1) - (1)].val), nil),
                                                 nil), (yyvsp[(1) - (1)].val)); }
    break;

  case 207:

/* Line 1806 of yacc.c  */
#line 859 "parser.y"
    { (yyval.val) = cons(symhlpr((yyvsp[(1) - (1)].lexeme), nil), nil); }
    break;

  case 208:

/* Line 1806 of yacc.c  */
#line 862 "parser.y"
    { val expr = symhlpr((yyvsp[(1) - (1)].lexeme), nil);
                                  if (!opt_compat || opt_compat > 128)
                                    expr = expand(expr, nil);
                                  (yyval.val) = list(var_s, expr, nao);
                                  rl((yyval.val), num(parser->lineno)); }
    break;

  case 209:

/* Line 1806 of yacc.c  */
#line 868 "parser.y"
    { if (opt_compat && opt_compat <= 128)
                                  { (yyval.val) = list(var_s,
                                              expand_meta((yyvsp[(2) - (4)].val), nil),
                                              expand_meta((yyvsp[(3) - (4)].val), nil), nao); }
                                  else
                                  { val quasi_var = list(var_s, (yyvsp[(2) - (4)].val), (yyvsp[(3) - (4)].val), nao);
                                    val quasi_items = cons(quasi_var, nil);
                                    (yyval.val) = car(expand_quasi(quasi_items, nil)); } }
    break;

  case 210:

/* Line 1806 of yacc.c  */
#line 876 "parser.y"
    { (yyval.val) = nil;
                                  free((yyvsp[(1) - (2)].lexeme));
                                  yybadtok(yychar, lit("variable spec")); }
    break;

  case 211:

/* Line 1806 of yacc.c  */
#line 882 "parser.y"
    { (yyval.val) = list(var_s, (yyvsp[(3) - (5)].val), (yyvsp[(4) - (5)].val), nao);
                                  rl((yyval.val), num(parser->lineno)); }
    break;

  case 212:

/* Line 1806 of yacc.c  */
#line 884 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("variable spec")); }
    break;

  case 213:

/* Line 1806 of yacc.c  */
#line 889 "parser.y"
    { if (parser->quasi_level > 0)
                                    (yyval.val) = rlc(cons(vector_lit_s,
                                                   cons((yyvsp[(2) - (2)].val), nil)), (yyvsp[(2) - (2)].val));
                                  else
                                    (yyval.val) = rlc(vec_list((yyvsp[(2) - (2)].val)), (yyvsp[(2) - (2)].val)); }
    break;

  case 214:

/* Line 1806 of yacc.c  */
#line 894 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("unassigned/reserved # notation")); }
    break;

  case 215:

/* Line 1806 of yacc.c  */
#line 898 "parser.y"
    { if (parser->ignore)
                                    (yyval.val) = nil;
                                  else if (parser->quasi_level > 0)
                                    (yyval.val) = rl(cons(hash_lit_s, (yyvsp[(2) - (2)].val)), num((yyvsp[(1) - (2)].lineno)));
                                  else
                                    (yyval.val) = rl(hash_construct(first((yyvsp[(2) - (2)].val)),
                                                             rest((yyvsp[(2) - (2)].val))),
                                            num((yyvsp[(1) - (2)].lineno))); }
    break;

  case 216:

/* Line 1806 of yacc.c  */
#line 906 "parser.y"
    { (yyval.val) = nil;
                                    yybadtok(yychar, lit("hash literal")); }
    break;

  case 217:

/* Line 1806 of yacc.c  */
#line 910 "parser.y"
    {  if (parser->ignore)
                                   { (yyval.val) = nil; }
                                   else if ((parser->quasi_level > 0) ||
                                           (parser->read_unknown_structs &&
                                            !find_struct_type(first((yyvsp[(2) - (2)].val)))))
                                  { (yyval.val) = rl(cons(struct_lit_s, (yyvsp[(2) - (2)].val)), num((yyvsp[(1) - (2)].lineno))); }
                                  else
                                  { val strct = make_struct_lit(first((yyvsp[(2) - (2)].val)),
                                                                rest((yyvsp[(2) - (2)].val)));
                                    (yyval.val) = rl(strct, num((yyvsp[(1) - (2)].lineno))); } }
    break;

  case 218:

/* Line 1806 of yacc.c  */
#line 920 "parser.y"
    { (yyval.val) = nil;
                                    yybadtok(yychar, lit("struct literal")); }
    break;

  case 219:

/* Line 1806 of yacc.c  */
#line 924 "parser.y"
    { if (length((yyvsp[(2) - (2)].val)) != two)
                                    yyerr("range literal needs two elements");
                                  { val range = rcons(first((yyvsp[(2) - (2)].val)), second((yyvsp[(2) - (2)].val)));
                                    (yyval.val) = rl(range, num((yyvsp[(1) - (2)].lineno))); } }
    break;

  case 220:

/* Line 1806 of yacc.c  */
#line 928 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("range literal")); }
    break;

  case 221:

/* Line 1806 of yacc.c  */
#line 932 "parser.y"
    { if (gt(length((yyvsp[(2) - (2)].val)), three))
                                    yyerr("excess elements in tree node");
                                  { val tn = tnode(first((yyvsp[(2) - (2)].val)), second((yyvsp[(2) - (2)].val)),
                                                   third((yyvsp[(2) - (2)].val)));
                                    (yyval.val) = rl(tn, num((yyvsp[(1) - (2)].lineno))); } }
    break;

  case 222:

/* Line 1806 of yacc.c  */
#line 937 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("tree node literal")); }
    break;

  case 223:

/* Line 1806 of yacc.c  */
#line 941 "parser.y"
    { if (parser->ignore)
                                 { (yyval.val) = nil; }
                                 else if (parser->quasi_level > 0)
                                 { (yyval.val) = rl(cons(tree_lit_s, (yyvsp[(2) - (2)].val)), num((yyvsp[(1) - (2)].lineno))); }
                                 else
                                 { val opts = first((yyvsp[(2) - (2)].val));
                                   val key_fn_name = pop(&opts);
                                   val less_fn_name = pop(&opts);
                                   val equal_fn_name = pop(&opts);
                                   val key_fn = fname_helper(parser, key_fn_name);
                                   val less_fn = fname_helper(parser, less_fn_name);
                                   val equal_fn = fname_helper(parser, equal_fn_name);
                                   val tr = tree(rest((yyvsp[(2) - (2)].val)), key_fn,
                                                 less_fn, equal_fn, t);
                                     (yyval.val) = rl(tr, num((yyvsp[(1) - (2)].lineno))); } }
    break;

  case 224:

/* Line 1806 of yacc.c  */
#line 956 "parser.y"
    { (yyval.val) = nil;
                                 yybadtok(yychar, lit("tree node literal")); }
    break;

  case 225:

/* Line 1806 of yacc.c  */
#line 960 "parser.y"
    { (yyval.val) = list(json_s, quote_s, (yyvsp[(2) - (2)].val), nao);
                                  end_of_json(scnr); }
    break;

  case 226:

/* Line 1806 of yacc.c  */
#line 962 "parser.y"
    { parser->quasi_level++; }
    break;

  case 227:

/* Line 1806 of yacc.c  */
#line 963 "parser.y"
    { parser->quasi_level--;
                                  end_of_json(scnr);
                                  (yyval.val) = list(json_s, sys_qquote_s, (yyvsp[(4) - (4)].val), nao); }
    break;

  case 228:

/* Line 1806 of yacc.c  */
#line 966 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 229:

/* Line 1806 of yacc.c  */
#line 967 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 230:

/* Line 1806 of yacc.c  */
#line 968 "parser.y"
    { (yyval.val) = null_string; }
    break;

  case 231:

/* Line 1806 of yacc.c  */
#line 969 "parser.y"
    { (yyval.val) = (yyvsp[(2) - (3)].val);
                                  rl((yyval.val), num(parser->lineno)); }
    break;

  case 232:

/* Line 1806 of yacc.c  */
#line 971 "parser.y"
    { (yyval.val) = vector(zero, nil); }
    break;

  case 233:

/* Line 1806 of yacc.c  */
#line 973 "parser.y"
    { (yyval.val) = if3(vectorp((yyvsp[(2) - (4)].val)),
                                           (yyvsp[(2) - (4)].val),
                                           rl(cons(vector_lit_s,
                                                   cons(nreverse((yyvsp[(2) - (4)].val)), nil)),
                                              (yyvsp[(2) - (4)].val))); }
    break;

  case 234:

/* Line 1806 of yacc.c  */
#line 978 "parser.y"
    { (yyval.val) = make_hash(hash_weak_none, t); }
    break;

  case 235:

/* Line 1806 of yacc.c  */
#line 980 "parser.y"
    { (yyval.val) = if3(hashp((yyvsp[(2) - (4)].val)),
                                           (yyvsp[(2) - (4)].val),
                                           rl(cons(hash_lit_s,
                                                   cons(nil, nreverse((yyvsp[(2) - (4)].val)))),
                                                   (yyvsp[(2) - (4)].val))); }
    break;

  case 236:

/* Line 1806 of yacc.c  */
#line 985 "parser.y"
    { parser->quasi_level--; }
    break;

  case 237:

/* Line 1806 of yacc.c  */
#line 986 "parser.y"
    { parser->quasi_level++;
                                  end_of_json_unquote(scnr);
                                  (yyval.val) = rl(rlc(list(sys_unquote_s, (yyvsp[(3) - (3)].val), nao), (yyvsp[(3) - (3)].val)),
                                          num(parser->lineno)); }
    break;

  case 238:

/* Line 1806 of yacc.c  */
#line 990 "parser.y"
    { parser->quasi_level--; }
    break;

  case 239:

/* Line 1806 of yacc.c  */
#line 991 "parser.y"
    { parser->quasi_level++;
                                  end_of_json_unquote(scnr);
                                  (yyval.val) = rl(rlc(list(sys_splice_s, (yyvsp[(3) - (3)].val), nao), (yyvsp[(3) - (3)].val)),
                                          num(parser->lineno)); }
    break;

  case 240:

/* Line 1806 of yacc.c  */
#line 995 "parser.y"
    { parser_circ_def(parser, (yyvsp[(1) - (1)].val), unique_s); }
    break;

  case 241:

/* Line 1806 of yacc.c  */
#line 996 "parser.y"
    { parser_circ_def(parser, (yyvsp[(1) - (3)].val), (yyvsp[(3) - (3)].val));
                                  (yyval.val) = (yyvsp[(3) - (3)].val); }
    break;

  case 242:

/* Line 1806 of yacc.c  */
#line 998 "parser.y"
    { (yyval.val) = parser_circ_ref(parser, (yyvsp[(1) - (1)].val)); }
    break;

  case 243:

/* Line 1806 of yacc.c  */
#line 999 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("JSON string")); }
    break;

  case 244:

/* Line 1806 of yacc.c  */
#line 1001 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("JSON array")); }
    break;

  case 245:

/* Line 1806 of yacc.c  */
#line 1003 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("JSON hash")); }
    break;

  case 246:

/* Line 1806 of yacc.c  */
#line 1007 "parser.y"
    { if (!parser->read_bad_json)
                                    yyerr("trailing comma in JSON array"); }
    break;

  case 248:

/* Line 1806 of yacc.c  */
#line 1012 "parser.y"
    { (yyval.val) = if3(parser->quasi_level > 0,
                                                   cons((yyvsp[(1) - (1)].val), nil),
                                                   vector(one, (yyvsp[(1) - (1)].val))); }
    break;

  case 249:

/* Line 1806 of yacc.c  */
#line 1015 "parser.y"
    { if (consp((yyvsp[(1) - (3)].val)))
                                          { (yyval.val) = cons((yyvsp[(3) - (3)].val), (yyvsp[(1) - (3)].val)); }
                                          else if (parser->quasi_level > 0)
                                          { val li = list_vec((yyvsp[(1) - (3)].val));
                                            (yyval.val) = cons((yyvsp[(3) - (3)].val), li); }
                                          else
                                          { vec_push((yyvsp[(1) - (3)].val), (yyvsp[(3) - (3)].val));
                                            (yyval.val) = (yyvsp[(1) - (3)].val); } }
    break;

  case 250:

/* Line 1806 of yacc.c  */
#line 1023 "parser.y"
    { yyerr("missing comma in JSON array");
                                          (yyval.val) = (yyvsp[(1) - (2)].val); }
    break;

  case 251:

/* Line 1806 of yacc.c  */
#line 1025 "parser.y"
    { yybadtok(yychar, lit("JSON array"));
                                          (yyval.val) = (yyvsp[(1) - (2)].val); }
    break;

  case 252:

/* Line 1806 of yacc.c  */
#line 1029 "parser.y"
    { if (parser->quasi_level > 0)
                                          { (yyval.val) = cons(list((yyvsp[(1) - (3)].val), (yyvsp[(3) - (3)].val), nao), nil); }
                                          else
                                          { (yyval.val) = make_hash(hash_weak_none, t);
                                            sethash((yyval.val), (yyvsp[(1) - (3)].val), (yyvsp[(3) - (3)].val)); } }
    break;

  case 253:

/* Line 1806 of yacc.c  */
#line 1035 "parser.y"
    { if (consp((yyvsp[(1) - (5)].val)))
                                          { (yyval.val) = cons(list((yyvsp[(3) - (5)].val), (yyvsp[(5) - (5)].val), nao), (yyvsp[(1) - (5)].val)); }
                                          else if (parser->quasi_level > 0)
                                          { val pa = hash_pairs((yyvsp[(1) - (5)].val));
                                            (yyval.val) = cons(list((yyvsp[(3) - (5)].val), (yyvsp[(5) - (5)].val), nao), pa); }
                                          else
                                          { sethash((yyvsp[(1) - (5)].val), (yyvsp[(3) - (5)].val), (yyvsp[(5) - (5)].val));
                                            (yyval.val) = (yyvsp[(1) - (5)].val); } }
    break;

  case 254:

/* Line 1806 of yacc.c  */
#line 1043 "parser.y"
    { yyerr("missing colon in JSON hash"); }
    break;

  case 255:

/* Line 1806 of yacc.c  */
#line 1045 "parser.y"
    { yyerr("missing comma in JSON hash"); }
    break;

  case 256:

/* Line 1806 of yacc.c  */
#line 1046 "parser.y"
    { yybadtok(yychar, lit("JSON hash")); }
    break;

  case 257:

/* Line 1806 of yacc.c  */
#line 1049 "parser.y"
    { if ((yyvsp[(1) - (1)].lexeme)[0] == ':' && (yyvsp[(1) - (1)].lexeme)[1] == 0)
                          { (yyval.val) = nil; }
                          else
                          { yybadtok(yychar, lit("JSON hash")); } }
    break;

  case 258:

/* Line 1806 of yacc.c  */
#line 1053 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 259:

/* Line 1806 of yacc.c  */
#line 1057 "parser.y"
    { (yyval.val) = rl((yyvsp[(2) - (3)].val), num((yyvsp[(1) - (3)].lineno))); }
    break;

  case 260:

/* Line 1806 of yacc.c  */
#line 1058 "parser.y"
    { val a = car((yyvsp[(3) - (4)].val));
                                  val ur = uref_helper(parser, a);
                                  if (ur == a)
                                    (yyval.val) = (yyvsp[(3) - (4)].val);
                                  else
                                    (yyval.val) = rlc(cons(ur, cdr((yyvsp[(3) - (4)].val))), ur); }
    break;

  case 261:

/* Line 1806 of yacc.c  */
#line 1064 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 262:

/* Line 1806 of yacc.c  */
#line 1065 "parser.y"
    { (yyval.val) = (yyvsp[(3) - (4)].val); }
    break;

  case 263:

/* Line 1806 of yacc.c  */
#line 1066 "parser.y"
    { (yyval.val) = (yyvsp[(3) - (4)].val); }
    break;

  case 264:

/* Line 1806 of yacc.c  */
#line 1067 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("expression")); }
    break;

  case 265:

/* Line 1806 of yacc.c  */
#line 1071 "parser.y"
    { if (consp((yyvsp[(2) - (2)].val)))
                                    (yyval.val) = rl(cons(expr_s, cons((yyvsp[(2) - (2)].val), nil)), num((yyvsp[(1) - (2)].lineno)));
                                  else
                                    (yyval.val) = rl(cons(var_s, cons((yyvsp[(2) - (2)].val), nil)),
                                            num((yyvsp[(1) - (2)].lineno))); }
    break;

  case 266:

/* Line 1806 of yacc.c  */
#line 1076 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("meta expression")); }
    break;

  case 267:

/* Line 1806 of yacc.c  */
#line 1080 "parser.y"
    { if (consp((yyvsp[(2) - (2)].val)))
                                    (yyval.val) = rl(cons(expr_s, cons((yyvsp[(2) - (2)].val), nil)), num((yyvsp[(1) - (2)].chr)));
                                  else
                                    (yyval.val) = rl(cons(var_s, cons((yyvsp[(2) - (2)].val), nil)),
                                            num((yyvsp[(1) - (2)].chr))); }
    break;

  case 268:

/* Line 1806 of yacc.c  */
#line 1085 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("meta expression")); }
    break;

  case 269:

/* Line 1806 of yacc.c  */
#line 1089 "parser.y"
    { val a = car((yyvsp[(3) - (4)].val));
                                  val ur = uref_helper(parser, a);
                                  (yyval.val) = rlcp_tree(cons(dwim_s,
                                                      cons(ur, cdr((yyvsp[(3) - (4)].val)))), ur); }
    break;

  case 270:

/* Line 1806 of yacc.c  */
#line 1093 "parser.y"
    { (yyval.val) = rl(cons(dwim_s, (yyvsp[(2) - (3)].val)), num((yyvsp[(1) - (3)].lineno))); }
    break;

  case 271:

/* Line 1806 of yacc.c  */
#line 1094 "parser.y"
    { (yyval.val) = rl(cons(dwim_s, nil), num((yyvsp[(1) - (2)].lineno))); }
    break;

  case 272:

/* Line 1806 of yacc.c  */
#line 1095 "parser.y"
    { (yyval.val) = rl(cons(dwim_s, (yyvsp[(3) - (4)].val)), num((yyvsp[(1) - (4)].lineno))); }
    break;

  case 273:

/* Line 1806 of yacc.c  */
#line 1096 "parser.y"
    { (yyval.val) = rl(cons(dwim_s, (yyvsp[(3) - (4)].val)), num((yyvsp[(1) - (4)].lineno))); }
    break;

  case 274:

/* Line 1806 of yacc.c  */
#line 1097 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("DWIM expression")); }
    break;

  case 278:

/* Line 1806 of yacc.c  */
#line 1106 "parser.y"
    { (yyval.val) = rlc(expand_meta((yyvsp[(1) - (1)].val), nil), (yyvsp[(1) - (1)].val)); }
    break;

  case 279:

/* Line 1806 of yacc.c  */
#line 1109 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 280:

/* Line 1806 of yacc.c  */
#line 1110 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 281:

/* Line 1806 of yacc.c  */
#line 1113 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val)->c.cdr;
                                  (yyvsp[(1) - (1)].val)->c.cdr = nil;
                                  if ((yyval.val)->c.car == nao)
                                    (yyval.val) = (yyval.val)->c.cdr; }
    break;

  case 282:

/* Line 1806 of yacc.c  */
#line 1118 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (3)].val)->c.cdr;
                                  (yyvsp[(1) - (3)].val)->c.cdr = (yyvsp[(3) - (3)].val); }
    break;

  case 283:

/* Line 1806 of yacc.c  */
#line 1122 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil);
                                  rlc((yyval.val), (yyvsp[(1) - (1)].val));
                                  (yyval.val)->c.cdr = (yyval.val); }
    break;

  case 284:

/* Line 1806 of yacc.c  */
#line 1125 "parser.y"
    { parser->ignore = 1; }
    break;

  case 285:

/* Line 1806 of yacc.c  */
#line 1126 "parser.y"
    { parser->ignore = 0;
                                  (yyval.val) = cons(nao, nil);
                                  (yyval.val)->c.cdr = (yyval.val); }
    break;

  case 286:

/* Line 1806 of yacc.c  */
#line 1129 "parser.y"
    { parser->ignore = 1; }
    break;

  case 287:

/* Line 1806 of yacc.c  */
#line 1130 "parser.y"
    { parser->ignore = 0;
                                  (yyval.val) = cons(nao, nil);
                                  (yyval.val)->c.cdr = (yyval.val); }
    break;

  case 288:

/* Line 1806 of yacc.c  */
#line 1133 "parser.y"
    { parser->ignore = 1; }
    break;

  case 289:

/* Line 1806 of yacc.c  */
#line 1134 "parser.y"
    { parser->ignore = 0;
                                  (yyval.val) = (yyvsp[(1) - (4)].val); }
    break;

  case 290:

/* Line 1806 of yacc.c  */
#line 1136 "parser.y"
    { parser->ignore = 1; }
    break;

  case 291:

/* Line 1806 of yacc.c  */
#line 1137 "parser.y"
    { parser->ignore = 0;
                                  (yyval.val) = (yyvsp[(1) - (5)].val); }
    break;

  case 292:

/* Line 1806 of yacc.c  */
#line 1139 "parser.y"
    { uses_or2;
                                  (yyval.val) = rlc(cons((yyvsp[(2) - (2)].val), (yyvsp[(1) - (2)].val)->c.cdr), or2((yyvsp[(2) - (2)].val), (yyvsp[(1) - (2)].val)->c.cdr));
                                  (yyvsp[(1) - (2)].val)->c.cdr = (yyval.val); }
    break;

  case 293:

/* Line 1806 of yacc.c  */
#line 1142 "parser.y"
    { (yyval.val) = lastcons(rl((yyvsp[(2) - (2)].val), num((yyvsp[(1) - (2)].lineno))));
                                  (yyval.val)->c.cdr = (yyvsp[(2) - (2)].val); }
    break;

  case 294:

/* Line 1806 of yacc.c  */
#line 1145 "parser.y"
    { (yyval.val) = lastcons(rl((yyvsp[(3) - (3)].val), num((yyvsp[(2) - (3)].lineno))));
                                  (yyval.val)->c.cdr = (yyvsp[(1) - (3)].val)->c.cdr;
                                  (yyvsp[(1) - (3)].val)->c.cdr = (yyvsp[(3) - (3)].val); }
    break;

  case 295:

/* Line 1806 of yacc.c  */
#line 1148 "parser.y"
    { (yyval.val) = lastcons(rl((yyvsp[(2) - (2)].val), num((yyvsp[(1) - (2)].lineno))));
                                  (yyval.val)->c.cdr = (yyvsp[(2) - (2)].val); }
    break;

  case 296:

/* Line 1806 of yacc.c  */
#line 1151 "parser.y"
    { (yyval.val) = lastcons(rl((yyvsp[(3) - (3)].val), num((yyvsp[(2) - (3)].lineno))));
                                  (yyval.val)->c.cdr = (yyvsp[(1) - (3)].val)->c.cdr;
                                  (yyvsp[(1) - (3)].val)->c.cdr = (yyvsp[(3) - (3)].val); }
    break;

  case 297:

/* Line 1806 of yacc.c  */
#line 1156 "parser.y"
    { (yyval.val) = ifnign(symhlpr((yyvsp[(1) - (1)].lexeme), t)); }
    break;

  case 298:

/* Line 1806 of yacc.c  */
#line 1157 "parser.y"
    { (yyval.val) = cons(var_s, cons((yyvsp[(1) - (1)].val), nil));
                                  rl((yyval.val), num(parser->lineno)); }
    break;

  case 299:

/* Line 1806 of yacc.c  */
#line 1159 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 300:

/* Line 1806 of yacc.c  */
#line 1160 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 301:

/* Line 1806 of yacc.c  */
#line 1161 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 302:

/* Line 1806 of yacc.c  */
#line 1162 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 303:

/* Line 1806 of yacc.c  */
#line 1163 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 304:

/* Line 1806 of yacc.c  */
#line 1164 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 305:

/* Line 1806 of yacc.c  */
#line 1165 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 306:

/* Line 1806 of yacc.c  */
#line 1166 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 307:

/* Line 1806 of yacc.c  */
#line 1167 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 308:

/* Line 1806 of yacc.c  */
#line 1168 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 309:

/* Line 1806 of yacc.c  */
#line 1169 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 310:

/* Line 1806 of yacc.c  */
#line 1170 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 311:

/* Line 1806 of yacc.c  */
#line 1171 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 312:

/* Line 1806 of yacc.c  */
#line 1172 "parser.y"
    { (yyval.val) = rl((yyvsp[(2) - (2)].val), num((yyvsp[(1) - (2)].lineno))); }
    break;

  case 313:

/* Line 1806 of yacc.c  */
#line 1173 "parser.y"
    { (yyval.val) = rl(cons(quasilist_s, (yyvsp[(2) - (2)].val)), num((yyvsp[(1) - (2)].lineno))); }
    break;

  case 314:

/* Line 1806 of yacc.c  */
#line 1174 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 315:

/* Line 1806 of yacc.c  */
#line 1175 "parser.y"
    { (yyval.val) = rl(rlc(list(quote_s, (yyvsp[(2) - (2)].val), nao), (yyvsp[(2) - (2)].val)),
                                          num(parser->lineno)); }
    break;

  case 316:

/* Line 1806 of yacc.c  */
#line 1177 "parser.y"
    { parser->quasi_level++; }
    break;

  case 317:

/* Line 1806 of yacc.c  */
#line 1178 "parser.y"
    { parser->quasi_level--;
                                  (yyval.val) = rl(rlc(list(sys_qquote_s, (yyvsp[(3) - (3)].val), nao), (yyvsp[(3) - (3)].val)),
                                          num(parser->lineno)); }
    break;

  case 318:

/* Line 1806 of yacc.c  */
#line 1181 "parser.y"
    { parser->quasi_level--; }
    break;

  case 319:

/* Line 1806 of yacc.c  */
#line 1182 "parser.y"
    { parser->quasi_level++;
                                  (yyval.val) = rl(rlc(list(sys_unquote_s, (yyvsp[(3) - (3)].val), nao), (yyvsp[(3) - (3)].val)),
                                          num(parser->lineno)); }
    break;

  case 320:

/* Line 1806 of yacc.c  */
#line 1185 "parser.y"
    { parser->quasi_level--; }
    break;

  case 321:

/* Line 1806 of yacc.c  */
#line 1186 "parser.y"
    { parser->quasi_level++;
                                  (yyval.val) = rl(rlc(list(sys_splice_s, (yyvsp[(3) - (3)].val), nao), (yyvsp[(3) - (3)].val)),
                                          num(parser->lineno)); }
    break;

  case 322:

/* Line 1806 of yacc.c  */
#line 1189 "parser.y"
    { parser_circ_def(parser, (yyvsp[(1) - (1)].val), unique_s); }
    break;

  case 323:

/* Line 1806 of yacc.c  */
#line 1190 "parser.y"
    { parser_circ_def(parser, (yyvsp[(1) - (3)].val), (yyvsp[(3) - (3)].val));
                                  (yyval.val) = (yyvsp[(3) - (3)].val); }
    break;

  case 324:

/* Line 1806 of yacc.c  */
#line 1192 "parser.y"
    { (yyval.val) = parser_circ_ref(parser, (yyvsp[(1) - (1)].val)); }
    break;

  case 325:

/* Line 1806 of yacc.c  */
#line 1195 "parser.y"
    { (yyval.val) = uref_helper(parser, (yyvsp[(2) - (2)].val)); }
    break;

  case 326:

/* Line 1806 of yacc.c  */
#line 1196 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 327:

/* Line 1806 of yacc.c  */
#line 1198 "parser.y"
    { (yyval.val) = ifnign(symhlpr((yyvsp[(1) - (1)].lexeme), t)); }
    break;

  case 328:

/* Line 1806 of yacc.c  */
#line 1199 "parser.y"
    { (yyval.val) = cons(var_s, cons((yyvsp[(1) - (1)].val), nil));
                                  rl((yyval.val), num(parser->lineno)); }
    break;

  case 329:

/* Line 1806 of yacc.c  */
#line 1201 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 330:

/* Line 1806 of yacc.c  */
#line 1202 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 331:

/* Line 1806 of yacc.c  */
#line 1203 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 332:

/* Line 1806 of yacc.c  */
#line 1204 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 333:

/* Line 1806 of yacc.c  */
#line 1205 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 334:

/* Line 1806 of yacc.c  */
#line 1206 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 335:

/* Line 1806 of yacc.c  */
#line 1207 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 336:

/* Line 1806 of yacc.c  */
#line 1208 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 337:

/* Line 1806 of yacc.c  */
#line 1209 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 338:

/* Line 1806 of yacc.c  */
#line 1210 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 339:

/* Line 1806 of yacc.c  */
#line 1211 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 340:

/* Line 1806 of yacc.c  */
#line 1212 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 341:

/* Line 1806 of yacc.c  */
#line 1213 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 342:

/* Line 1806 of yacc.c  */
#line 1214 "parser.y"
    { (yyval.val) = rl((yyvsp[(2) - (2)].val), num((yyvsp[(1) - (2)].lineno))); }
    break;

  case 343:

/* Line 1806 of yacc.c  */
#line 1215 "parser.y"
    { (yyval.val) = rl(cons(quasilist_s, (yyvsp[(2) - (2)].val)), num((yyvsp[(1) - (2)].lineno))); }
    break;

  case 344:

/* Line 1806 of yacc.c  */
#line 1216 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 345:

/* Line 1806 of yacc.c  */
#line 1217 "parser.y"
    { (yyval.val) = rl(rlc(list(quote_s, (yyvsp[(2) - (2)].val), nao), (yyvsp[(2) - (2)].val)),
                                          num(parser->lineno)); }
    break;

  case 346:

/* Line 1806 of yacc.c  */
#line 1219 "parser.y"
    { parser->quasi_level++; }
    break;

  case 347:

/* Line 1806 of yacc.c  */
#line 1220 "parser.y"
    { parser->quasi_level--;
                                  (yyval.val) = rl(rlc(list(sys_qquote_s, (yyvsp[(3) - (3)].val), nao), (yyvsp[(3) - (3)].val)),
                                          num(parser->lineno)); }
    break;

  case 348:

/* Line 1806 of yacc.c  */
#line 1223 "parser.y"
    { parser->quasi_level--; }
    break;

  case 349:

/* Line 1806 of yacc.c  */
#line 1224 "parser.y"
    { parser->quasi_level++;
                                  (yyval.val) = rl(rlc(list(sys_unquote_s, (yyvsp[(3) - (3)].val), nao), (yyvsp[(3) - (3)].val)),
                                          num(parser->lineno)); }
    break;

  case 350:

/* Line 1806 of yacc.c  */
#line 1227 "parser.y"
    { parser->quasi_level--; }
    break;

  case 351:

/* Line 1806 of yacc.c  */
#line 1228 "parser.y"
    { parser->quasi_level++;
                                  (yyval.val) = rl(rlc(list(sys_splice_s, (yyvsp[(3) - (3)].val), nao), (yyvsp[(3) - (3)].val)),
                                          num(parser->lineno)); }
    break;

  case 352:

/* Line 1806 of yacc.c  */
#line 1231 "parser.y"
    { uses_or2;
                                  (yyval.val) = rlc(list(rcons_s, (yyvsp[(1) - (3)].val), (yyvsp[(3) - (3)].val), nao),
                                            or2((yyvsp[(1) - (3)].val), (yyvsp[(3) - (3)].val))); }
    break;

  case 353:

/* Line 1806 of yacc.c  */
#line 1235 "parser.y"
    { uses_or2;
                                  (yyval.val) = rlc(list(rcons_s, (yyvsp[(1) - (4)].val),
                                                          uref_helper(parser, (yyvsp[(4) - (4)].val)),
                                                          nao),
                                            or2((yyvsp[(1) - (4)].val), (yyvsp[(4) - (4)].val))); }
    break;

  case 354:

/* Line 1806 of yacc.c  */
#line 1241 "parser.y"
    { uses_or2;
                                  (yyval.val) = rlc(list(rcons_s, (yyvsp[(1) - (3)].val), (yyvsp[(3) - (3)].val), nao),
                                            or2((yyvsp[(1) - (3)].val), (yyvsp[(3) - (3)].val))); }
    break;

  case 355:

/* Line 1806 of yacc.c  */
#line 1245 "parser.y"
    { uses_or2;
                                  (yyval.val) = rlc(list(rcons_s, (yyvsp[(1) - (4)].val),
                                                          uref_helper(parser, (yyvsp[(4) - (4)].val)),
                                                          nao),
                                            or2((yyvsp[(1) - (4)].val), (yyvsp[(4) - (4)].val))); }
    break;

  case 356:

/* Line 1806 of yacc.c  */
#line 1250 "parser.y"
    { (yyval.val) = qref_helper(parser, (yyvsp[(1) - (3)].val), (yyvsp[(3) - (3)].val)); }
    break;

  case 357:

/* Line 1806 of yacc.c  */
#line 1251 "parser.y"
    { (yyval.val) = qref_helper(parser,
                                                   cons(t, cons((yyvsp[(1) - (3)].val), nil)),
                                                        (yyvsp[(3) - (3)].val)); }
    break;

  case 358:

/* Line 1806 of yacc.c  */
#line 1254 "parser.y"
    { (yyval.val) = uref_helper(parser, (yyvsp[(2) - (2)].val)); }
    break;

  case 359:

/* Line 1806 of yacc.c  */
#line 1255 "parser.y"
    { (yyval.val) = uoref_helper(parser, (yyvsp[(2) - (2)].val)); }
    break;

  case 360:

/* Line 1806 of yacc.c  */
#line 1256 "parser.y"
    { parser_circ_def(parser, (yyvsp[(1) - (1)].val), unique_s); }
    break;

  case 361:

/* Line 1806 of yacc.c  */
#line 1257 "parser.y"
    { parser_circ_def(parser, (yyvsp[(1) - (3)].val), (yyvsp[(3) - (3)].val));
                                  (yyval.val) = (yyvsp[(3) - (3)].val); }
    break;

  case 362:

/* Line 1806 of yacc.c  */
#line 1259 "parser.y"
    { (yyval.val) = parser_circ_ref(parser, (yyvsp[(1) - (1)].val)); }
    break;

  case 363:

/* Line 1806 of yacc.c  */
#line 1262 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 364:

/* Line 1806 of yacc.c  */
#line 1263 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 365:

/* Line 1806 of yacc.c  */
#line 1266 "parser.y"
    { (yyval.val) = uref_helper(parser, (yyvsp[(2) - (2)].val)); }
    break;

  case 366:

/* Line 1806 of yacc.c  */
#line 1267 "parser.y"
    { (yyval.val) = uoref_helper(parser, (yyvsp[(2) - (2)].val)); }
    break;

  case 367:

/* Line 1806 of yacc.c  */
#line 1268 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 368:

/* Line 1806 of yacc.c  */
#line 1271 "parser.y"
    { (yyval.val) = regex_compile((yyvsp[(2) - (3)].val), nil);
                                  end_of_regex(scnr);
                                  rl((yyval.val), num(parser->lineno)); }
    break;

  case 369:

/* Line 1806 of yacc.c  */
#line 1274 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("regex"));
                                  end_of_regex(scnr); }
    break;

  case 370:

/* Line 1806 of yacc.c  */
#line 1280 "parser.y"
    { (yyval.val) = regex_compile((yyvsp[(2) - (3)].val), nil);
                                  end_of_regex(scnr);
                                  rl((yyval.val), num(parser->lineno)); }
    break;

  case 371:

/* Line 1806 of yacc.c  */
#line 1284 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("regex"));
                                  end_of_regex(scnr); }
    break;

  case 372:

/* Line 1806 of yacc.c  */
#line 1289 "parser.y"
    { (yyval.val) = if3(cdr((yyvsp[(1) - (1)].val)),
                                                   cons(compound_s, (yyvsp[(1) - (1)].val)),
                                                   car((yyvsp[(1) - (1)].val))); }
    break;

  case 373:

/* Line 1806 of yacc.c  */
#line 1292 "parser.y"
    { (yyval.val) = list(or_s, (yyvsp[(1) - (3)].val), (yyvsp[(3) - (3)].val), nao); }
    break;

  case 374:

/* Line 1806 of yacc.c  */
#line 1293 "parser.y"
    { (yyval.val) = list(and_s, (yyvsp[(1) - (3)].val), (yyvsp[(3) - (3)].val), nao); }
    break;

  case 375:

/* Line 1806 of yacc.c  */
#line 1294 "parser.y"
    { (yyval.val) = list(compl_s, (yyvsp[(2) - (2)].val), nao); }
    break;

  case 376:

/* Line 1806 of yacc.c  */
#line 1295 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 377:

/* Line 1806 of yacc.c  */
#line 1298 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil); }
    break;

  case 378:

/* Line 1806 of yacc.c  */
#line 1299 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (2)].val), (yyvsp[(2) - (2)].val)); }
    break;

  case 379:

/* Line 1806 of yacc.c  */
#line 1300 "parser.y"
    { (yyval.val) = list((yyvsp[(1) - (3)].val), list(compl_s, (yyvsp[(3) - (3)].val), nao), nao); }
    break;

  case 380:

/* Line 1806 of yacc.c  */
#line 1303 "parser.y"
    { (yyval.val) = list(zeroplus_s, (yyvsp[(1) - (2)].val), nao); }
    break;

  case 381:

/* Line 1806 of yacc.c  */
#line 1304 "parser.y"
    { (yyval.val) = list(oneplus_s, (yyvsp[(1) - (2)].val), nao); }
    break;

  case 382:

/* Line 1806 of yacc.c  */
#line 1305 "parser.y"
    { (yyval.val) = list(optional_s, (yyvsp[(1) - (2)].val), nao); }
    break;

  case 383:

/* Line 1806 of yacc.c  */
#line 1306 "parser.y"
    { (yyval.val) = list(nongreedy_s, (yyvsp[(1) - (3)].val), (yyvsp[(3) - (3)].val), nao); }
    break;

  case 384:

/* Line 1806 of yacc.c  */
#line 1307 "parser.y"
    { if (first((yyvsp[(2) - (3)].val)) == chr('^'))
                                  { if (rest((yyvsp[(2) - (3)].val)))
                                      (yyval.val) = cons(cset_s, rest((yyvsp[(2) - (3)].val)));
                                    else
                                      (yyval.val) = wild_s; }
                                  else
                                    (yyval.val) = cons(set_s, (yyvsp[(2) - (3)].val)); }
    break;

  case 385:

/* Line 1806 of yacc.c  */
#line 1314 "parser.y"
    { (yyval.val) = cons(set_s, nil); }
    break;

  case 386:

/* Line 1806 of yacc.c  */
#line 1315 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("regex character class")); }
    break;

  case 387:

/* Line 1806 of yacc.c  */
#line 1317 "parser.y"
    { (yyval.val) = wild_s; }
    break;

  case 388:

/* Line 1806 of yacc.c  */
#line 1318 "parser.y"
    { (yyval.val) = chr(']'); }
    break;

  case 389:

/* Line 1806 of yacc.c  */
#line 1319 "parser.y"
    { (yyval.val) = chr('-'); }
    break;

  case 390:

/* Line 1806 of yacc.c  */
#line 1320 "parser.y"
    { (yyval.val) = chr((yyvsp[(1) - (1)].chr)); }
    break;

  case 391:

/* Line 1806 of yacc.c  */
#line 1321 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 392:

/* Line 1806 of yacc.c  */
#line 1322 "parser.y"
    { (yyval.val) = list(compound_s, string_own((yyvsp[(1) - (1)].lexeme)), nao); }
    break;

  case 393:

/* Line 1806 of yacc.c  */
#line 1323 "parser.y"
    { (yyval.val) = (yyvsp[(2) - (3)].val); }
    break;

  case 394:

/* Line 1806 of yacc.c  */
#line 1324 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("regex subexpression")); }
    break;

  case 395:

/* Line 1806 of yacc.c  */
#line 1328 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil); }
    break;

  case 396:

/* Line 1806 of yacc.c  */
#line 1329 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (2)].val), (yyvsp[(2) - (2)].val)); }
    break;

  case 397:

/* Line 1806 of yacc.c  */
#line 1332 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 398:

/* Line 1806 of yacc.c  */
#line 1333 "parser.y"
    { (yyval.val) = chr((yyvsp[(1) - (1)].chr)); }
    break;

  case 399:

/* Line 1806 of yacc.c  */
#line 1334 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 400:

/* Line 1806 of yacc.c  */
#line 1337 "parser.y"
    { (yyval.val) = cons(chr((yyvsp[(1) - (3)].chr)), chr((yyvsp[(3) - (3)].chr))); }
    break;

  case 401:

/* Line 1806 of yacc.c  */
#line 1339 "parser.y"
    { (yyval.chr) = '?'; }
    break;

  case 402:

/* Line 1806 of yacc.c  */
#line 1340 "parser.y"
    { (yyval.chr) = '.'; }
    break;

  case 403:

/* Line 1806 of yacc.c  */
#line 1341 "parser.y"
    { (yyval.chr) = '*'; }
    break;

  case 404:

/* Line 1806 of yacc.c  */
#line 1342 "parser.y"
    { (yyval.chr) = '+'; }
    break;

  case 405:

/* Line 1806 of yacc.c  */
#line 1343 "parser.y"
    { (yyval.chr) = '('; }
    break;

  case 406:

/* Line 1806 of yacc.c  */
#line 1344 "parser.y"
    { (yyval.chr) = ')'; }
    break;

  case 407:

/* Line 1806 of yacc.c  */
#line 1345 "parser.y"
    { (yyval.chr) = '|'; }
    break;

  case 408:

/* Line 1806 of yacc.c  */
#line 1346 "parser.y"
    { (yyval.chr) = '~'; }
    break;

  case 409:

/* Line 1806 of yacc.c  */
#line 1347 "parser.y"
    { (yyval.chr) = '&'; }
    break;

  case 410:

/* Line 1806 of yacc.c  */
#line 1348 "parser.y"
    { (yyval.chr) = '%'; }
    break;

  case 411:

/* Line 1806 of yacc.c  */
#line 1349 "parser.y"
    { (yyval.chr) = '/'; }
    break;

  case 412:

/* Line 1806 of yacc.c  */
#line 1350 "parser.y"
    { (yyval.chr) = (yyvsp[(1) - (1)].chr); }
    break;

  case 413:

/* Line 1806 of yacc.c  */
#line 1353 "parser.y"
    { switch ((yyvsp[(1) - (1)].chr))
                                  { case 's':
                                      (yyval.val) = space_k; break;
                                    case 'S':
                                      (yyval.val) = cspace_k; break;
                                    case 'd':
                                      (yyval.val) = digit_k; break;
                                    case 'D':
                                      (yyval.val) = cdigit_k; break;
                                    case 'w':
                                      (yyval.val) = word_char_k; break;
                                    case 'W':
                                      (yyval.val) = cword_char_k; break; }}
    break;

  case 415:

/* Line 1806 of yacc.c  */
#line 1368 "parser.y"
    { yyerr("newline expected after directive");
                          yyerrok; }
    break;

  case 416:

/* Line 1806 of yacc.c  */
#line 1372 "parser.y"
    { (yyval.val) = null_string; }
    break;

  case 417:

/* Line 1806 of yacc.c  */
#line 1373 "parser.y"
    { (yyval.val) = (yyvsp[(2) - (3)].val);
                                  rl((yyval.val), num(parser->lineno)); }
    break;

  case 418:

/* Line 1806 of yacc.c  */
#line 1375 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("string literal")); }
    break;

  case 419:

/* Line 1806 of yacc.c  */
#line 1379 "parser.y"
    { wchar_t ch;
                                  val str = string_own((yyvsp[(2) - (2)].lexeme));
                                  const wchar_t *cstr = c_str(str, nil);

                                  if (cstr[1] == 0)
                                  { ch = cstr[0]; }
                                  else
                                  { ch = char_from_name(cstr);
                                    if (ch == L'!')
                                    { yyerrorf(scnr, lit("unknown character name: ~a"),
                                               str, nao); }}
                                  end_of_char(scnr);
                                  (yyval.val) = chr(ch); }
    break;

  case 420:

/* Line 1806 of yacc.c  */
#line 1392 "parser.y"
    { (yyval.val) = chr((yyvsp[(2) - (2)].chr));
                                  end_of_char(scnr); }
    break;

  case 421:

/* Line 1806 of yacc.c  */
#line 1394 "parser.y"
    { free((yyvsp[(2) - (2)].lexeme));
                                   yyerrorf(scnr,
                                            lit("invalid UTF-8 used as character name"),
                                            nao); }
    break;

  case 422:

/* Line 1806 of yacc.c  */
#line 1398 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar,
                                             lit("character literal")); }
    break;

  case 423:

/* Line 1806 of yacc.c  */
#line 1403 "parser.y"
    { (yyval.val) = null_string; }
    break;

  case 424:

/* Line 1806 of yacc.c  */
#line 1404 "parser.y"
    { (yyval.val) = cons(quasi_s, (yyvsp[(2) - (3)].val));
                                  rlc((yyval.val), (yyvsp[(2) - (3)].val));
                                  rl((yyval.val), num(parser->lineno)); }
    break;

  case 425:

/* Line 1806 of yacc.c  */
#line 1407 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("quasistring")); }
    break;

  case 426:

/* Line 1806 of yacc.c  */
#line 1411 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (1)].val), nil);
                                          rl((yyval.val), num(parser->lineno)); }
    break;

  case 427:

/* Line 1806 of yacc.c  */
#line 1413 "parser.y"
    { (yyval.val) = cons((yyvsp[(1) - (2)].val), (yyvsp[(2) - (2)].val));
                                          rl((yyval.val), num(parser->lineno)); }
    break;

  case 428:

/* Line 1806 of yacc.c  */
#line 1417 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 429:

/* Line 1806 of yacc.c  */
#line 1418 "parser.y"
    { (yyval.val) = (yyvsp[(1) - (1)].val); }
    break;

  case 430:

/* Line 1806 of yacc.c  */
#line 1419 "parser.y"
    { (yyval.val) = cons(var_s, cons((yyvsp[(1) - (1)].val), nil));
                                  rl((yyval.val), num(parser->lineno)); }
    break;

  case 431:

/* Line 1806 of yacc.c  */
#line 1421 "parser.y"
    { if (integerp((yyvsp[(2) - (2)].val)) || symbolp((yyvsp[(2) - (2)].val)))
                                    (yyval.val) = rlcp_tree(cons(var_s, cons((yyvsp[(2) - (2)].val), nil)),
                                                   (yyvsp[(2) - (2)].val));
                                  else
                                    (yyval.val) = (yyvsp[(2) - (2)].val); }
    break;

  case 432:

/* Line 1806 of yacc.c  */
#line 1428 "parser.y"
    { (yyval.val) = mkstring(one, chr((yyvsp[(1) - (1)].chr))); }
    break;

  case 433:

/* Line 1806 of yacc.c  */
#line 1429 "parser.y"
    { val ch = mkstring(one, chr((yyvsp[(1) - (2)].chr)));
                                  (yyval.val) = string_extend(ch, (yyvsp[(2) - (2)].val), t); }
    break;

  case 434:

/* Line 1806 of yacc.c  */
#line 1431 "parser.y"
    { (yyval.val) = string_own((yyvsp[(1) - (1)].lexeme)); }
    break;

  case 435:

/* Line 1806 of yacc.c  */
#line 1432 "parser.y"
    { (yyval.val) = string_extend(string_own((yyvsp[(1) - (2)].lexeme)), (yyvsp[(2) - (2)].val), t); }
    break;

  case 436:

/* Line 1806 of yacc.c  */
#line 1435 "parser.y"
    { (yyval.val) = mkstring(one, chr((yyvsp[(1) - (1)].chr))); }
    break;

  case 437:

/* Line 1806 of yacc.c  */
#line 1436 "parser.y"
    { (yyval.val) = string_extend((yyvsp[(1) - (2)].val), chr((yyvsp[(2) - (2)].chr)), nil); }
    break;

  case 438:

/* Line 1806 of yacc.c  */
#line 1437 "parser.y"
    { (yyval.val) = string_own((yyvsp[(1) - (1)].lexeme)); }
    break;

  case 439:

/* Line 1806 of yacc.c  */
#line 1438 "parser.y"
    { (yyval.val) = string_extend((yyvsp[(1) - (2)].val), string_own((yyvsp[(2) - (2)].lexeme)), nil); }
    break;

  case 440:

/* Line 1806 of yacc.c  */
#line 1441 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 441:

/* Line 1806 of yacc.c  */
#line 1442 "parser.y"
    { (yyval.val) = (yyvsp[(2) - (2)].val); }
    break;

  case 442:

/* Line 1806 of yacc.c  */
#line 1443 "parser.y"
    { val word = (yyvsp[(1) - (2)].val);
                                  (yyval.val) = rlc(cons(word, (yyvsp[(2) - (2)].val)), (yyvsp[(1) - (2)].val)); }
    break;

  case 443:

/* Line 1806 of yacc.c  */
#line 1445 "parser.y"
    { (yyval.val) = nil;
                                  yybadtok(yychar, lit("word list")); }
    break;

  case 444:

/* Line 1806 of yacc.c  */
#line 1449 "parser.y"
    { (yyval.val) = nil; }
    break;

  case 445:

/* Line 1806 of yacc.c  */
#line 1450 "parser.y"
    { (yyval.val) = (yyvsp[(2) - (2)].val); }
    break;

  case 446:

/* Line 1806 of yacc.c  */
#line 1451 "parser.y"
    { val qword = cons(quasi_s, (yyvsp[(1) - (2)].val));
                                   (yyval.val) = rlc(cons(qword, nil), (yyvsp[(1) - (2)].val)); }
    break;

  case 447:

/* Line 1806 of yacc.c  */
#line 1455 "parser.y"
    { val qword = cons(quasi_s, (yyvsp[(1) - (3)].val));
                                   (yyval.val) = rlc(cons(qword, (yyvsp[(3) - (3)].val)), (yyvsp[(1) - (3)].val)); }
    break;

  case 448:

/* Line 1806 of yacc.c  */
#line 1459 "parser.y"
    { (yyval.val) = make_buf(zero, nil, nil);
                                           end_of_buflit(scnr); }
    break;

  case 449:

/* Line 1806 of yacc.c  */
#line 1461 "parser.y"
    { end_of_buflit(scnr);
                                           buf_trim((yyvsp[(2) - (3)].val));
                                           (yyval.val) = (yyvsp[(2) - (3)].val); }
    break;

  case 450:

/* Line 1806 of yacc.c  */
#line 1464 "parser.y"
    { yyerr("unterminated buffer literal");
                                           end_of_buflit(scnr);
                                           yyerrok; }
    break;

  case 451:

/* Line 1806 of yacc.c  */
#line 1469 "parser.y"
    { buf_put_u8((yyvsp[(1) - (2)].val), length_buf((yyval.val)), (yyvsp[(2) - (2)].val));
                                          (yyval.val) = (yyvsp[(1) - (2)].val); }
    break;

  case 452:

/* Line 1806 of yacc.c  */
#line 1471 "parser.y"
    { (yyval.val) = make_buf(zero, nil, num_fast(512));
                                          buf_put_u8((yyval.val), zero, (yyvsp[(1) - (1)].val)); }
    break;

  case 453:

/* Line 1806 of yacc.c  */
#line 1475 "parser.y"
    { (yyval.val) = num((yyvsp[(1) - (2)].chr) << 4 | (yyvsp[(2) - (2)].chr)); }
    break;

  case 454:

/* Line 1806 of yacc.c  */
#line 1476 "parser.y"
    { (yyval.val) = zero;
                                          yyerr("unpaired digit in buffer literal");
                                          yyerrok; }
    break;

  case 455:

/* Line 1806 of yacc.c  */
#line 1483 "parser.y"
    { (yyval.val) = mkexp(all_s, nil, num(parser->lineno)); }
    break;

  case 456:

/* Line 1806 of yacc.c  */
#line 1484 "parser.y"
    { (yyval.val) = mkexp(some_s, nil, num(parser->lineno)); }
    break;

  case 457:

/* Line 1806 of yacc.c  */
#line 1485 "parser.y"
    { (yyval.val) = mkexp(none_s, nil, num(parser->lineno)); }
    break;

  case 458:

/* Line 1806 of yacc.c  */
#line 1486 "parser.y"
    { (yyval.val) = mkexp(maybe_s, nil, num(parser->lineno)); }
    break;

  case 459:

/* Line 1806 of yacc.c  */
#line 1487 "parser.y"
    { (yyval.val) = mkexp(cases_s, nil, num(parser->lineno)); }
    break;

  case 460:

/* Line 1806 of yacc.c  */
#line 1488 "parser.y"
    { (yyval.val) = mkexp(and_s, nil, num(parser->lineno)); }
    break;

  case 461:

/* Line 1806 of yacc.c  */
#line 1489 "parser.y"
    { (yyval.val) = mkexp(or_s, nil, num(parser->lineno)); }
    break;

  case 462:

/* Line 1806 of yacc.c  */
#line 1490 "parser.y"
    { (yyval.val) = mkexp(try_s, nil, num(parser->lineno)); }
    break;

  case 463:

/* Line 1806 of yacc.c  */
#line 1491 "parser.y"
    { (yyval.val) = mkexp(finally_s, nil, num(parser->lineno)); }
    break;

  case 464:

/* Line 1806 of yacc.c  */
#line 1493 "parser.y"
    { (yyval.val) = mkexp(block_s, (yyvsp[(2) - (3)].val), nil); }
    break;

  case 465:

/* Line 1806 of yacc.c  */
#line 1495 "parser.y"
    { (yyval.val) = mkexp(choose_s, (yyvsp[(2) - (3)].val), nil); }
    break;

  case 466:

/* Line 1806 of yacc.c  */
#line 1497 "parser.y"
    { (yyval.val) = mkexp(collect_s, (yyvsp[(2) - (3)].val), nil); }
    break;

  case 467:

/* Line 1806 of yacc.c  */
#line 1499 "parser.y"
    { (yyval.val) = mkexp(coll_s, (yyvsp[(2) - (3)].val), nil); }
    break;

  case 468:

/* Line 1806 of yacc.c  */
#line 1501 "parser.y"
    { (yyval.val) = mkexp(gather_s, (yyvsp[(2) - (3)].val), nil); }
    break;

  case 469:

/* Line 1806 of yacc.c  */
#line 1503 "parser.y"
    { (yyval.val) = mkexp(define_s, (yyvsp[(2) - (3)].val), nil); }
    break;

  case 470:

/* Line 1806 of yacc.c  */
#line 1505 "parser.y"
    { (yyval.val) = mkexp(catch_s, (yyvsp[(2) - (3)].val), nil); }
    break;

  case 471:

/* Line 1806 of yacc.c  */
#line 1507 "parser.y"
    { (yyval.val) = mkexp(if_s,
                                                         cons((yyvsp[(2) - (5)].val),
                                                              cons((yyvsp[(3) - (5)].val), (yyvsp[(4) - (5)].val))),
                                                         nil); }
    break;

  case 472:

/* Line 1806 of yacc.c  */
#line 1512 "parser.y"
    { yyerr("@(output) doesn't nest"); }
    break;

  case 473:

/* Line 1806 of yacc.c  */
#line 1514 "parser.y"
    { yyerr("@(push) doesn't nest"); }
    break;



/* Line 1806 of yacc.c  */
#line 7033 "y.tab.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (scnr, parser, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (scnr, parser, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, scnr, parser);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, scnr, parser);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (scnr, parser, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, scnr, parser);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, scnr, parser);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 2067 of yacc.c  */
#line 1517 "parser.y"


const int have_yydebug = YYDEBUG;

int yylex(YYSTYPE *, yyscan_t scanner);

void yydebug_onoff(int val)
{
#if YYDEBUG
  yydebug = val;
#else
  (void) val;
#endif
}

static void set_syntax_tree(parser_t *parser, val tree)
{
  if (tree == nao)
    parser->syntax_tree = tree;
  else
    set(mkloc(parser->syntax_tree, parser->parser), tree);
}

static val sym_helper(parser_t *parser, wchar_t *lexeme, val meta_allowed)
{
  scanner_t *scnr = parser->scanner;
  int leading_at = *lexeme == L'@';
  wchar_t *tokfree = lexeme;
  wchar_t *colon = wcschr(lexeme, L':');
  val sym;

  if (leading_at) {
    if (!meta_allowed) {
      val tok = string_own(lexeme);
      yyerrorf(scnr, lit("~a: meta variable not allowed in this context"), tok, nao);
      return nil;
    }
    lexeme++;
  }

  if (colon != 0)
    *colon = 0;

  if (colon == lexeme) {
    val sym_name = string(colon + 1);
    scrub_scanner(parser->scanner, SYMTOK, tokfree);
    free(tokfree);
    sym = intern(sym_name, keyword_package);
  } else if (colon != 0) {
    val pkg_name = string(lexeme);
    val sym_name = string(colon + 1);
    scrub_scanner(parser->scanner, SYMTOK, tokfree);
    free(tokfree);
    if (equal(pkg_name, lit("#"))) {
      sym = make_sym(sym_name);
    } else {
      val package = find_package(pkg_name);
      if (!package) {
        yyerrorf(scnr, lit("~a:~a: package ~a not found"),
                 pkg_name, sym_name, pkg_name, nao);
        return nil;
      }
      sym = intern(sym_name, package);
    }
  } else {
    val sym_name = string(lexeme);
    scrub_scanner(parser->scanner, SYMTOK, tokfree);
    free(tokfree);
    sym = intern_fallback(sym_name, cur_package);
  }

  return leading_at ? rl(list(var_s, sym, nao), num(parser->lineno)) : sym;
}

static val expand_repeat_rep_args(val args)
{
  list_collect_decl (out, ptail);
  val exp_pair = nil, exp_pairs = nil;

  for (; args; args = cdr(args)) {
    val arg = car(args);

    if (consp(arg)) {
      if (exp_pairs) {
        list_collect_decl (iout, iptail);
        for (; arg; arg = cdr(arg)) {
          val iarg = car(arg);
          if (consp(iarg)) {
            val sym = first(iarg);
            iptail = list_collect(iptail, list(sym,
                                               expand(second(iarg), nil),
                                               nao));
            match_reg_var(sym);
          } else {
            iptail = list_collect(iptail, iarg);
            match_reg_var(iarg);
          }
        }
        ptail = list_collect(ptail, iout);
      } else if (exp_pair) {
        val sym = first(arg);
        ptail = list_collect(ptail, list(sym,
                                         expand(second(arg), nil),
                                         nao));
        match_reg_var(sym);
      } else {
        ptail = list_collect(ptail, arg);
      }
    } else if (!exp_pair && !exp_pairs) {
      if (arg == counter_k) {
        exp_pair = t;
        ptail = list_collect(ptail, arg);
        continue;
      } else if (arg == vars_k) {
        exp_pairs = t;
        ptail = list_collect(ptail, arg);
        continue;
      }
    } else if (exp_pair) {
      match_reg_var(arg);
    }

    exp_pair = exp_pairs = nil;
    ptail = list_collect(ptail, arg);
  }

  return out;
}

static val extract_vars(val output_spec)
{
  list_collect_decl (vars, tai);

  if (consp(output_spec)) {
    val sym = first(output_spec);
    if (sym == var_s) {
      val expr = second(output_spec);
      val modifiers = third(output_spec);

      if (bindable(expr)) {
        tai = list_collect(tai, expr);
      } else if (opt_compat && opt_compat <= 128) {
        tai = list_collect_nconc(tai, extract_vars(expr));
      } else {
        val frefs = expand_with_free_refs(expr, nil, nil);
        tai = list_collect_nconc(tai, second(frefs));
      }

      for (; modifiers; modifiers = cdr(modifiers)) {
        val mod = car(modifiers);
        if (bindable(mod)) {
          tai = list_collect(tai, mod);
        } else if (consp(mod)) {
          val msym = car(mod);

          if (msym == dwim_s) {
            val arg = second(mod);

            if (bindable(arg)) {
              tai = list_collect(tai, arg);
            } else if (consp(arg) && car(arg) == rcons_s) {
              val f = second(arg);
              val t = third(arg);
              if (bindable(f))
                tai = list_collect(tai, f);
              if (bindable(t))
                tai = list_collect(tai, t);
            }
          }
        }
      }
    } else if (sym == expr_s) {
      val expr = second(output_spec);
      val frefs = expand_with_free_refs(expr, nil, nil);
      tai = list_collect_nconc(tai, second(frefs));
    } else {
      for (; output_spec; output_spec = cdr(output_spec))
        tai = list_collect_nconc(tai, extract_vars(car(output_spec)));
    }
  }

  return vars;
}

static val repeat_rep_helper(val sym, val args, val main, val parts)
{
  uses_or2;
  val exp_args = expand_repeat_rep_args(args);
  val single_parts = nil, single_parts_p = nil;
  val first_parts = nil, first_parts_p = nil;
  val last_parts = nil, last_parts_p = nil;
  val empty_parts = nil, empty_parts_p = nil;
  val mod_parts = nil, mod_parts_p = nil;
  val modlast_parts = nil, modlast_parts_p = nil;
  val occur_vars = nil;
  val iter;

  for (iter = parts; iter != nil; iter = cdr(iter)) {
    val part = car(iter);
    val sym = car(part);
    val clauses = copy_list(cdr(part));

    if (sym == single_s) {
      single_parts = nappend2(single_parts, clauses);
      single_parts_p = t;
    } else if (sym == first_s) {
      first_parts = nappend2(first_parts, clauses);
      first_parts_p = t;
    } else if (sym == last_s) {
      last_parts = nappend2(last_parts, clauses);
      last_parts_p = t;
    } else if (sym == empty_s) {
      empty_parts = nappend2(empty_parts, clauses);
      empty_parts_p = t;
    } else if (sym == mod_s) {
      mod_parts = cons(clauses, mod_parts);
      mod_parts_p = t;
    } else if (sym == modlast_s) {
      modlast_parts = cons(clauses, modlast_parts);
      modlast_parts_p = t;
    } else {
      abort();
    }
  }

  single_parts = or2(single_parts, single_parts_p);
  first_parts = or2(first_parts, first_parts_p);
  last_parts = or2(last_parts, last_parts_p);
  empty_parts = or2(empty_parts, empty_parts_p);
  mod_parts = or2(nreverse(mod_parts), mod_parts_p);
  modlast_parts = or2(nreverse(modlast_parts), modlast_parts_p);

  occur_vars = extract_vars(main);
  occur_vars = nappend2(occur_vars, extract_vars(single_parts));
  occur_vars = nappend2(occur_vars, extract_vars(first_parts));
  occur_vars = nappend2(occur_vars, extract_vars(last_parts));
  occur_vars = nappend2(occur_vars, extract_vars(empty_parts));
  occur_vars = nappend2(occur_vars, extract_vars(mod_parts));
  occur_vars = uniq(occur_vars);

  return list(sym, exp_args, main, single_parts, first_parts,
              last_parts, empty_parts, nreverse(mod_parts),
              nreverse(modlast_parts), occur_vars, nao);
}

static void process_catch_exprs(val exprs)
{
  val params = second(exprs);
  for (; params; params = cdr(params)) {
    val param = first(params);
    if (consp(param))
      match_reg_var(car(param));
    else
      match_reg_var(param);
  }
}

static val define_transform(parser_t *parser, val define_form)
{
  scanner_t *scnr = parser->scanner;
  val sym = first(define_form);
  val args = second(define_form);

  if (define_form == nil)
    return nil;

  assert (sym == define_s);

  if (args == nil) {
    yyerr("define requires arguments");
    return define_form;
  }

  if (!consp(args) || !listp(cdr(args))) {
    yyerr("bad define argument syntax");
    return define_form;
  } else {
    val name = first(args);
    val params = second(args);

    if (!symbolp(name)) {
      yyerr("function name must be a symbol");
      return define_form;
    }

    if (!proper_list_p(params)) {
      yyerr("invalid function parameter list");
      return define_form;
    }

    if (!all_satisfy(params, func_n1(symbolp), nil))
      yyerr("function parameters must be symbols");
  }

  return define_form;
}

static val optimize_text(val text_form)
{
  if (all_satisfy(rest(text_form), func_n1(stringp), nil))
    return cat_str(rest(text_form), lit(""));
  return text_form;
}

val expand_meta(val form, val menv)
{
  val sym;

  if (atom(form))
    return form;

  menv = default_arg(menv, make_env(nil, nil, nil));

  if ((sym = car(form)) == quasi_s) {
    if (opt_compat && opt_compat <= 128) {
      list_collect_decl (out, ptail);

      for (; consp(form); form = cdr(form)) {
        val subform = car(form);
        if (consp(subform) && car(subform) == expr_s)
          ptail = list_collect(ptail, expand_meta(subform, menv));
        else
          ptail = list_collect(ptail, subform);
      }

      ptail = list_collect_nconc(ptail, form);

      return rlcp(out, form);
    }

    return expand(form, nil);
  }

  if ((sym = car(form)) == expr_s) {
    val exp_x = expand(second(form), menv);
    if (!bindable(exp_x))
      return rlcp(cons(sym, cons(exp_x, nil)), form);
    return rlcp(cons(var_s, cons(exp_x, nil)), form);
  }

  if (sym == var_s) {
    val var_x = expand(second(form), menv);
    if (!bindable(var_x))
      return rlcp(cons(expr_s, cons(var_x, nil)), form);
    return rlcp(cons(var_s, cons(var_x, nil)), form);
  }

  {
    list_collect_decl (out, ptail);

    for (; consp(form); form = cdr(form)) {
      loc nptail = list_collect(ptail, expand_meta(car(form), menv));
      rlcp(deref(ptail), form);
      ptail = nptail;
    }

    ptail = list_collect_nconc(ptail, form);

    return out;
  }
}

static val rlviable(val form)
{
  switch (type(form)) {
  case NIL:
  case LIT:
  case CHR:
  case NUM:
  case SYM:
  case BGNUM:
  case FLNUM:
    return nil;
  default:
    return t;
  }
}

val rlset(val form, val info)
{
  if (rlviable(form)) {
    loc place = gethash_l(lit("rlcp"), form_to_ln_hash, form, nulloc);
    if (nilp(deref(place)))
      set(place, info);
  }
  return form;
}

val rlrec(parser_t *parser, val form, val line)
{
  if (parser->rec_source_loc)
    rlset(form, cons(line, parser->name));
  return form;
}

val rlcp_parser(parser_t *parser, val to, val from)
{
  if (parser->rec_source_loc)
    rlset(to, source_loc(from));
  return to;
}

static val rlcp_tree_rec(val to, val from, struct circ_stack *up)
{
  val ret = to;

  while (consp(to)) {
    val a = car(to);
    struct circ_stack rlcs = { up, a };
    rlcp(to, from);
    if (!parser_callgraph_circ_check(up, a))
      break;
    rlcp_tree_rec(a, from, &rlcs);
    to = cdr(to);
    if (!parser_callgraph_circ_check(up, to))
      break;
  }
  return ret;
}


val rlcp_tree(val to, val from)
{
  return rlcp_tree_rec(to, from, 0);
}

static wchar_t char_from_name(const wchar_t *name)
{
  static struct {
    const wchar_t *name;
    const wchar_t ch;
  } map[] = {
    { L"nul", 0 },
    { L"alarm", L'\a' },
    { L"backspace", L'\b' },
    { L"tab", L'\t' },
    { L"linefeed", L'\n' },
    { L"newline", L'\n' },
    { L"vtab", L'\v' },
    { L"page", L'\f' },
    { L"return", L'\r' },
    { L"esc", 27 },
    { L"space", L' ' },
    { L"pnul", 0xDC00 },
    { 0, 0 },
  };
  int i;

  for (i = 0; map[i].name; i++) {
    if (wcscmp(map[i].name, name) == 0)
      return map[i].ch;
  }

  return L'!'; /* code meaning not found */
}

static val make_expr(parser_t *parser, val sym, val rest, val lineno)
{
  val expr = cons(sym, rest);
  val ret = cons(expr_s, cons(expand(expr, nil), nil));

  if (rest) {
    rlc(expr, rest);
    rlc(ret, rest);
  } else {
    rl(expr, lineno);
    rl(ret, lineno);
  }

  return ret;
}

static val check_parse_time_action(val spec_rev)
{
  val line = first(spec_rev);

  if (consp(line)) {
    val elem = first(line);
    if (consp(elem)) {
      val sym = car(elem);
      if (sym == include_s) {
        return nappend2(nreverse(include(line)), rest(spec_rev));
      }
      if (sym == in_package_s) {
        eval_intrinsic(elem, nil, nil);
        return nil;
      }
    }
  }
  return spec_rev;
}

static val uref_helper(parser_t *parser, val expr)
{
  if (consp(expr) && car(expr) == qref_s) {
    return rplaca(expr, uref_s);
  } else {
    return rl(rlc(list(uref_s, expr, nao), expr), num(parser->lineno));
  }
}

static val uoref_helper(parser_t *parser, val expr)
{
  val uref = uref_helper(parser, expr);
  rplacd(uref, cons(t, cdr(uref)));
  return uref;
}

static val qref_helper(parser_t *parser, val lexpr, val rexpr)
{
  uses_or2;

  if (consp(rexpr) && car(rexpr) == qref_s) {
    rplacd(rexpr, rlc(cons(lexpr, cdr(rexpr)), lexpr));
    return rl(rexpr, num(parser->lineno));
  } else {
    return rl(rlc(list(qref_s, lexpr, rexpr, nao),
                  or2(lexpr, rexpr)),
                  num(parser->lineno));
  }
}

static val fname_helper(parser_t *parser, val name)
{
  if (!name) {
    return nil;
  } else if (!bindable(name)) {
    yyerrorf(parser->scanner, lit("#T: ~s isn't a function name"),
             name, nao);
  } else if (!memq(name, tree_fun_whitelist)) {
    yyerrorf(parser->scanner, lit("#T: ~s not in *tree-fun-whitelist*"),
             name, nao);
  } else {
    val fbinding = lookup_fun(nil, name);
    if (fbinding)
      return cdr(fbinding);
    yyerrorf(parser->scanner, lit("#T: function named ~s doesn't exist"),
             name, nao);
  }

  return nil;
}

static val output_helper(parser_t *parser, val sym, val exprs, val clauses)
{
  cons_bind (dest, rest, exprs);

  val dest_ex = expand_form_ver(dest, 166);
  val args = if3(dest_ex == dest, exprs, cons(dest_ex, rest));
  val args_kw = keywordp(car(args));
  val alist = improper_plist_to_alist(if3(args_kw, args, cdr(args)),
                                      v_output_keys);

  if (!args_kw && sym == push_s)
  {
    yyerrorf(parser->scanner, lit("~s: doesn't support destination argument"),
             sym, nao);
  }


  while (alist) {
    val key = car(pop(&alist));

    if (key == filter_k)
      continue;

    if (sym != push_s) {
      if (key == nothrow_k || key == append_k ||
          key == named_k || key == continue_k ||
          key == finish_k || key == into_k)
      {
        continue;
      }
    }

    yyerrorf(parser->scanner, lit("~s: unsupported keyword ~s"),
             sym, key, nao);
  }

  if (sym != push_s) {
    val into_var = second(memql(into_k, args));
    val named_var = second(memql(named_k, args));
    match_reg_var(into_var);
    match_reg_var(named_var);
  }

  return list(sym, clauses, args, nao);
}

#ifndef YYEOF
#define YYEOF 0
#endif

void yybadtoken(parser_t *parser, int tok, val context)
{
  val problem = nil;
  scanner_t *scnr = parser->scanner;

  switch (tok) {
  case ERRTOK:
    return;
  case SPACE:   problem = lit("space"); break;
  case TEXT:    problem = lit("text"); break;
  case SYMTOK:  problem = lit("symbol-token"); break;
  case METANUM: problem = lit("metanum"); break;
  case ALL:     problem = lit("\"all\""); break;
  case SOME:    problem = lit("\"some\""); break;
  case NONE:    problem = lit("\"none\""); break;
  case MAYBE:   problem = lit("\"maybe\""); break;
  case CASES:   problem = lit("\"cases\""); break;
  case BLOCK:   problem = lit("\"block\""); break;
  case CHOOSE:  problem = lit("\"choose\""); break;
  case GATHER:  problem = lit("\"gather\""); break;
  case AND:     problem = lit("\"and\""); break;
  case OR:      problem = lit("\"or\""); break;
  case END:     problem = lit("\"end\""); break;
  case COLLECT: problem = lit("\"collect\""); break;
  case UNTIL:   problem = lit("\"until\""); break;
  case COLL:    problem = lit("\"coll\""); break;
  case OUTPUT:  problem = lit("\"output\""); break;
  case REPEAT:  problem = lit("\"repeat\""); break;
  case REP:     problem = lit("\"rep\""); break;
  case SINGLE:  problem = lit("\"single\""); break;
  case FIRST:   problem = lit("\"first\""); break;
  case LAST:    problem = lit("\"last\""); break;
  case EMPTY:   problem = lit("\"empty\""); break;
  case MOD:     problem = lit("\"mod\""); break;
  case MODLAST: problem = lit("\"modlast\""); break;
  case DEFINE:  problem = lit("\"define\""); break;
  case TRY:     problem = lit("\"try\""); break;
  case CATCH:   problem = lit("\"catch\""); break;
  case FINALLY: problem = lit("\"finally\""); break;
  case IF:      problem = lit("\"if\""); break;
  case ELIF:    problem = lit("\"elif\""); break;
  case ELSE:    problem = lit("\"else\""); break;
  case NUMBER:  problem = lit("number"); break;
  case JSKW:    problem = lit("JSON keyword"); break;
  case REGCHAR: problem = lit("regular expression character"); break;
  case REGTOKEN: problem = lit("regular expression token"); break;
  case LITCHAR: problem = lit("string literal character"); break;
  case SPLICE:  problem = lit("*"); break;
  case JSPLICE: problem = lit("~*"); break;
  case CONSDOT:
  case LAMBDOT: problem = lit("consing dot"); break;
  case DOTDOT: problem = lit(".."); break;
  case OLD_DOTDOT:     problem = lit(".."); break;
  case UREFDOT:        problem = lit("referencing dot"); break;
  case OREFDOT:
  case UOREFDOT:       problem = lit("referencing .?"); break;
  case HASH_BACKSLASH: problem = lit("#\\"); break;
  case HASH_SLASH:     problem = lit("#/"); break;
  case HASH_H:         problem = lit("#H"); break;
  case HASH_S:         problem = lit("#S"); break;
  case HASH_R:         problem = lit("#R"); break;
  case HASH_N:         problem = lit("#N"); break;
  case HASH_T:         problem = lit("#T"); break;
  case HASH_J:         problem = lit("#J"); break;
  case HASH_SEMI:      problem = lit("#;"); break;
  case HASH_N_EQUALS:  problem = lit("#<n>="); break;
  case HASH_N_HASH:    problem = lit("#<n>#"); break;
  case HASH_B_QUOTE:   problem = lit("#b'"); break;
  case WORDS:   problem = lit("#\""); break;
  case WSPLICE: problem = lit("#*\""); break;
  case QWORDS:         problem = lit("#`"); break;
  case QWSPLICE:       problem = lit("#*`"); break;
  case OLD_AT:         problem = lit("@"); break;
  }

  if (problem != 0)
    if (context)
      yyerrorf(scnr, lit("misplaced ~a in ~a"), problem, context, nao);
    else
      yyerrorf(scnr, lit("unexpected ~a"), problem, nao);
  else
    if (context) /* Byacc sets yychar to 0 */
      if (tok == YYEOF || tok == YYEMPTY)
        yyerrorf(scnr, lit("unterminated ~a"), context, nao);
      else if (tok == '\n')
        yyerrorf(scnr, lit("newline in ~a"), context, nao);
      else
        yyerrorf(scnr, lit("misplaced character ~a in ~a"), chr(tok), context, nao);
    else
      if (tok == YYEOF)
        yyerrorf(scnr, lit("unexpected end of input"), nao);
      else if (tok == YYEMPTY)
        return;
      else
        yyerrorf(scnr, lit("unexpected character ~a"), chr(tok), nao);
}

int parse_once(val self, val stream, val name)
{
  int res = 0;
#if CONFIG_DEBUG_SUPPORT
  unsigned dbg_state = debug_clear(opt_dbg_expansion ? 0 : DBG_ENABLE);
#endif
  val parser_obj = ensure_parser(stream, name);
  parser_t *parser = parser_get_impl(self, parser_obj);
  parser->rec_source_loc = 1;

  uw_catch_begin(cons(error_s, nil), esym, eobj);


  res = yyparse(parser->scanner, parser);

  parser_resolve_circ(parser);

  uw_catch(esym, eobj) {
    yyerrorf(parser->scanner, lit("error exception during parse"), nao);
    uw_throw(esym, eobj);
  }

  uw_unwind {
#if CONFIG_DEBUG_SUPPORT
    debug_set(dbg_state);
#endif
  }

  uw_catch_end;

  return res;
}

int parse(parser_t *parser, val name, enum prime_parser prim)
{
  int res = 0;
  cnum start_line = parser->lineno;

  parser->errors = 0;
  parser->eof = 0;
  parser->ignore = 0;
  parser->prepared_msg = nil;
  parser->circ_ref_hash = nil;
  parser->circ_count = 0;
  parser->syntax_tree = nil;
  parser->quasi_level = 0;

  prime_parser(parser, name, prim);

  uw_catch_begin(cons(error_s, nil), esym, eobj);

  res = yyparse(parser->scanner, parser);

  prime_parser_post(parser, prim);

  parser_resolve_circ(parser);

  uw_catch(esym, eobj) {
    yyerrorf(parser->scanner, lit("error exception during parse"), nao);
    uw_throw(esym, eobj);
  }

  uw_unwind;

  uw_catch_end;

  if (parser->errors && parser->syntax_tree == nil &&
      parser->lineno != start_line)
  {
    cnum curline = parser->lineno;
    parser->lineno = start_line;
    yyerrorf(parser->scanner,
             lit("while parsing expression starting on this line"), nao);
    parser->lineno = curline;
  }

  return res;
}

